/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainFactory.java,v 1.2 2008/04/13 20:29:19 urs Exp $
 */
package de.urszeidler.eclipse.callchain;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see de.urszeidler.eclipse.callchain.CallchainPackage
 * @generated
 */
public interface CallchainFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	CallchainFactory eINSTANCE = de.urszeidler.eclipse.callchain.impl.CallchainFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Model</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Model</em>'.
	 * @generated
	 */
	Model createModel();

	/**
	 * Returns a new object of class '<em>Atl Res</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Atl Res</em>'.
	 * @generated
	 */
	AtlRes createAtlRes();

	/**
	 * Returns a new object of class '<em>Call</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Call</em>'.
	 * @generated
	 */
	Call createCall();

	/**
	 * Returns a new object of class '<em>MM</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MM</em>'.
	 * @generated
	 */
	MM createMM();

	/**
	 * Returns a new object of class '<em>Calls</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Calls</em>'.
	 * @generated
	 */
	Calls createCalls();

	/**
	 * Returns a new object of class '<em>Atl Libary</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Atl Libary</em>'.
	 * @generated
	 */
	AtlLibary createAtlLibary();

	/**
	 * Returns a new object of class '<em>Model Alias</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Model Alias</em>'.
	 * @generated
	 */
	ModelAlias createModelAlias();

	/**
	 * Returns a new object of class '<em>Artifact</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Artifact</em>'.
	 * @generated
	 */
	Artifact createArtifact();

	/**
	 * Returns a new object of class '<em>MM Alias</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>MM Alias</em>'.
	 * @generated
	 */
	MMAlias createMMAlias();

	/**
	 * Returns a new object of class '<em>Comment</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Comment</em>'.
	 * @generated
	 */
	Comment createComment();

	/**
	 * Returns a new object of class '<em>Generic Generator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Generic Generator</em>'.
	 * @generated
	 */
	Generic_Generator createGeneric_Generator();

	/**
	 * Returns a new object of class '<em>Property</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Property</em>'.
	 * @generated
	 */
	Property createProperty();

	/**
	 * Returns a new object of class '<em>Predicate Switch</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Predicate Switch</em>'.
	 * @generated
	 */
	PredicateSwitch createPredicateSwitch();

	/**
	 * Returns a new object of class '<em>Transition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Transition</em>'.
	 * @generated
	 */
	Transition createTransition();

	/**
	 * Returns a new object of class '<em>Property Has Value</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Property Has Value</em>'.
	 * @generated
	 */
	PropertyHasValue createPropertyHasValue();

	/**
	 * Returns a new object of class '<em>Property Exist</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Property Exist</em>'.
	 * @generated
	 */
	PropertyExist createPropertyExist();

	/**
	 * Returns a new object of class '<em>Resource Exist Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Resource Exist Predicate</em>'.
	 * @generated
	 */
	ResourceExistPredicate createResourceExistPredicate();

	/**
	 * Returns a new object of class '<em>And Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>And Predicate</em>'.
	 * @generated
	 */
	AndPredicate createAndPredicate();

	/**
	 * Returns a new object of class '<em>Or Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Or Predicate</em>'.
	 * @generated
	 */
	OrPredicate createOrPredicate();

	/**
	 * Returns a new object of class '<em>Not Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Not Predicate</em>'.
	 * @generated
	 */
	NotPredicate createNotPredicate();

	/**
	 * Returns a new object of class '<em>Property Value Switch</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Property Value Switch</em>'.
	 * @generated
	 */
	PropertyValueSwitch createPropertyValueSwitch();

	/**
	 * Returns a new object of class '<em>External Callable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>External Callable</em>'.
	 * @generated
	 */
	ExternalCallable createExternalCallable();

	/**
	 * Returns a new object of class '<em>Stop Call</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Stop Call</em>'.
	 * @generated
	 */
	StopCall createStopCall();

	/**
	 * Returns a new object of class '<em>Boolean Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Boolean Predicate</em>'.
	 * @generated
	 */
	BooleanPredicate createBooleanPredicate();

	/**
	 * Returns a new object of class '<em>Property Mapper</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Property Mapper</em>'.
	 * @generated
	 */
	PropertyMapper createPropertyMapper();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	CallchainPackage getCallchainPackage();

} //CallchainFactory
