/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.urszeidler.eclipse.callchain;

import org.eclipse.emf.common.util.EList;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>External Callable</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.urszeidler.eclipse.callchain.ExternalCallable#getDelegatedCallable <em>Delegated Callable</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.ExternalCallable#getEnviorment <em>Enviorment</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.ExternalCallable#getMappers <em>Mappers</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getExternalCallable()
 * @model
 * @generated
 */
public interface ExternalCallable extends Callable, Documentable, Eavaluateable {
	/**
	 * Returns the value of the '<em><b>Delegated Callable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Delegated Callable</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Delegated Callable</em>' reference.
	 * @see #setDelegatedCallable(Callable)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getExternalCallable_DelegatedCallable()
	 * @model required="true"
	 * @generated
	 */
	Callable getDelegatedCallable();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.ExternalCallable#getDelegatedCallable <em>Delegated Callable</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Delegated Callable</em>' reference.
	 * @see #getDelegatedCallable()
	 * @generated
	 */
	void setDelegatedCallable(Callable value);

	/**
	 * Returns the value of the '<em><b>Enviorment</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.urszeidler.eclipse.callchain.Calls#getExternCallables <em>Extern Callables</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Enviorment</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Enviorment</em>' container reference.
	 * @see #setEnviorment(Calls)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getExternalCallable_Enviorment()
	 * @see de.urszeidler.eclipse.callchain.Calls#getExternCallables
	 * @model opposite="externCallables" transient="false"
	 * @generated
	 */
	Calls getEnviorment();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.ExternalCallable#getEnviorment <em>Enviorment</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Enviorment</em>' container reference.
	 * @see #getEnviorment()
	 * @generated
	 */
	void setEnviorment(Calls value);

	/**
	 * Returns the value of the '<em><b>Mappers</b></em>' containment reference list.
	 * The list contents are of type {@link de.urszeidler.eclipse.callchain.PropertyMapper}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mappers</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mappers</em>' containment reference list.
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getExternalCallable_Mappers()
	 * @model containment="true"
	 * @generated
	 */
	EList<PropertyMapper> getMappers();

} // ExternalCallable
