/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;

import de.urszeidler.eclipse.callchain.BooleanPredicate;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.parts.BooleanPredicatePropertiesEditionPart;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;


/**
 * @author Urs Zeidler
 * @generated
 */
public class BooleanPredicatePropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Default constructor
	 * @generated
	 */
	public BooleanPredicatePropertiesEditionComponent(PropertiesEditingContext editingContext, EObject booleanPredicate, String editing_mode) {
    super(editingContext, booleanPredicate, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.BooleanPredicate.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final BooleanPredicate booleanPredicate = (BooleanPredicate)elt;
      final BooleanPredicatePropertiesEditionPart basePart = (BooleanPredicatePropertiesEditionPart)editingPart;
      // init values
      if (isAccessible(CallchainViewsRepository.BooleanPredicate.Properties.value)) {
        basePart.setValue(booleanPredicate.isValue());
      }
      // init filters
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }




	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.BooleanPredicate.Properties.value) {
      return CallchainPackage.eINSTANCE.getBooleanPredicate_Value();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    BooleanPredicate booleanPredicate = (BooleanPredicate)semanticObject;
    if (CallchainViewsRepository.BooleanPredicate.Properties.value == event.getAffectedEditor()) {
      booleanPredicate.setValue((Boolean)event.getNewValue());
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			BooleanPredicatePropertiesEditionPart basePart = (BooleanPredicatePropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getBooleanPredicate_Value().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.BooleanPredicate.Properties.value))
				basePart.setValue((Boolean)msg.getNewValue());
			
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
	 * @generated
	 */
	public boolean isRequired(Object key, int kind) {
    return key == CallchainViewsRepository.BooleanPredicate.Properties.value;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
        if (CallchainViewsRepository.BooleanPredicate.Properties.value == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getBooleanPredicate_Value().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getBooleanPredicate_Value().getEAttributeType(), newValue);
        }
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
