/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.context.impl.EObjectPropertiesEditionContext;
import org.eclipse.emf.eef.runtime.context.impl.EReferencePropertiesEditionContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.filters.EObjectFilter;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.utils.EEFConverterUtil;
import org.eclipse.emf.eef.runtime.policies.PropertiesEditingPolicy;
import org.eclipse.emf.eef.runtime.policies.impl.CreateEditingPolicy;
import org.eclipse.emf.eef.runtime.providers.PropertiesEditingProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainFactory;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.Predicate;
import de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;


/**
 * @author Urs Zeidler
 * @generated
 */
public class CallPropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Settings for res EObjectFlatComboViewer
	 */
	private	EObjectFlatComboSettings resSettings;
	
	/**
	 * Settings for next EObjectFlatComboViewer
	 */
	private	EObjectFlatComboSettings nextSettings;
	
	/**
	 * Settings for in ReferencesTable
	 */
	private	ReferencesTableSettings inSettings;
	
	/**
	 * Settings for out ReferencesTable
	 */
	private	ReferencesTableSettings outSettings;
	
	/**
	 * Settings for artifact EObjectFlatComboViewer
	 */
	private	EObjectFlatComboSettings artifactSettings;
	
	/**
	 * Settings for libarys ReferencesTable
	 */
	private	ReferencesTableSettings libarysSettings;
	
	/**
   * Settings for predicate EObjectFlatComboViewer
   */
  private	EObjectFlatComboSettings predicateSettings;

  /**
	 * Default constructor
	 * @generated
	 */
	public CallPropertiesEditionComponent(PropertiesEditingContext editingContext, EObject call, String editing_mode) {
    super(editingContext, call, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.Call.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final Call call = (Call)elt;
      final CallPropertiesEditionPart basePart = (CallPropertiesEditionPart)editingPart;
      // init values
      if (call.getName() != null && isAccessible(CallchainViewsRepository.Call.Properties.name))
        basePart.setName(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), call.getName()));
      
      if (isAccessible(CallchainViewsRepository.Call.Properties.res)) {
        // init part
        resSettings = new EObjectFlatComboSettings(call, CallchainPackage.eINSTANCE.getCall_Res());
        basePart.initRes(resSettings);
        // set the button mode
        basePart.setResButtonMode(ButtonsModeEnum.BROWSE);
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.next)) {
        // init part
        nextSettings = new EObjectFlatComboSettings(call, CallchainPackage.eINSTANCE.getCallable_Next());
        basePart.initNext(nextSettings);
        // set the button mode
        basePart.setNextButtonMode(ButtonsModeEnum.BROWSE);
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.in)) {
        inSettings = new ReferencesTableSettings(call, CallchainPackage.eINSTANCE.getCall_In());
        basePart.initIn(inSettings);
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.out)) {
        outSettings = new ReferencesTableSettings(call, CallchainPackage.eINSTANCE.getCall_Out());
        basePart.initOut(outSettings);
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.artifact)) {
        // init part
        artifactSettings = new EObjectFlatComboSettings(call, CallchainPackage.eINSTANCE.getCall_Artifact());
        basePart.initArtifact(artifactSettings);
        // set the button mode
        basePart.setArtifactButtonMode(ButtonsModeEnum.BROWSE);
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.libarys)) {
        libarysSettings = new ReferencesTableSettings(call, CallchainPackage.eINSTANCE.getCall_Libarys());
        basePart.initLibarys(libarysSettings);
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.allowInterModelReferences)) {
        basePart.setAllowInterModelReferences(call.isAllowInterModelReferences());
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.continueAfterErrors)) {
        basePart.setContinueAfterErrors(call.isContinueAfterErrors());
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.showSummary)) {
        basePart.setShowSummary(call.isShowSummary());
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.printExecutionTime)) {
        basePart.setPrintExecutionTime(call.isPrintExecutionTime());
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.disableAttributeHelperCache)) {
        basePart.setDisableAttributeHelperCache(call.isDisableAttributeHelperCache());
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.profile)) {
        basePart.setProfile(call.isProfile());
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.refreshWorkspace)) {
        basePart.setRefreshWorkspace(call.isRefreshWorkspace());
      }
      if (isAccessible(CallchainViewsRepository.Call.Properties.predicate)) {
        // init part
        predicateSettings = new EObjectFlatComboSettings(call, CallchainPackage.eINSTANCE.getEavaluateable_Predicate());
        basePart.initPredicate(predicateSettings);
        // set the button mode
        basePart.setPredicateButtonMode(ButtonsModeEnum.CREATE);
      }
      // init filters
      
      basePart.addFilterToRes(new ViewerFilter() {
      
      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
       */
      public boolean select(Viewer viewer, Object parentElement, Object element) {
        return (element instanceof AtlRes);
        }
      
      });
      
      basePart.addFilterToNext(new ViewerFilter() {
      
      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
       */
      public boolean select(Viewer viewer, Object parentElement, Object element) {
        return (element instanceof String && element.equals("")) || (element instanceof Callable); //$NON-NLS-1$ 
        }
      
      });
      
      basePart.addFilterToIn(new ViewerFilter() {
      
        /**
         * {@inheritDoc}
         * 
         * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
         */
        public boolean select(Viewer viewer, Object parentElement, Object element) {
          if (element instanceof EObject)
            return (!basePart.isContainedInInTable((EObject)element));
          return element instanceof Resource;
        }
      
      });
      basePart.addFilterToIn(new EObjectFilter(CallchainPackage.eINSTANCE.getModel()));
      
      basePart.addFilterToOut(new ViewerFilter() {
      
        /**
         * {@inheritDoc}
         * 
         * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
         */
        public boolean select(Viewer viewer, Object parentElement, Object element) {
          if (element instanceof EObject)
            return (!basePart.isContainedInOutTable((EObject)element));
          return element instanceof Resource;
        }
      
      });
      basePart.addFilterToOut(new EObjectFilter(CallchainPackage.eINSTANCE.getModel()));
      
      basePart.addFilterToArtifact(new ViewerFilter() {
      
      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
       */
      public boolean select(Viewer viewer, Object parentElement, Object element) {
        return (element instanceof String && element.equals("")) || (element instanceof Artifact); //$NON-NLS-1$ 
        }
      
      });
      
      basePart.addFilterToLibarys(new ViewerFilter() {
      
        /**
         * {@inheritDoc}
         * 
         * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
         */
        public boolean select(Viewer viewer, Object parentElement, Object element) {
          if (element instanceof EObject)
            return (!basePart.isContainedInLibarysTable((EObject)element));
          return element instanceof Resource;
        }
      
      });
      basePart.addFilterToLibarys(new EObjectFilter(CallchainPackage.eINSTANCE.getAtlLibary()));
      
      
      
      
      
      
      
      
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }
















	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.Call.Properties.name) {
      return CallchainPackage.eINSTANCE.getCallable_Name();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.res) {
      return CallchainPackage.eINSTANCE.getCall_Res();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.next) {
      return CallchainPackage.eINSTANCE.getCallable_Next();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.in) {
      return CallchainPackage.eINSTANCE.getCall_In();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.out) {
      return CallchainPackage.eINSTANCE.getCall_Out();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.artifact) {
      return CallchainPackage.eINSTANCE.getCall_Artifact();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.libarys) {
      return CallchainPackage.eINSTANCE.getCall_Libarys();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.allowInterModelReferences) {
      return CallchainPackage.eINSTANCE.getCall_AllowInterModelReferences();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.continueAfterErrors) {
      return CallchainPackage.eINSTANCE.getCall_ContinueAfterErrors();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.showSummary) {
      return CallchainPackage.eINSTANCE.getCall_ShowSummary();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.printExecutionTime) {
      return CallchainPackage.eINSTANCE.getCall_PrintExecutionTime();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.disableAttributeHelperCache) {
      return CallchainPackage.eINSTANCE.getCall_DisableAttributeHelperCache();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.profile) {
      return CallchainPackage.eINSTANCE.getCall_Profile();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.refreshWorkspace) {
      return CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace();
    }
    if (editorKey == CallchainViewsRepository.Call.Properties.predicate) {
      return CallchainPackage.eINSTANCE.getEavaluateable_Predicate();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    Call call = (Call)semanticObject;
    if (CallchainViewsRepository.Call.Properties.name == event.getAffectedEditor()) {
      call.setName((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.Call.Properties.res == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.SET) {
        resSettings.setToReference((AtlRes)event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.ADD) {
        AtlRes eObject = CallchainFactory.eINSTANCE.createAtlRes();
        EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(editingContext, this, eObject, editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(eObject, PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy policy = provider.getPolicy(context);
          if (policy != null) {
            policy.execute();
          }
        }
        resSettings.setToReference(eObject);
      }
    }
    if (CallchainViewsRepository.Call.Properties.next == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.SET) {
        nextSettings.setToReference((Callable)event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.ADD) {
        EReferencePropertiesEditionContext context = new EReferencePropertiesEditionContext(editingContext, this, nextSettings, editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(semanticObject, PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy policy = provider.getPolicy(context);
          if (policy instanceof CreateEditingPolicy) {
            policy.execute();
          }
        }
      }
    }
    if (CallchainViewsRepository.Call.Properties.in == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.ADD) {
        if (event.getNewValue() instanceof Model) {
          inSettings.addToReference((EObject) event.getNewValue());
        }
      } else if (event.getKind() == PropertiesEditionEvent.REMOVE) {
        inSettings.removeFromReference((EObject) event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.MOVE) {
        inSettings.move(event.getNewIndex(), (Model) event.getNewValue());
      }
    }
    if (CallchainViewsRepository.Call.Properties.out == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.ADD) {
        if (event.getNewValue() instanceof Model) {
          outSettings.addToReference((EObject) event.getNewValue());
        }
      } else if (event.getKind() == PropertiesEditionEvent.REMOVE) {
        outSettings.removeFromReference((EObject) event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.MOVE) {
        outSettings.move(event.getNewIndex(), (Model) event.getNewValue());
      }
    }
    if (CallchainViewsRepository.Call.Properties.artifact == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.SET) {
        artifactSettings.setToReference((Artifact)event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.ADD) {
        Artifact eObject = CallchainFactory.eINSTANCE.createArtifact();
        EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(editingContext, this, eObject, editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(eObject, PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy policy = provider.getPolicy(context);
          if (policy != null) {
            policy.execute();
          }
        }
        artifactSettings.setToReference(eObject);
      }
    }
    if (CallchainViewsRepository.Call.Properties.libarys == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.ADD) {
        if (event.getNewValue() instanceof AtlLibary) {
          libarysSettings.addToReference((EObject) event.getNewValue());
        }
      } else if (event.getKind() == PropertiesEditionEvent.REMOVE) {
        libarysSettings.removeFromReference((EObject) event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.MOVE) {
        libarysSettings.move(event.getNewIndex(), (AtlLibary) event.getNewValue());
      }
    }
    if (CallchainViewsRepository.Call.Properties.allowInterModelReferences == event.getAffectedEditor()) {
      call.setAllowInterModelReferences((Boolean)event.getNewValue());
    }
    if (CallchainViewsRepository.Call.Properties.continueAfterErrors == event.getAffectedEditor()) {
      call.setContinueAfterErrors((Boolean)event.getNewValue());
    }
    if (CallchainViewsRepository.Call.Properties.showSummary == event.getAffectedEditor()) {
      call.setShowSummary((Boolean)event.getNewValue());
    }
    if (CallchainViewsRepository.Call.Properties.printExecutionTime == event.getAffectedEditor()) {
      call.setPrintExecutionTime((Boolean)event.getNewValue());
    }
    if (CallchainViewsRepository.Call.Properties.disableAttributeHelperCache == event.getAffectedEditor()) {
      call.setDisableAttributeHelperCache((Boolean)event.getNewValue());
    }
    if (CallchainViewsRepository.Call.Properties.profile == event.getAffectedEditor()) {
      call.setProfile((Boolean)event.getNewValue());
    }
    if (CallchainViewsRepository.Call.Properties.refreshWorkspace == event.getAffectedEditor()) {
      call.setRefreshWorkspace((Boolean)event.getNewValue());
    }
    if (CallchainViewsRepository.Call.Properties.predicate == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.SET) {
        predicateSettings.setToReference((Predicate)event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.ADD) {
        EReferencePropertiesEditionContext context = new EReferencePropertiesEditionContext(editingContext, this, predicateSettings, editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(semanticObject, PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy policy = provider.getPolicy(context);
          if (policy instanceof CreateEditingPolicy) {
            policy.execute();
          }
        }
      }
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			CallPropertiesEditionPart basePart = (CallPropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getCallable_Name().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Call.Properties.name)) {
				if (msg.getNewValue() != null) {
					basePart.setName(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setName("");
				}
			}
			if (CallchainPackage.eINSTANCE.getCall_Res().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Call.Properties.res))
				basePart.setRes((EObject)msg.getNewValue());
			if (CallchainPackage.eINSTANCE.getCallable_Next().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Call.Properties.next))
				basePart.setNext((EObject)msg.getNewValue());
			if (CallchainPackage.eINSTANCE.getCall_In().equals(msg.getFeature())  && isAccessible(CallchainViewsRepository.Call.Properties.in))
				basePart.updateIn();
			if (CallchainPackage.eINSTANCE.getCall_Out().equals(msg.getFeature())  && isAccessible(CallchainViewsRepository.Call.Properties.out))
				basePart.updateOut();
			if (CallchainPackage.eINSTANCE.getCall_Artifact().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Call.Properties.artifact))
				basePart.setArtifact((EObject)msg.getNewValue());
			if (CallchainPackage.eINSTANCE.getCall_Libarys().equals(msg.getFeature())  && isAccessible(CallchainViewsRepository.Call.Properties.libarys))
				basePart.updateLibarys();
			if (CallchainPackage.eINSTANCE.getCall_AllowInterModelReferences().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Call.Properties.allowInterModelReferences))
				basePart.setAllowInterModelReferences((Boolean)msg.getNewValue());
			
			if (CallchainPackage.eINSTANCE.getCall_ContinueAfterErrors().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Call.Properties.continueAfterErrors))
				basePart.setContinueAfterErrors((Boolean)msg.getNewValue());
			
			if (CallchainPackage.eINSTANCE.getCall_ShowSummary().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Call.Properties.showSummary))
				basePart.setShowSummary((Boolean)msg.getNewValue());
			
			if (CallchainPackage.eINSTANCE.getCall_PrintExecutionTime().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Call.Properties.printExecutionTime))
				basePart.setPrintExecutionTime((Boolean)msg.getNewValue());
			
			if (CallchainPackage.eINSTANCE.getCall_DisableAttributeHelperCache().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Call.Properties.disableAttributeHelperCache))
				basePart.setDisableAttributeHelperCache((Boolean)msg.getNewValue());
			
			if (CallchainPackage.eINSTANCE.getCall_Profile().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Call.Properties.profile))
				basePart.setProfile((Boolean)msg.getNewValue());
			
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
	 * @generated
	 */
	public boolean isRequired(Object key, int kind) {
    return key == CallchainViewsRepository.Call.Properties.res || key == CallchainViewsRepository.Call.Properties.refreshWorkspace;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
        if (CallchainViewsRepository.Call.Properties.name == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCallable_Name().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCallable_Name().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Call.Properties.allowInterModelReferences == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCall_AllowInterModelReferences().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCall_AllowInterModelReferences().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Call.Properties.continueAfterErrors == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCall_ContinueAfterErrors().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCall_ContinueAfterErrors().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Call.Properties.showSummary == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCall_ShowSummary().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCall_ShowSummary().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Call.Properties.printExecutionTime == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCall_PrintExecutionTime().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCall_PrintExecutionTime().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Call.Properties.disableAttributeHelperCache == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCall_DisableAttributeHelperCache().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCall_DisableAttributeHelperCache().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Call.Properties.profile == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCall_Profile().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCall_Profile().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Call.Properties.refreshWorkspace == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace().getEAttributeType(), newValue);
        }
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
