/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.context.impl.EObjectPropertiesEditionContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.utils.EEFConverterUtil;
import org.eclipse.emf.eef.runtime.policies.PropertiesEditingPolicy;
import org.eclipse.emf.eef.runtime.providers.PropertiesEditingProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import de.urszeidler.eclipse.callchain.CallchainFactory;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.MM;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart;


/**
 * @author Urs Zeidler
 * @generated
 */
public class ModelPropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Settings for mm EObjectFlatComboViewer
	 */
	private	EObjectFlatComboSettings mmSettings;
	
	/**
	 * Default constructor
	 * @generated
	 */
	public ModelPropertiesEditionComponent(PropertiesEditingContext editingContext, EObject model, String editing_mode) {
    super(editingContext, model, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.Model.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final Model model = (Model)elt;
      final ModelPropertiesEditionPart basePart = (ModelPropertiesEditionPart)editingPart;
      // init values
      if (model.getName() != null && isAccessible(CallchainViewsRepository.Model.Properties.name))
        basePart.setName(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), model.getName()));
      
        if (model.getUri() != null && isAccessible(CallchainViewsRepository.Model.Properties.uri)) {
          basePart.setUri(EEFConverterUtil.convertToString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), model.getUri()));
        }
      
      if (isAccessible(CallchainViewsRepository.Model.Properties.mm)) {
        // init part
        mmSettings = new EObjectFlatComboSettings(model, CallchainPackage.eINSTANCE.getModel_Mm());
        basePart.initMm(mmSettings);
        // set the button mode
        basePart.setMmButtonMode(ButtonsModeEnum.BROWSE);
      }
      if (isAccessible(CallchainViewsRepository.Model.Properties.derived)) {
        basePart.setDerived(model.isDerived());
      }
      if (isAccessible(CallchainViewsRepository.Model.Properties.isTemporary)) {
        basePart.setIsTemporary(model.isIsTemporary());
      }
      // init filters
      
      
      basePart.addFilterToMm(new ViewerFilter() {
      
      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
       */
      public boolean select(Viewer viewer, Object parentElement, Object element) {
        return (element instanceof MM);
        }
      
      });
      
      
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }








	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.Model.Properties.name) {
      return CallchainPackage.eINSTANCE.getArtifact_Name();
    }
    if (editorKey == CallchainViewsRepository.Model.Properties.uri) {
      return CallchainPackage.eINSTANCE.getArtifact_Uri();
    }
    if (editorKey == CallchainViewsRepository.Model.Properties.mm) {
      return CallchainPackage.eINSTANCE.getModel_Mm();
    }
    if (editorKey == CallchainViewsRepository.Model.Properties.derived) {
      return CallchainPackage.eINSTANCE.getArtifact_Derived();
    }
    if (editorKey == CallchainViewsRepository.Model.Properties.isTemporary) {
      return CallchainPackage.eINSTANCE.getModel_IsTemporary();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    Model model = (Model)semanticObject;
    if (CallchainViewsRepository.Model.Properties.name == event.getAffectedEditor()) {
      model.setName((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.Model.Properties.uri == event.getAffectedEditor()) {
      model.setUri((String)event.getNewValue());
    }
    if (CallchainViewsRepository.Model.Properties.mm == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.SET) {
        mmSettings.setToReference((MM)event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.ADD) {
        MM eObject = CallchainFactory.eINSTANCE.createMM();
        EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(editingContext, this, eObject, editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(eObject, PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy policy = provider.getPolicy(context);
          if (policy != null) {
            policy.execute();
          }
        }
        mmSettings.setToReference(eObject);
      }
    }
    if (CallchainViewsRepository.Model.Properties.derived == event.getAffectedEditor()) {
      model.setDerived((Boolean)event.getNewValue());
    }
    if (CallchainViewsRepository.Model.Properties.isTemporary == event.getAffectedEditor()) {
      model.setIsTemporary((Boolean)event.getNewValue());
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			ModelPropertiesEditionPart basePart = (ModelPropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getArtifact_Name().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Model.Properties.name)) {
				if (msg.getNewValue() != null) {
					basePart.setName(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setName("");
				}
			}
			if (CallchainPackage.eINSTANCE.getArtifact_Uri().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Model.Properties.uri)) {
				if (msg.getNewValue() != null) {
					basePart.setUri(EcoreUtil.convertToString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), msg.getNewValue()));
				} else {
					basePart.setUri("");
				}
			}
			if (CallchainPackage.eINSTANCE.getModel_Mm().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Model.Properties.mm))
				basePart.setMm((EObject)msg.getNewValue());
			if (CallchainPackage.eINSTANCE.getArtifact_Derived().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Model.Properties.derived))
				basePart.setDerived((Boolean)msg.getNewValue());
			
			if (CallchainPackage.eINSTANCE.getModel_IsTemporary().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Model.Properties.isTemporary))
				basePart.setIsTemporary((Boolean)msg.getNewValue());
			
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
	 * @generated
	 */
	public boolean isRequired(Object key, int kind) {
    return key == CallchainViewsRepository.Model.Properties.name || key == CallchainViewsRepository.Model.Properties.uri || key == CallchainViewsRepository.Model.Properties.mm || key == CallchainViewsRepository.Model.Properties.derived;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
        if (CallchainViewsRepository.Model.Properties.name == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getArtifact_Name().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getArtifact_Name().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Model.Properties.uri == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Model.Properties.derived == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getArtifact_Derived().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getArtifact_Derived().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Model.Properties.isTemporary == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getModel_IsTemporary().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getModel_IsTemporary().getEAttributeType(), newValue);
        }
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
