/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.context.impl.EObjectPropertiesEditionContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.policies.PropertiesEditingPolicy;
import org.eclipse.emf.eef.runtime.providers.PropertiesEditingProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import de.urszeidler.eclipse.callchain.CallchainFactory;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Property;
import de.urszeidler.eclipse.callchain.PropertyMapper;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart;


/**
 * @author Urs Zeidler
 * @generated
 */
public class PropertyMapperPropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Settings for input EObjectFlatComboViewer
	 */
	private	EObjectFlatComboSettings inputSettings;
	
	/**
	 * Settings for output EObjectFlatComboViewer
	 */
	private	EObjectFlatComboSettings outputSettings;
	
	
	/**
	 * Default constructor
	 * @generated
	 */
	public PropertyMapperPropertiesEditionComponent(PropertiesEditingContext editingContext, EObject propertyMapper, String editing_mode) {
		super(editingContext, propertyMapper, editing_mode);
		parts = new String[] { BASE_PART };
		repositoryKey = CallchainViewsRepository.class;
		partKey = CallchainViewsRepository.PropertyMapper.class;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
		setInitializing(true);
		if (editingPart != null && key == partKey) {
			editingPart.setContext(elt, allResource);
			final PropertyMapper propertyMapper = (PropertyMapper)elt;
			final PropertyMapperPropertiesEditionPart basePart = (PropertyMapperPropertiesEditionPart)editingPart;
			// init values
			if (isAccessible(CallchainViewsRepository.PropertyMapper.Properties.input)) {
				// init part
				inputSettings = new EObjectFlatComboSettings(propertyMapper, CallchainPackage.eINSTANCE.getPropertyMapper_Input());
				basePart.initInput(inputSettings);
				// set the button mode
				basePart.setInputButtonMode(ButtonsModeEnum.BROWSE);
			}
			if (isAccessible(CallchainViewsRepository.PropertyMapper.Properties.output)) {
				// init part
				outputSettings = new EObjectFlatComboSettings(propertyMapper, CallchainPackage.eINSTANCE.getPropertyMapper_Output());
				basePart.initOutput(outputSettings);
				// set the button mode
				basePart.setOutputButtonMode(ButtonsModeEnum.BROWSE);
			}
			// init filters
			basePart.addFilterToInput(new ViewerFilter() {
			
			/**
			 * {@inheritDoc}
			 * 
			 * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
			 */
			public boolean select(Viewer viewer, Object parentElement, Object element) {
				return (element instanceof Property);
				}
			
			});
			
			basePart.addFilterToOutput(new ViewerFilter() {
			
			/**
			 * {@inheritDoc}
			 * 
			 * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
			 */
			public boolean select(Viewer viewer, Object parentElement, Object element) {
				return (element instanceof Property);
				}
			
			});
			
			// init values for referenced views
			
			// init filters for referenced views
			
		}
		setInitializing(false);
	}





	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
	 */
	public EStructuralFeature associatedFeature(Object editorKey) {
		if (editorKey == CallchainViewsRepository.PropertyMapper.Properties.input) {
			return CallchainPackage.eINSTANCE.getPropertyMapper_Input();
		}
		if (editorKey == CallchainViewsRepository.PropertyMapper.Properties.output) {
			return CallchainPackage.eINSTANCE.getPropertyMapper_Output();
		}
		return super.associatedFeature(editorKey);
	}

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
		PropertyMapper propertyMapper = (PropertyMapper)semanticObject;
		if (CallchainViewsRepository.PropertyMapper.Properties.input == event.getAffectedEditor()) {
			if (event.getKind() == PropertiesEditionEvent.SET) {
				inputSettings.setToReference((Property)event.getNewValue());
			} else if (event.getKind() == PropertiesEditionEvent.ADD) {
				Property eObject = CallchainFactory.eINSTANCE.createProperty();
				EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(editingContext, this, eObject, editingContext.getAdapterFactory());
				PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(eObject, PropertiesEditingProvider.class);
				if (provider != null) {
					PropertiesEditingPolicy policy = provider.getPolicy(context);
					if (policy != null) {
						policy.execute();
					}
				}
				inputSettings.setToReference(eObject);
			}
		}
		if (CallchainViewsRepository.PropertyMapper.Properties.output == event.getAffectedEditor()) {
			if (event.getKind() == PropertiesEditionEvent.SET) {
				outputSettings.setToReference((Property)event.getNewValue());
			} else if (event.getKind() == PropertiesEditionEvent.ADD) {
				Property eObject = CallchainFactory.eINSTANCE.createProperty();
				EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(editingContext, this, eObject, editingContext.getAdapterFactory());
				PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(eObject, PropertiesEditingProvider.class);
				if (provider != null) {
					PropertiesEditingPolicy policy = provider.getPolicy(context);
					if (policy != null) {
						policy.execute();
					}
				}
				outputSettings.setToReference(eObject);
			}
		}
	}

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			PropertyMapperPropertiesEditionPart basePart = (PropertyMapperPropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getPropertyMapper_Input().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.PropertyMapper.Properties.input))
				basePart.setInput((EObject)msg.getNewValue());
			if (CallchainPackage.eINSTANCE.getPropertyMapper_Output().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.PropertyMapper.Properties.output))
				basePart.setOutput((EObject)msg.getNewValue());
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
	 * @generated
	 */
	public boolean isRequired(Object key, int kind) {
		return key == CallchainViewsRepository.PropertyMapper.Properties.input || key == CallchainViewsRepository.PropertyMapper.Properties.output;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
		Diagnostic ret = Diagnostic.OK_INSTANCE;
		if (event.getNewValue() != null) {
			try {
			} catch (IllegalArgumentException iae) {
				ret = BasicDiagnostic.toDiagnostic(iae);
			} catch (WrappedException we) {
				ret = BasicDiagnostic.toDiagnostic(we);
			}
		}
		return ret;
	}

}
