package de.urszeidler.eclipse.callchain.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import de.urszeidler.eclipse.callchain.diagram.edit.policies.CallItemSemanticEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class CallEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2017;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public CallEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new CallItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new CallFigure();
	}

	/**
	 * @generated
	 */
	public CallFigure getPrimaryShape() {
		return (CallFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof CallNameEditPart) {
			((CallNameEditPart) childEditPart).setLabel(getPrimaryShape().getFigureCallnameFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof CallNameEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(150, 50);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	protected java.util.List getModelSourceConnections() {
		View v = (View) getModel();
		v.getSourceEdges();
		List list = super.getModelSourceConnections();
		ArrayList<Object> arrayList = new ArrayList<Object>();
		for (Object object : list) {
			if (object instanceof Edge) {
				Edge e = (Edge) object;
				if (!e.getTarget().getType().equals("" + ModelAliasEditPart.VISUAL_ID))
					arrayList.add(e);
			}
		}
		return arrayList;
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(CallchainVisualIDRegistry.getType(CallNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(7);
		types.add(CallchainElementTypes.ModelAlias_4016);
		types.add(CallchainElementTypes.CallIn_4020);
		types.add(CallchainElementTypes.CallOut_4021);
		types.add(CallchainElementTypes.CallRes_4022);
		types.add(CallchainElementTypes.CallLibarys_4023);
		types.add(CallchainElementTypes.CallArtifact_4024);
		types.add(CallchainElementTypes.CallableNext_4028);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof ModelEditPart) {
			types.add(CallchainElementTypes.ModelAlias_4016);
		}
		if (targetEditPart instanceof ModelEditPart) {
			types.add(CallchainElementTypes.CallIn_4020);
		}
		if (targetEditPart instanceof ModelEditPart) {
			types.add(CallchainElementTypes.CallOut_4021);
		}
		if (targetEditPart instanceof AtlResEditPart) {
			types.add(CallchainElementTypes.CallRes_4022);
		}
		if (targetEditPart instanceof AtlLibaryEditPart) {
			types.add(CallchainElementTypes.CallLibarys_4023);
		}
		if (targetEditPart instanceof MMEditPart) {
			types.add(CallchainElementTypes.CallArtifact_4024);
		}
		if (targetEditPart instanceof ModelEditPart) {
			types.add(CallchainElementTypes.CallArtifact_4024);
		}
		if (targetEditPart instanceof AtlLibaryEditPart) {
			types.add(CallchainElementTypes.CallArtifact_4024);
		}
		if (targetEditPart instanceof AtlResEditPart) {
			types.add(CallchainElementTypes.CallArtifact_4024);
		}
		if (targetEditPart instanceof ArtifactEditPart) {
			types.add(CallchainElementTypes.CallArtifact_4024);
		}
		if (targetEditPart instanceof PredicateSwitchEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof ExternalCallableEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof de.urszeidler.eclipse.callchain.diagram.edit.parts.CallEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof Generic_GeneratorEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof PropertyValueSwitchEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof StopCallEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == CallchainElementTypes.ModelAlias_4016) {
			types.add(CallchainElementTypes.Model_2015);
		} else if (relationshipType == CallchainElementTypes.CallIn_4020) {
			types.add(CallchainElementTypes.Model_2015);
		} else if (relationshipType == CallchainElementTypes.CallOut_4021) {
			types.add(CallchainElementTypes.Model_2015);
		} else if (relationshipType == CallchainElementTypes.CallRes_4022) {
			types.add(CallchainElementTypes.AtlRes_2016);
		} else if (relationshipType == CallchainElementTypes.CallLibarys_4023) {
			types.add(CallchainElementTypes.AtlLibary_2019);
		} else if (relationshipType == CallchainElementTypes.CallArtifact_4024) {
			types.add(CallchainElementTypes.MM_2018);
			types.add(CallchainElementTypes.Model_2015);
			types.add(CallchainElementTypes.AtlLibary_2019);
			types.add(CallchainElementTypes.AtlRes_2016);
			types.add(CallchainElementTypes.Artifact_2020);
		} else if (relationshipType == CallchainElementTypes.CallableNext_4028) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
			types.add(CallchainElementTypes.ExternalCallable_2029);
			types.add(CallchainElementTypes.Call_2017);
			types.add(CallchainElementTypes.Generic_Generator_2027);
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
			types.add(CallchainElementTypes.StopCall_2031);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(6);
		types.add(CallchainElementTypes.Transition_4029);
		types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		types.add(CallchainElementTypes.PredicateSwitchTrueCallable_4030);
		types.add(CallchainElementTypes.PredicateSwitchFalseCallable_4031);
		types.add(CallchainElementTypes.CallableNext_4028);
		types.add(CallchainElementTypes.NamedSwitchDefaultCall_4032);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == CallchainElementTypes.Transition_4029) {
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
		} else if (relationshipType == CallchainElementTypes.CommentDocumentedElement_4025) {
			types.add(CallchainElementTypes.Comment_2024);
		} else if (relationshipType == CallchainElementTypes.PredicateSwitchTrueCallable_4030) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
		} else if (relationshipType == CallchainElementTypes.PredicateSwitchFalseCallable_4031) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
		} else if (relationshipType == CallchainElementTypes.CallableNext_4028) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
			types.add(CallchainElementTypes.ExternalCallable_2029);
			types.add(CallchainElementTypes.Call_2017);
			types.add(CallchainElementTypes.Generic_Generator_2027);
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
			types.add(CallchainElementTypes.StopCall_2031);
		} else if (relationshipType == CallchainElementTypes.NamedSwitchDefaultCall_4032) {
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class CallFigure extends RoundedRectangle {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureCallnameFigure;

		/**
		 * @generated
		 */
		public CallFigure() {

			BorderLayout layoutThis = new BorderLayout();
			this.setLayoutManager(layoutThis);

			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(30), getMapMode().DPtoLP(30)));
			this.setForegroundColor(THIS_FORE);
			this.setBackgroundColor(ColorConstants.white);

			this.setFont(THIS_FONT);

			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(150), getMapMode().DPtoLP(50)));
			createContents();
		}

		/**
		 * @generated not
		 */
		private void createContents() {

			fFigureCallnameFigure = new WrappingLabel();
			fFigureCallnameFigure.setText("[null]");
			fFigureCallnameFigure.setAlignment(PositionConstants.CENTER);
			fFigureCallnameFigure.setTextJustification(WrappingLabel.CENTER);
			fFigureCallnameFigure.setForegroundColor(FFIGURECALLNAMEFIGURE_FORE);

			this.add(fFigureCallnameFigure, BorderLayout.CENTER);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureCallnameFigure() {
			return fFigureCallnameFigure;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_FORE = new Color(null, 128, 128, 0);

	/**
	 * @generated
	 */
	static final Font THIS_FONT = new Font(Display.getCurrent(),
			Display.getDefault().getSystemFont().getFontData()[0].getName(), 11, SWT.NORMAL);

	/**
	 * @generated
	 */
	static final Color FFIGURECALLNAMEFIGURE_FORE = new Color(null, 128, 128, 0);

}
