package de.urszeidler.eclipse.callchain.diagram.edit.parts;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;

import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;

/**
 * @generated
 */
public class CallchainEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (CallchainVisualIDRegistry.getVisualID(view)) {

			case CallsEditPart.VISUAL_ID:
				return new CallsEditPart(view);

			case PredicateSwitchEditPart.VISUAL_ID:
				return new PredicateSwitchEditPart(view);

			case PredicateSwitchNameEditPart.VISUAL_ID:
				return new PredicateSwitchNameEditPart(view);

			case MMEditPart.VISUAL_ID:
				return new MMEditPart(view);

			case MMNameEditPart.VISUAL_ID:
				return new MMNameEditPart(view);

			case MMUriEditPart.VISUAL_ID:
				return new MMUriEditPart(view);

			case MMHandlerEditPart.VISUAL_ID:
				return new MMHandlerEditPart(view);

			case ModelEditPart.VISUAL_ID:
				return new ModelEditPart(view);

			case ModelNameEditPart.VISUAL_ID:
				return new ModelNameEditPart(view);

			case ModelUriEditPart.VISUAL_ID:
				return new ModelUriEditPart(view);

			case AtlLibaryEditPart.VISUAL_ID:
				return new AtlLibaryEditPart(view);

			case AtlLibaryNameEditPart.VISUAL_ID:
				return new AtlLibaryNameEditPart(view);

			case AtlLibaryUriEditPart.VISUAL_ID:
				return new AtlLibaryUriEditPart(view);

			case CommentEditPart.VISUAL_ID:
				return new CommentEditPart(view);

			case CommentDocEditPart.VISUAL_ID:
				return new CommentDocEditPart(view);

			case ExternalCallableEditPart.VISUAL_ID:
				return new ExternalCallableEditPart(view);

			case ExternalCallableNameEditPart.VISUAL_ID:
				return new ExternalCallableNameEditPart(view);

			case CallEditPart.VISUAL_ID:
				return new CallEditPart(view);

			case CallNameEditPart.VISUAL_ID:
				return new CallNameEditPart(view);

			case Generic_GeneratorEditPart.VISUAL_ID:
				return new Generic_GeneratorEditPart(view);

			case Generic_GeneratorNameEditPart.VISUAL_ID:
				return new Generic_GeneratorNameEditPart(view);

			case PropertyValueSwitchEditPart.VISUAL_ID:
				return new PropertyValueSwitchEditPart(view);

			case PropertyValueSwitchNameEditPart.VISUAL_ID:
				return new PropertyValueSwitchNameEditPart(view);

			case AtlResEditPart.VISUAL_ID:
				return new AtlResEditPart(view);

			case AtlResNameEditPart.VISUAL_ID:
				return new AtlResNameEditPart(view);

			case AtlResUriEditPart.VISUAL_ID:
				return new AtlResUriEditPart(view);

			case ArtifactEditPart.VISUAL_ID:
				return new ArtifactEditPart(view);

			case ArtifactNameEditPart.VISUAL_ID:
				return new ArtifactNameEditPart(view);

			case ArtifactUriEditPart.VISUAL_ID:
				return new ArtifactUriEditPart(view);

			case StopCallEditPart.VISUAL_ID:
				return new StopCallEditPart(view);

			case StopCallNameEditPart.VISUAL_ID:
				return new StopCallNameEditPart(view);

			case ModelAliasEditPart.VISUAL_ID:
				return new ModelAliasEditPart(view);

			case ModelAliasAliasNameEditPart.VISUAL_ID:
				return new ModelAliasAliasNameEditPart(view);

			case MMAliasEditPart.VISUAL_ID:
				return new MMAliasEditPart(view);

			case MMAliasAliasNameEditPart.VISUAL_ID:
				return new MMAliasAliasNameEditPart(view);

			case TransitionEditPart.VISUAL_ID:
				return new TransitionEditPart(view);

			case TransitionNameEditPart.VISUAL_ID:
				return new TransitionNameEditPart(view);

			case ModelMmEditPart.VISUAL_ID:
				return new ModelMmEditPart(view);

			case AtlResSuperimposeEditPart.VISUAL_ID:
				return new AtlResSuperimposeEditPart(view);

			case CallInEditPart.VISUAL_ID:
				return new CallInEditPart(view);

			case CallOutEditPart.VISUAL_ID:
				return new CallOutEditPart(view);

			case CallResEditPart.VISUAL_ID:
				return new CallResEditPart(view);

			case CallLibarysEditPart.VISUAL_ID:
				return new CallLibarysEditPart(view);

			case CallArtifactEditPart.VISUAL_ID:
				return new CallArtifactEditPart(view);

			case CommentDocumentedElementEditPart.VISUAL_ID:
				return new CommentDocumentedElementEditPart(view);

			case PredicateSwitchTrueCallableEditPart.VISUAL_ID:
				return new PredicateSwitchTrueCallableEditPart(view);

			case WrappingLabel2EditPart.VISUAL_ID:
				return new WrappingLabel2EditPart(view);

			case PredicateSwitchFalseCallableEditPart.VISUAL_ID:
				return new PredicateSwitchFalseCallableEditPart(view);

			case WrappingLabelEditPart.VISUAL_ID:
				return new WrappingLabelEditPart(view);

			case GeneratorUsesEditPart.VISUAL_ID:
				return new GeneratorUsesEditPart(view);

			case GeneratorProduceEditPart.VISUAL_ID:
				return new GeneratorProduceEditPart(view);

			case CallableNextEditPart.VISUAL_ID:
				return new CallableNextEditPart(view);

			case NamedSwitchDefaultCallEditPart.VISUAL_ID:
				return new NamedSwitchDefaultCallEditPart(view);

			case WrappingLabel3EditPart.VISUAL_ID:
				return new WrappingLabel3EditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrappingLabel)
			return new TextCellEditorLocator((WrappingLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrappingLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrappingLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (!text.getFont().isDisposed()) {
				if (getWrapLabel().isTextWrapOn() && getWrapLabel().getText().length() > 0) {
					rect.setSize(new Dimension(text.computeSize(rect.width, SWT.DEFAULT)));
				} else {
					int avr = FigureUtilities.getFontMetrics(text.getFont()).getAverageCharWidth();
					rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT, SWT.DEFAULT)).expand(avr * 2, 0));
				}
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}

	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			if (!text.getFont().isDisposed()) {
				int avr = FigureUtilities.getFontMetrics(text.getFont()).getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT, SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
