package de.urszeidler.eclipse.callchain.diagram.edit.parts;

import java.util.Collections;
import java.util.List;

import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.handles.MoveHandle;
import org.eclipse.gmf.runtime.diagram.ui.editparts.DiagramEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.NonResizableLabelEditPolicy;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.diagram.edit.part.CustomDiagramPopupBarEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.edit.policies.CallChainEditPolicyRoles;
import de.urszeidler.eclipse.callchain.diagram.edit.policies.CallsCanonicalEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.edit.policies.CallsDiagramDragDropEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.edit.policies.CallsItemSemanticEditPolicy;

/**
 * @generated
 */
public class CallsEditPart extends DiagramEditPart {

	/**
	 * @generated
	 */
	public final static String MODEL_ID = "Callchain"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 1000;

	/**
	 * @generated
	 */
	public CallsEditPart(View view) {
		super(view);
	}

	/**
	 * @generated not
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new CallsItemSemanticEditPolicy());
		// installEditPolicy(EditPolicyRoles.CANONICAL_ROLE,
		// new CallsCanonicalEditPolicy());
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.
		// EditPolicyRoles.POPUPBAR_ROLE);
		installEditPolicy(CallChainEditPolicyRoles.PSEUDO_CANONICAL_ROLE, new CallsCanonicalEditPolicy());
		installEditPolicy(EditPolicyRoles.DRAG_DROP_ROLE, new CallsDiagramDragDropEditPolicy());
		installEditPolicy(EditPolicyRoles.POPUPBAR_ROLE, new CustomDiagramPopupBarEditPolicy());

	}

	/**
	 * @generated
	 */
	/*package-local*/static class NodeLabelDragPolicy extends NonResizableEditPolicy {

		/**
		 * @generated
		 */
		@SuppressWarnings("rawtypes")
		protected List createSelectionHandles() {
			MoveHandle h = new MoveHandle((GraphicalEditPart) getHost());
			h.setBorder(null);
			return Collections.singletonList(h);
		}

		/**
		 * @generated
		 */
		public Command getCommand(Request request) {
			return null;
		}

		/**
		 * @generated
		 */
		public boolean understandsRequest(Request request) {
			return false;
		}
	}

	/**
	 * @generated
	 */
	/*package-local*/static class LinkLabelDragPolicy extends NonResizableLabelEditPolicy {

		/**
		 * @generated
		 */
		@SuppressWarnings("rawtypes")
		protected List createSelectionHandles() {
			MoveHandle mh = new MoveHandle((GraphicalEditPart) getHost());
			mh.setBorder(null);
			return Collections.singletonList(mh);
		}
	}

}
