package de.urszeidler.eclipse.callchain.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.Border;
import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.FlowLayoutEditPolicy;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.diagram.edit.policies.Generic_GeneratorItemSemanticEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorDescriptor;
import de.urszeidler.eclipse.callchain.generatorservice.Generatorservice;

/**
 * @generated
 */
public class Generic_GeneratorEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2027;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public Generic_GeneratorEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new Generic_GeneratorItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {

		FlowLayoutEditPolicy lep = new FlowLayoutEditPolicy() {

			protected Command createAddCommand(EditPart child, EditPart after) {
				return null;
			}

			protected Command createMoveChildCommand(EditPart child, EditPart after) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new Generic_GeneratorFigure();
	}

	/**
	 * @generated
	 */
	public Generic_GeneratorFigure getPrimaryShape() {
		return (Generic_GeneratorFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof Generic_GeneratorNameEditPart) {
			((Generic_GeneratorNameEditPart) childEditPart).setLabel(getPrimaryShape()
					.getFigureGeneric_GeneratornameFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof Generic_GeneratorNameEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model so
	 * you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane. Respects
	 * layout one may have set for generated figure.
	 * 
	 * @param nodeShape
	 *            instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(CallchainVisualIDRegistry.getType(Generic_GeneratorNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(3);
		types.add(CallchainElementTypes.GeneratorUses_4026);
		types.add(CallchainElementTypes.GeneratorProduce_4027);
		types.add(CallchainElementTypes.CallableNext_4028);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof MMEditPart) {
			types.add(CallchainElementTypes.GeneratorUses_4026);
		}
		if (targetEditPart instanceof ModelEditPart) {
			types.add(CallchainElementTypes.GeneratorUses_4026);
		}
		if (targetEditPart instanceof AtlLibaryEditPart) {
			types.add(CallchainElementTypes.GeneratorUses_4026);
		}
		if (targetEditPart instanceof AtlResEditPart) {
			types.add(CallchainElementTypes.GeneratorUses_4026);
		}
		if (targetEditPart instanceof ArtifactEditPart) {
			types.add(CallchainElementTypes.GeneratorUses_4026);
		}
		if (targetEditPart instanceof MMEditPart) {
			types.add(CallchainElementTypes.GeneratorProduce_4027);
		}
		if (targetEditPart instanceof ModelEditPart) {
			types.add(CallchainElementTypes.GeneratorProduce_4027);
		}
		if (targetEditPart instanceof AtlLibaryEditPart) {
			types.add(CallchainElementTypes.GeneratorProduce_4027);
		}
		if (targetEditPart instanceof AtlResEditPart) {
			types.add(CallchainElementTypes.GeneratorProduce_4027);
		}
		if (targetEditPart instanceof ArtifactEditPart) {
			types.add(CallchainElementTypes.GeneratorProduce_4027);
		}
		if (targetEditPart instanceof PredicateSwitchEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof ExternalCallableEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof CallEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof PropertyValueSwitchEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof StopCallEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
			types.add(CallchainElementTypes.MM_2018);
			types.add(CallchainElementTypes.Model_2015);
			types.add(CallchainElementTypes.AtlLibary_2019);
			types.add(CallchainElementTypes.AtlRes_2016);
			types.add(CallchainElementTypes.Artifact_2020);
		} else if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
			types.add(CallchainElementTypes.MM_2018);
			types.add(CallchainElementTypes.Model_2015);
			types.add(CallchainElementTypes.AtlLibary_2019);
			types.add(CallchainElementTypes.AtlRes_2016);
			types.add(CallchainElementTypes.Artifact_2020);
		} else if (relationshipType == CallchainElementTypes.CallableNext_4028) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
			types.add(CallchainElementTypes.ExternalCallable_2029);
			types.add(CallchainElementTypes.Call_2017);
			types.add(CallchainElementTypes.Generic_Generator_2027);
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
			types.add(CallchainElementTypes.StopCall_2031);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(6);
		types.add(CallchainElementTypes.Transition_4029);
		types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		types.add(CallchainElementTypes.PredicateSwitchTrueCallable_4030);
		types.add(CallchainElementTypes.PredicateSwitchFalseCallable_4031);
		types.add(CallchainElementTypes.CallableNext_4028);
		types.add(CallchainElementTypes.NamedSwitchDefaultCall_4032);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == CallchainElementTypes.Transition_4029) {
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
		} else if (relationshipType == CallchainElementTypes.CommentDocumentedElement_4025) {
			types.add(CallchainElementTypes.Comment_2024);
		} else if (relationshipType == CallchainElementTypes.PredicateSwitchTrueCallable_4030) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
		} else if (relationshipType == CallchainElementTypes.PredicateSwitchFalseCallable_4031) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
		} else if (relationshipType == CallchainElementTypes.CallableNext_4028) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
			types.add(CallchainElementTypes.ExternalCallable_2029);
			types.add(CallchainElementTypes.Call_2017);
			types.add(CallchainElementTypes.Generic_Generator_2027);
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
			types.add(CallchainElementTypes.StopCall_2031);
		} else if (relationshipType == CallchainElementTypes.NamedSwitchDefaultCall_4032) {
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
		}
		return types;
	}

	@Override
	protected void refreshVisuals() {
		super.refreshVisuals();

		View view = (View) getModel();
		EObject element = view.getElement();
		if (element instanceof Generic_Generator) {
			Generic_Generator generic_gen = (Generic_Generator) element;
			getPrimaryShape().getGeneric_GeneratorName().setText(generic_gen.getGeneratorType());
			GeneratorDescriptor descriptor = Generatorservice.getDefault().getGenerator(generic_gen.getId());
			if (descriptor != null) {
				getPrimaryShape().generic_GeneratorName.setIcon(descriptor.getSmallImage());
				if (descriptor.getGeneratorColor() != null)
					getPrimaryShape()//.getFigureGeneric_GeneratornameFigure()
							.setForegroundColor(descriptor.getGeneratorColor());
			}
		}
	}

	/**
	 * @generated not
	 */
	public class Generic_GeneratorFigure extends RoundedRectangle {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureGeneric_GeneratornameFigure;
		private WrappingLabel generic_GeneratorName;
		private Figure container;

		/**
		 * @generated not
		 */
		public Generic_GeneratorFigure() {

			BorderLayout layoutThis = new BorderLayout();
			layoutThis.setHorizontalSpacing(3);
			this.setLayoutManager(layoutThis);
			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(30), getMapMode().DPtoLP(30)));

			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(120), getMapMode().DPtoLP(30)));

			Border newBorder = new MarginBorder(5);
			this.setBorder(newBorder);
			createContents();

			// createContents();
		}

		/**
		 * @generated not
		 */
		private void createContents() {
			container = new Figure();
			ToolbarLayout layout = new ToolbarLayout();
			layout.setStretchMinorAxis(true);
			layout.setMinorAlignment(ToolbarLayout.ALIGN_CENTER);

			container.setLayoutManager(layout);
			this.add(container, BorderLayout.CENTER);

			generic_GeneratorName = new WrappingLabel();
			generic_GeneratorName.setText("Generic_Generator");
			generic_GeneratorName.setAlignment(PositionConstants.CENTER);// TODO
			// :
			// this
			// one
			// need
			// to
			// be
			// different
			// in
			// many
			// kinds
			container.add(generic_GeneratorName);

			fFigureGeneric_GeneratornameFigure = new WrappingLabel();
			fFigureGeneric_GeneratornameFigure.setText("[null]");
			fFigureGeneric_GeneratornameFigure.setAlignment(PositionConstants.CENTER);
			container.add(fFigureGeneric_GeneratornameFigure);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureGeneric_GeneratornameFigure() {
			return fFigureGeneric_GeneratornameFigure;
		}

		public WrappingLabel getGeneric_GeneratorName() {
			return generic_GeneratorName;
		}

	}

}
