package de.urszeidler.eclipse.callchain.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand;
import org.eclipse.gmf.runtime.emf.commands.core.command.CompositeTransactionalCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyReferenceCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyReferenceRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallArtifactCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallArtifactReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallInCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallInReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallLibarysCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallLibarysReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallOutCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallOutReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallResCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallResReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallableNextCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallableNextReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentDocumentedElementCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentDocumentedElementReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelAliasCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelAliasReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.NamedSwitchDefaultCallCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.NamedSwitchDefaultCallReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.PredicateSwitchFalseCallableCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.PredicateSwitchFalseCallableReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.PredicateSwitchTrueCallableCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.PredicateSwitchTrueCallableReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.TransitionCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.TransitionReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallInEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallLibarysEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallOutEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallableNextEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocumentedElementEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.NamedSwitchDefaultCallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchFalseCallableEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchTrueCallableEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TransitionEditPart;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class CallItemSemanticEditPolicy extends CallchainBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public CallItemSemanticEditPolicy() {
		super(CallchainElementTypes.Call_2017);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		View view = (View) getHost().getModel();
		CompositeTransactionalCommand cmd = new CompositeTransactionalCommand(getEditingDomain(), null);
		cmd.setTransactionNestingEnabled(false);
		for (Iterator<?> it = view.getTargetEdges().iterator(); it.hasNext();) {
			Edge incomingLink = (Edge) it.next();
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == TransitionEditPart.VISUAL_ID) {
				DestroyElementRequest r = new DestroyElementRequest(incomingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == CommentDocumentedElementEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == PredicateSwitchTrueCallableEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == PredicateSwitchFalseCallableEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == CallableNextEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == NamedSwitchDefaultCallEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
		}
		for (Iterator<?> it = view.getSourceEdges().iterator(); it.hasNext();) {
			Edge outgoingLink = (Edge) it.next();
			if (CallchainVisualIDRegistry.getVisualID(outgoingLink) == ModelAliasEditPart.VISUAL_ID) {
				DestroyElementRequest r = new DestroyElementRequest(outgoingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(outgoingLink) == CallInEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(outgoingLink.getSource().getElement(), null,
						outgoingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(outgoingLink) == CallOutEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(outgoingLink.getSource().getElement(), null,
						outgoingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(outgoingLink) == CallResEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(outgoingLink.getSource().getElement(), null,
						outgoingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(outgoingLink) == CallLibarysEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(outgoingLink.getSource().getElement(), null,
						outgoingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(outgoingLink) == CallArtifactEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(outgoingLink.getSource().getElement(), null,
						outgoingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(outgoingLink) == CallableNextEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(outgoingLink.getSource().getElement(), null,
						outgoingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
		}
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation == null) {
			// there are indirectly referenced children, need extra commands: false
			addDestroyShortcutsCommand(cmd, view);
			// delete host element
			cmd.add(new DestroyElementCommand(req));
		} else {
			cmd.add(new DeleteCommand(getEditingDomain(), view));
		}
		return getGEFWrapper(cmd.reduce());
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (CallchainElementTypes.ModelAlias_4016 == req.getElementType()) {
			return getGEFWrapper(new ModelAliasCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.Transition_4029 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallIn_4020 == req.getElementType()) {
			return getGEFWrapper(new CallInCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallOut_4021 == req.getElementType()) {
			return getGEFWrapper(new CallOutCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallRes_4022 == req.getElementType()) {
			return getGEFWrapper(new CallResCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallLibarys_4023 == req.getElementType()) {
			return getGEFWrapper(new CallLibarysCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallArtifact_4024 == req.getElementType()) {
			return getGEFWrapper(new CallArtifactCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CommentDocumentedElement_4025 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.PredicateSwitchTrueCallable_4030 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.PredicateSwitchFalseCallable_4031 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallableNext_4028 == req.getElementType()) {
			return getGEFWrapper(new CallableNextCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.NamedSwitchDefaultCall_4032 == req.getElementType()) {
			return null;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (CallchainElementTypes.ModelAlias_4016 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.Transition_4029 == req.getElementType()) {
			return getGEFWrapper(new TransitionCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallIn_4020 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallOut_4021 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallRes_4022 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallLibarys_4023 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallArtifact_4024 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CommentDocumentedElement_4025 == req.getElementType()) {
			return getGEFWrapper(new CommentDocumentedElementCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.PredicateSwitchTrueCallable_4030 == req.getElementType()) {
			return getGEFWrapper(new PredicateSwitchTrueCallableCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.PredicateSwitchFalseCallable_4031 == req.getElementType()) {
			return getGEFWrapper(new PredicateSwitchFalseCallableCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallableNext_4028 == req.getElementType()) {
			return getGEFWrapper(new CallableNextCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.NamedSwitchDefaultCall_4032 == req.getElementType()) {
			return getGEFWrapper(new NamedSwitchDefaultCallCreateCommand(req, req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EClass based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientRelationshipCommand(ReorientRelationshipRequest req) {
		switch (getVisualID(req)) {
		case ModelAliasEditPart.VISUAL_ID:
			return getGEFWrapper(new ModelAliasReorientCommand(req));
		case TransitionEditPart.VISUAL_ID:
			return getGEFWrapper(new TransitionReorientCommand(req));
		}
		return super.getReorientRelationshipCommand(req);
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case CallInEditPart.VISUAL_ID:
			return getGEFWrapper(new CallInReorientCommand(req));
		case CallOutEditPart.VISUAL_ID:
			return getGEFWrapper(new CallOutReorientCommand(req));
		case CallResEditPart.VISUAL_ID:
			return getGEFWrapper(new CallResReorientCommand(req));
		case CallLibarysEditPart.VISUAL_ID:
			return getGEFWrapper(new CallLibarysReorientCommand(req));
		case CallArtifactEditPart.VISUAL_ID:
			return getGEFWrapper(new CallArtifactReorientCommand(req));
		case CommentDocumentedElementEditPart.VISUAL_ID:
			return getGEFWrapper(new CommentDocumentedElementReorientCommand(req));
		case PredicateSwitchTrueCallableEditPart.VISUAL_ID:
			return getGEFWrapper(new PredicateSwitchTrueCallableReorientCommand(req));
		case PredicateSwitchFalseCallableEditPart.VISUAL_ID:
			return getGEFWrapper(new PredicateSwitchFalseCallableReorientCommand(req));
		case CallableNextEditPart.VISUAL_ID:
			return getGEFWrapper(new CallableNextReorientCommand(req));
		case NamedSwitchDefaultCallEditPart.VISUAL_ID:
			return getGEFWrapper(new NamedSwitchDefaultCallReorientCommand(req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
