package de.urszeidler.eclipse.callchain.diagram.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;

import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallArtifactCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallArtifactReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentDocumentedElementCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentDocumentedElementReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorProduceCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorProduceReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorUsesCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorUsesReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelMmCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelMmReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocumentedElementEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorProduceEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorUsesEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelMmEditPart;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class MMAliasItemSemanticEditPolicy extends CallchainBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public MMAliasItemSemanticEditPolicy() {
		super(CallchainElementTypes.MMAlias_4017);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		return getGEFWrapper(new DestroyElementCommand(req));
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (CallchainElementTypes.ModelMm_4018 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallArtifact_4024 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CommentDocumentedElement_4025 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.GeneratorUses_4026 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.GeneratorProduce_4027 == req.getElementType()) {
			return null;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (CallchainElementTypes.ModelMm_4018 == req.getElementType()) {
			return getGEFWrapper(new ModelMmCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallArtifact_4024 == req.getElementType()) {
			return getGEFWrapper(new CallArtifactCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CommentDocumentedElement_4025 == req.getElementType()) {
			return getGEFWrapper(new CommentDocumentedElementCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.GeneratorUses_4026 == req.getElementType()) {
			return getGEFWrapper(new GeneratorUsesCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.GeneratorProduce_4027 == req.getElementType()) {
			return getGEFWrapper(new GeneratorProduceCreateCommand(req, req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case ModelMmEditPart.VISUAL_ID:
			return getGEFWrapper(new ModelMmReorientCommand(req));
		case CallArtifactEditPart.VISUAL_ID:
			return getGEFWrapper(new CallArtifactReorientCommand(req));
		case CommentDocumentedElementEditPart.VISUAL_ID:
			return getGEFWrapper(new CommentDocumentedElementReorientCommand(req));
		case GeneratorUsesEditPart.VISUAL_ID:
			return getGEFWrapper(new GeneratorUsesReorientCommand(req));
		case GeneratorProduceEditPart.VISUAL_ID:
			return getGEFWrapper(new GeneratorProduceReorientCommand(req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
