package de.urszeidler.eclipse.callchain.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ExternalCallableNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMHandlerEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PropertyValueSwitchNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.StopCallNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TransitionNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.parsers.MessageFormatParser;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;

/**
 * @generated
 */
public class CallchainParserProvider extends AbstractProvider implements IParserProvider {

	/**
	 * @generated
	 */
	private IParser modelName_5031Parser;

	/**
	 * @generated
	 */
	private IParser getModelName_5031Parser() {
		if (modelName_5031Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			modelName_5031Parser = parser;
		}
		return modelName_5031Parser;
	}

	/**
	 * @generated
	 */
	private IParser modelUri_5032Parser;

	/**
	 * @generated
	 */
	private IParser getModelUri_5032Parser() {
		if (modelUri_5032Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			modelUri_5032Parser = parser;
		}
		return modelUri_5032Parser;
	}

	/**
	 * @generated
	 */
	private IParser atlResName_5033Parser;

	/**
	 * @generated
	 */
	private IParser getAtlResName_5033Parser() {
		if (atlResName_5033Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			atlResName_5033Parser = parser;
		}
		return atlResName_5033Parser;
	}

	/**
	 * @generated
	 */
	private IParser atlResUri_5034Parser;

	/**
	 * @generated
	 */
	private IParser getAtlResUri_5034Parser() {
		if (atlResUri_5034Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			atlResUri_5034Parser = parser;
		}
		return atlResUri_5034Parser;
	}

	/**
	 * @generated
	 */
	private IParser atlLibaryName_5039Parser;

	/**
	 * @generated
	 */
	private IParser getAtlLibaryName_5039Parser() {
		if (atlLibaryName_5039Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			atlLibaryName_5039Parser = parser;
		}
		return atlLibaryName_5039Parser;
	}

	/**
	 * @generated
	 */
	private IParser atlLibaryUri_5040Parser;

	/**
	 * @generated
	 */
	private IParser getAtlLibaryUri_5040Parser() {
		if (atlLibaryUri_5040Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			atlLibaryUri_5040Parser = parser;
		}
		return atlLibaryUri_5040Parser;
	}

	/**
	 * @generated
	 */
	private IParser callName_5035Parser;

	/**
	 * @generated
	 */
	private IParser getCallName_5035Parser() {
		if (callName_5035Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			callName_5035Parser = parser;
		}
		return callName_5035Parser;
	}

	/**
	 * @generated
	 */
	private IParser predicateSwitchName_5054Parser;

	/**
	 * @generated
	 */
	private IParser getPredicateSwitchName_5054Parser() {
		if (predicateSwitchName_5054Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			predicateSwitchName_5054Parser = parser;
		}
		return predicateSwitchName_5054Parser;
	}

	/**
	 * @generated
	 */
	private IParser externalCallableName_5055Parser;

	/**
	 * @generated
	 */
	private IParser getExternalCallableName_5055Parser() {
		if (externalCallableName_5055Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			externalCallableName_5055Parser = parser;
		}
		return externalCallableName_5055Parser;
	}

	/**
	 * @generated
	 */
	private IParser mMUri_5037Parser;

	/**
	 * @generated
	 */
	private IParser getMMUri_5037Parser() {
		if (mMUri_5037Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			mMUri_5037Parser = parser;
		}
		return mMUri_5037Parser;
	}

	/**
	 * @generated
	 */
	private IParser mMHandler_5038Parser;

	/**
	 * @generated
	 */
	private IParser getMMHandler_5038Parser() {
		if (mMHandler_5038Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getMM_Handler() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getMM_Handler() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			mMHandler_5038Parser = parser;
		}
		return mMHandler_5038Parser;
	}

	/**
	 * @generated
	 */
	private IParser artifactName_5041Parser;

	/**
	 * @generated
	 */
	private IParser getArtifactName_5041Parser() {
		if (artifactName_5041Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			artifactName_5041Parser = parser;
		}
		return artifactName_5041Parser;
	}

	/**
	 * @generated
	 */
	private IParser artifactUri_5042Parser;

	/**
	 * @generated
	 */
	private IParser getArtifactUri_5042Parser() {
		if (artifactUri_5042Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Uri() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			artifactUri_5042Parser = parser;
		}
		return artifactUri_5042Parser;
	}

	/**
	 * @generated
	 */
	private IParser propertyValueSwitchName_5056Parser;

	/**
	 * @generated
	 */
	private IParser getPropertyValueSwitchName_5056Parser() {
		if (propertyValueSwitchName_5056Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			propertyValueSwitchName_5056Parser = parser;
		}
		return propertyValueSwitchName_5056Parser;
	}

	/**
	 * @generated
	 */
	private IParser commentDoc_5048Parser;

	/**
	 * @generated
	 */
	private IParser getCommentDoc_5048Parser() {
		if (commentDoc_5048Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getComment_Doc() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getComment_Doc() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			commentDoc_5048Parser = parser;
		}
		return commentDoc_5048Parser;
	}

	/**
	 * @generated
	 */
	private IParser stopCallName_5057Parser;

	/**
	 * @generated
	 */
	private IParser getStopCallName_5057Parser() {
		if (stopCallName_5057Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			stopCallName_5057Parser = parser;
		}
		return stopCallName_5057Parser;
	}

	/**
	 * @generated
	 */
	private IParser generic_GeneratorName_5053Parser;

	/**
	 * @generated
	 */
	private IParser getGeneric_GeneratorName_5053Parser() {
		if (generic_GeneratorName_5053Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getCallable_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			generic_GeneratorName_5053Parser = parser;
		}
		return generic_GeneratorName_5053Parser;
	}

	/**
	 * @generated
	 */
	private IParser mMName_5036Parser;

	/**
	 * @generated
	 */
	private IParser getMMName_5036Parser() {
		if (mMName_5036Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getArtifact_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			mMName_5036Parser = parser;
		}
		return mMName_5036Parser;
	}

	/**
	 * @generated
	 */
	private IParser modelAliasAliasName_6003Parser;

	/**
	 * @generated
	 */
	private IParser getModelAliasAliasName_6003Parser() {
		if (modelAliasAliasName_6003Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getModelAlias_AliasName() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getModelAlias_AliasName() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			modelAliasAliasName_6003Parser = parser;
		}
		return modelAliasAliasName_6003Parser;
	}

	/**
	 * @generated
	 */
	private IParser mMAliasAliasName_6004Parser;

	/**
	 * @generated
	 */
	private IParser getMMAliasAliasName_6004Parser() {
		if (mMAliasAliasName_6004Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getMMAlias_AliasName() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getMMAlias_AliasName() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			mMAliasAliasName_6004Parser = parser;
		}
		return mMAliasAliasName_6004Parser;
	}

	/**
	 * @generated
	 */
	private IParser transitionName_6005Parser;

	/**
	 * @generated
	 */
	private IParser getTransitionName_6005Parser() {
		if (transitionName_6005Parser == null) {
			EAttribute[] features = new EAttribute[] { CallchainPackage.eINSTANCE.getTransition_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { CallchainPackage.eINSTANCE.getTransition_Name() };
			MessageFormatParser parser = new MessageFormatParser(features, editableFeatures);
			transitionName_6005Parser = parser;
		}
		return transitionName_6005Parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case PredicateSwitchNameEditPart.VISUAL_ID:
			return getPredicateSwitchName_5054Parser();
		case MMNameEditPart.VISUAL_ID:
			return getMMName_5036Parser();
		case MMUriEditPart.VISUAL_ID:
			return getMMUri_5037Parser();
		case MMHandlerEditPart.VISUAL_ID:
			return getMMHandler_5038Parser();
		case ModelNameEditPart.VISUAL_ID:
			return getModelName_5031Parser();
		case ModelUriEditPart.VISUAL_ID:
			return getModelUri_5032Parser();
		case AtlLibaryNameEditPart.VISUAL_ID:
			return getAtlLibaryName_5039Parser();
		case AtlLibaryUriEditPart.VISUAL_ID:
			return getAtlLibaryUri_5040Parser();
		case CommentDocEditPart.VISUAL_ID:
			return getCommentDoc_5048Parser();
		case ExternalCallableNameEditPart.VISUAL_ID:
			return getExternalCallableName_5055Parser();
		case CallNameEditPart.VISUAL_ID:
			return getCallName_5035Parser();
		case Generic_GeneratorNameEditPart.VISUAL_ID:
			return getGeneric_GeneratorName_5053Parser();
		case PropertyValueSwitchNameEditPart.VISUAL_ID:
			return getPropertyValueSwitchName_5056Parser();
		case AtlResNameEditPart.VISUAL_ID:
			return getAtlResName_5033Parser();
		case AtlResUriEditPart.VISUAL_ID:
			return getAtlResUri_5034Parser();
		case ArtifactNameEditPart.VISUAL_ID:
			return getArtifactName_5041Parser();
		case ArtifactUriEditPart.VISUAL_ID:
			return getArtifactUri_5042Parser();
		case StopCallNameEditPart.VISUAL_ID:
			return getStopCallName_5057Parser();
		case ModelAliasAliasNameEditPart.VISUAL_ID:
			return getModelAliasAliasName_6003Parser();
		case MMAliasAliasNameEditPart.VISUAL_ID:
			return getMMAliasAliasName_6004Parser();
		case TransitionNameEditPart.VISUAL_ID:
			return getTransitionName_6005Parser();
		}
		return null;
	}

	/**
	 * Utility method that consults ParserService
	 * @generated
	 */
	public static IParser getParser(IElementType type, EObject object, String parserHint) {
		return ParserService.getInstance().getParser(new HintAdapter(type, object, parserHint));
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(CallchainVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(CallchainVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (CallchainElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	private static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
