/**
 * 
 */
package de.urszeidler.eclipse.callchain.emfgenerators.executables;

import java.io.IOException;
import java.util.Collection;
import java.util.List;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.EcoreUtil;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable;
import de.urszeidler.eclipse.callchain.generatorservice.executables.AbstractExecuteable;

/**
 * @author urs
 * 
 */
public class XmiMerge extends AbstractExecuteable implements GeneratorExecutable {

	/**
	 * 
	 */
	public XmiMerge() {
		// TODO Auto-generated constructor stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable#
	 * configure(de.urszeidler.eclipse.callchain.Generic_Generator)
	 */
	// @Override
	public void configure(Generic_Generator generator) {
		super.configure(generator);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable#
	 * execute(org.eclipse.core.runtime.IProgressMonitor)
	 */
	// @Override
	public void execute(IProgressMonitor monitor) {
		IFile artifactToIFile = artifactToIFile(this.generator.getProduce().get(0));
		Resource resource = createNewResource(artifactToIFile);
		ResourceSet resourceSet = createResourceSet();
		List<Model> allModels = getAllModels(this.generator.getUses());
		for (Model model : allModels) {
			URI uri = artifactToUri(model);
			if (!allreadyLoaded(resourceSet, uri)) {

				Object eObject = loadEObject(model, resourceSet);
				EcoreUtil.resolveAll(resourceSet);
			}
		}

		for (Model model : allModels) {
			URI uri = artifactToUri(model);
			EList<Resource> resources = resourceSet.getResources();
			for (Resource r : resources) {
				if (r.getURI().equals(uri)) {
					resource.getContents().addAll(r.getContents());
					break;
				}
			}
		}

		try {
			resource.save(null);
		} catch (IOException e) {
			e.printStackTrace();
			createCoreException(e);
		}
	}

	/**
	 * @param resourceSet
	 * @param uri
	 * @return 
	 */
	private boolean allreadyLoaded(ResourceSet resourceSet, URI uri) {
		EList<Resource> resources = resourceSet.getResources();
		for (Resource r : resources) {
			if (r.getURI().equals(uri)) {
				return true;
			}
		}
		return false;
	}

}
