/**
 * 
 */
package de.urszeidler.eclipse.callchain.executors;

import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.ExternalCallable;

/**
 * @author urs
 *
 */
public class StopExternalCallableStep implements ExecutorStep {

	private ExternalCallable ec;

	public StopExternalCallableStep(ExternalCallable object) {
		this.ec = object;
	}

	/* (non-Javadoc)
	 * @see de.urszeidler.eclipse.callchain.executors.ExecutorStep#generate(java.lang.Object)
	 */
	@Override
	public void generate(Object monitor) {
		Callable delegatedCallable = ec.getDelegatedCallable();
		if (delegatedCallable == null)
			return;

		Calls currentCalls = (Calls) ec.eContainer();
		Calls externalCalls = (Calls) delegatedCallable.eContainer();
		if (currentCalls != externalCalls) 
			externalCalls.setSubtitutionMode(false);		
	}

	/* (non-Javadoc)
	 * @see de.urszeidler.eclipse.callchain.executors.ExecutorStep#getTaskName()
	 */
	@Override
	public String getTaskName() {
		return "returning from :"+ec.getName();
	}

	/* (non-Javadoc)
	 * @see de.urszeidler.eclipse.callchain.executors.ExecutorStep#getWrapedObject()
	 */
	@Override
	public Object getWrapedObject() {
		return null;
	}

	/* (non-Javadoc)
	 * @see de.urszeidler.eclipse.callchain.executors.ExecutorStep#isRefreshWorkspace()
	 */
	@Override
	public boolean isRefreshWorkspace() {
		return false;
	}

}
