/**
 * 
 */
package de.urszeidler.eclipse.callchain.gmfgenerators;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.gmf.codegen.gmfgen.GenEditorGenerator;
import org.eclipse.gmf.codegen.util.Generator;
import org.eclipse.gmf.internal.bridge.transform.ValidationHelper;
import org.eclipse.gmf.internal.codegen.CodeGenUIPlugin;

import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable;

/**
 * @author urs
 * 
 */
public class GMFDiagramGenerator extends AbstractGMFGenerator implements GeneratorExecutable {

	/**
	 * 
	 */
	public GMFDiagramGenerator() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable#
	 * configure(de.urszeidler.eclipse.callchain.Generic_Generator)
	 */
	@Override
	public void configure(Object generator) {
		super.configure(generator);

	}

	@Override
	protected String validateGG(Generic_Generator generator) {
	
		Model model = findModelByMetaModel(generator.getUses(), GENMODELS);
		if (model == null)
			return "No used model conforms to "+GENMODELURI+"or "+GENMODELURI2008+" Metamodel.";
		
		return "";
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable#
	 * execute(org.eclipse.core.runtime.IProgressMonitor)
	 */
	@SuppressWarnings( { "restriction" })
	@Override
	public void execute(IProgressMonitor monitor) throws CoreException {
		try {

			Model genmodel = findModelByMetaModel(generator.getUses(), GENMODELS);
			GenEditorGenerator genModel = loadGenmodel(genmodel);
			Diagnostic diagnostic = ValidationHelper.validate(genmodel, true);
			if(diagnostic.getSeverity()==Diagnostic.ERROR)
				throw createCoreException(diagnostic.getException());
				
			Generator gen = new org.eclipse.gmf.codegen.util.Generator(genModel, CodeGenUIPlugin.getDefault()
					.getEmitters(genModel));
			gen.run(monitor);
		} catch (Exception e) {
			throw createCoreException(e);
		}

	}

	private GenEditorGenerator loadGenmodel(Model model) {
		return (GenEditorGenerator) loadEObject(model);
	}

}
