/**
 * 
 */
package de.urszeidler.eclipse.callchain.gmfgenerators;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.gmf.internal.bridge.transform.TransformToGenModelOperation;
import org.eclipse.gmf.mappings.Mapping;

import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable;

/**
 * @author urs
 * 
 */
public class GenmodelGenerator extends AbstractGMFGenerator implements GeneratorExecutable {
	/**
	 * 
	 */
	public GenmodelGenerator() {
		// TODO Auto-generated constructor stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable#
	 * configure(de.urszeidler.eclipse.callchain.Generic_Generator)
	 */
	@Override
	public void configure(Object generator) {
		super.configure(generator);

	}

	@Override
	protected String validateGG(Generic_Generator generator) {
		Model model = findModelByMetaModel(generator.getUses(), MAPPINGMODELS);
		if (model == null)
			return "No used model conforms to "+MAPPINGMODELURI+"or "+MAPPINGMODELURI2008+" Metamodel.";
		
		model = findModelByMetaModel(generator.getProduce(), GENMODELS);
		if (model == null)
			return "No produced model conforms to "+GENMODELURI+"or "+GENMODELURI2008+"or "+GENMODELURI2009+" Metamodel.";
		
		return "";
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable#
	 * execute(org.eclipse.core.runtime.IProgressMonitor)
	 */
	@Override
	public void execute(IProgressMonitor monitor) throws CoreException {
		ResourceSet resourceSet = createResourceSet();
		IWorkspace wks = ResourcesPlugin.getWorkspace();
		IWorkspaceRoot wksroot = wks.getRoot();

		Model mappingmodel = findModelByMetaModel(generator.getUses(), MAPPINGMODELS);

		String strUri = mappingmodel.getUri();
//		Path file = new Path(strUri);
		IFile currentFile = wksroot.getFile(new Path(strUri));
		// Get the URI of the model file.
		URI mappingURI = URI.createPlatformResourceURI(currentFile.getFullPath().toString());

		// Create a resource for this file.
		// Resource emfResource = resourceSet.createResource(mappingURI);

		TransformToGenModelOperation op = new TransformToGenModelOperation(resourceSet);

		Model genmodel = findModelByMetaModel(generator.getProduce(), GENMODELS);
		strUri = genmodel.getUri();
//		file = new Path(strUri);
		currentFile = wksroot.getFile(new Path(strUri));

		IFile target = currentFile;
		try {
			Mapping loadMappingModel = op.loadMappingModel(mappingURI, monitor);
			op.setGenURI(URI.createPlatformResourceURI(target.getFullPath().toString(), true));
			
			
		} catch (CoreException e) {
			throw createCoreException(e);
		}
		IStatus s = op.executeTransformation(monitor);

	}

}
