package de.urszeidler.eclipse.callchain.gmfgenerators.preferences;

import java.io.File;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;

import de.urszeidler.eclipse.callchain.gmfgenerators.AbstractGMFGenerator;
import de.urszeidler.eclipse.callchain.gmfgenerators.Activator;

/**
 * Class used to initialize default preference values.
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#
	 * initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = Activator.getDefault().getPreferenceStore();
		store.setDefault(PreferenceConstants.GENMODELS_PREFERENCES, AbstractGMFGenerator.GENMODELURI
				+ File.pathSeparator + "\n\r" + AbstractGMFGenerator.GENMODELURI2008 + File.pathSeparator + "\n\r"
				+ AbstractGMFGenerator.GENMODELURI2009 + File.pathSeparator + "\n\r");
		store.setDefault(PreferenceConstants.MAPPINGMODELS_PREFERENCES, AbstractGMFGenerator.MAPPINGMODELURI
				+ File.pathSeparator + "\n\r" + AbstractGMFGenerator.MAPPINGMODELURI2008 + File.pathSeparator + "\n\r");
	}

}
