/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallsImpl.java,v 1.1 2008/04/09 22:40:57 urs Exp $
 */
package de.urszeidler.eclipse.callchain.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.ExternalCallable;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.Property;
import de.urszeidler.eclipse.callchain.StopCall;
import de.urszeidler.eclipse.callchain.Switch;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Calls</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getComments <em>Comments</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getCall <em>Call</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getGenerators <em>Generators</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getArtifacts <em>Artifacts</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getProperties <em>Properties</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getDefaultLib <em>Default Lib</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getDefaultSuperImposed <em>Default Super Imposed</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getStartPoints <em>Start Points</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getDefaultStartPoint <em>Default Start Point</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#isLogDefault <em>Log Default</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getSwitches <em>Switches</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getExternCallables <em>Extern Callables</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallsImpl#getStopElements <em>Stop Elements</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CallsImpl extends EObjectImpl implements Calls {
	/**
	 * The cached value of the '{@link #getComments() <em>Comments</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComments()
	 * @generated
	 * @ordered
	 */
	protected EList<Comment> comments;

	/**
	 * The cached value of the '{@link #getCall() <em>Call</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCall()
	 * @generated
	 * @ordered
	 */
	protected EList<Call> call;

	/**
	 * The cached value of the '{@link #getGenerators() <em>Generators</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGenerators()
	 * @generated
	 * @ordered
	 */
	protected EList<Generator> generators;

	/**
	 * The cached value of the '{@link #getArtifacts() <em>Artifacts</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArtifacts()
	 * @generated
	 * @ordered
	 */
	protected EList<Artifact> artifacts;

	/**
	 * The cached value of the '{@link #getProperties() <em>Properties</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProperties()
	 * @generated
	 * @ordered
	 */
	protected EList<Property> properties;

	/**
	 * The cached value of the '{@link #getDefaultLib() <em>Default Lib</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDefaultLib()
	 * @generated
	 * @ordered
	 */
	protected EList<AtlLibary> defaultLib;

	/**
	 * The cached value of the '{@link #getDefaultSuperImposed() <em>Default Super Imposed</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDefaultSuperImposed()
	 * @generated
	 * @ordered
	 */
	protected EList<AtlRes> defaultSuperImposed;

	/**
	 * The cached value of the '{@link #getStartPoints() <em>Start Points</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartPoints()
	 * @generated
	 * @ordered
	 */
	protected EList<Callable> startPoints;

	/**
	 * The cached value of the '{@link #getDefaultStartPoint() <em>Default Start Point</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDefaultStartPoint()
	 * @generated
	 * @ordered
	 */
	protected Callable defaultStartPoint;

	/**
	 * The default value of the '{@link #isLogDefault() <em>Log Default</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLogDefault()
	 * @generated
	 * @ordered
	 */
	protected static final boolean LOG_DEFAULT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isLogDefault() <em>Log Default</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLogDefault()
	 * @generated
	 * @ordered
	 */
	protected boolean logDefault = LOG_DEFAULT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getSwitches() <em>Switches</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSwitches()
	 * @generated
	 * @ordered
	 */
	protected EList<Switch> switches;

	/**
	 * The cached value of the '{@link #getExternCallables() <em>Extern Callables</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExternCallables()
	 * @generated
	 * @ordered
	 */
	protected EList<ExternalCallable> externCallables;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStopElements() <em>Stop Elements</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStopElements()
	 * @generated
	 * @ordered
	 */
	protected EList<StopCall> stopElements;

	private boolean subtitutionMode = false;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CallchainPackage.Literals.CALLS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Comment> getComments() {
		if (comments == null) {
			comments = new EObjectContainmentWithInverseEList<Comment>(Comment.class, this, CallchainPackage.CALLS__COMMENTS, CallchainPackage.COMMENT__OWNER);
		}
		return comments;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Call> getCall() {
		if (call == null) {
			call = new EObjectContainmentWithInverseEList<Call>(Call.class, this, CallchainPackage.CALLS__CALL, CallchainPackage.CALL__ENVIORMENT);
		}
		return call;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Generator> getGenerators() {
		if (generators == null) {
			generators = new EObjectContainmentWithInverseEList<Generator>(Generator.class, this, CallchainPackage.CALLS__GENERATORS, CallchainPackage.GENERATOR__ENVIORMENT);
		}
		return generators;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Artifact> getArtifacts() {
		if (artifacts == null) {
			artifacts = new EObjectContainmentEList<Artifact>(Artifact.class, this, CallchainPackage.CALLS__ARTIFACTS);
		}
		return artifacts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Property> getProperties() {
		if (properties == null) {
			properties = new EObjectContainmentEList<Property>(Property.class, this, CallchainPackage.CALLS__PROPERTIES);
		}
		return properties;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<AtlLibary> getDefaultLib() {
		if (defaultLib == null) {
			defaultLib = new EObjectResolvingEList<AtlLibary>(AtlLibary.class, this, CallchainPackage.CALLS__DEFAULT_LIB);
		}
		return defaultLib;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<AtlRes> getDefaultSuperImposed() {
		if (defaultSuperImposed == null) {
			defaultSuperImposed = new EObjectResolvingEList<AtlRes>(AtlRes.class, this, CallchainPackage.CALLS__DEFAULT_SUPER_IMPOSED);
		}
		return defaultSuperImposed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Callable> getStartPoints() {
		if (startPoints == null) {
			startPoints = new EObjectResolvingEList<Callable>(Callable.class, this, CallchainPackage.CALLS__START_POINTS);
		}
		return startPoints;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Callable getDefaultStartPoint() {
		if (defaultStartPoint != null && defaultStartPoint.eIsProxy()) {
			InternalEObject oldDefaultStartPoint = (InternalEObject)defaultStartPoint;
			defaultStartPoint = (Callable)eResolveProxy(oldDefaultStartPoint);
			if (defaultStartPoint != oldDefaultStartPoint) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CallchainPackage.CALLS__DEFAULT_START_POINT, oldDefaultStartPoint, defaultStartPoint));
			}
		}
		return defaultStartPoint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Callable basicGetDefaultStartPoint() {
		return defaultStartPoint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDefaultStartPoint(Callable newDefaultStartPoint) {
		Callable oldDefaultStartPoint = defaultStartPoint;
		defaultStartPoint = newDefaultStartPoint;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALLS__DEFAULT_START_POINT, oldDefaultStartPoint, defaultStartPoint));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isLogDefault() {
		return logDefault;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLogDefault(boolean newLogDefault) {
		boolean oldLogDefault = logDefault;
		logDefault = newLogDefault;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALLS__LOG_DEFAULT, oldLogDefault, logDefault));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Switch> getSwitches() {
		if (switches == null) {
			switches = new EObjectContainmentWithInverseEList<Switch>(Switch.class, this, CallchainPackage.CALLS__SWITCHES, CallchainPackage.SWITCH__ENVIORMENT);
		}
		return switches;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ExternalCallable> getExternCallables() {
		if (externCallables == null) {
			externCallables = new EObjectContainmentWithInverseEList<ExternalCallable>(ExternalCallable.class, this, CallchainPackage.CALLS__EXTERN_CALLABLES, CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT);
		}
		return externCallables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALLS__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<StopCall> getStopElements() {
		if (stopElements == null) {
			stopElements = new EObjectContainmentEList<StopCall>(StopCall.class, this, CallchainPackage.CALLS__STOP_ELEMENTS);
		}
		return stopElements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CallchainPackage.CALLS__COMMENTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getComments()).basicAdd(otherEnd, msgs);
			case CallchainPackage.CALLS__CALL:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getCall()).basicAdd(otherEnd, msgs);
			case CallchainPackage.CALLS__GENERATORS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getGenerators()).basicAdd(otherEnd, msgs);
			case CallchainPackage.CALLS__SWITCHES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getSwitches()).basicAdd(otherEnd, msgs);
			case CallchainPackage.CALLS__EXTERN_CALLABLES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getExternCallables()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CallchainPackage.CALLS__COMMENTS:
				return ((InternalEList<?>)getComments()).basicRemove(otherEnd, msgs);
			case CallchainPackage.CALLS__CALL:
				return ((InternalEList<?>)getCall()).basicRemove(otherEnd, msgs);
			case CallchainPackage.CALLS__GENERATORS:
				return ((InternalEList<?>)getGenerators()).basicRemove(otherEnd, msgs);
			case CallchainPackage.CALLS__ARTIFACTS:
				return ((InternalEList<?>)getArtifacts()).basicRemove(otherEnd, msgs);
			case CallchainPackage.CALLS__PROPERTIES:
				return ((InternalEList<?>)getProperties()).basicRemove(otherEnd, msgs);
			case CallchainPackage.CALLS__SWITCHES:
				return ((InternalEList<?>)getSwitches()).basicRemove(otherEnd, msgs);
			case CallchainPackage.CALLS__EXTERN_CALLABLES:
				return ((InternalEList<?>)getExternCallables()).basicRemove(otherEnd, msgs);
			case CallchainPackage.CALLS__STOP_ELEMENTS:
				return ((InternalEList<?>)getStopElements()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CallchainPackage.CALLS__COMMENTS:
				return getComments();
			case CallchainPackage.CALLS__CALL:
				return getCall();
			case CallchainPackage.CALLS__GENERATORS:
				return getGenerators();
			case CallchainPackage.CALLS__ARTIFACTS:
				return getArtifacts();
			case CallchainPackage.CALLS__PROPERTIES:
				return getProperties();
			case CallchainPackage.CALLS__DEFAULT_LIB:
				return getDefaultLib();
			case CallchainPackage.CALLS__DEFAULT_SUPER_IMPOSED:
				return getDefaultSuperImposed();
			case CallchainPackage.CALLS__START_POINTS:
				return getStartPoints();
			case CallchainPackage.CALLS__DEFAULT_START_POINT:
				if (resolve) return getDefaultStartPoint();
				return basicGetDefaultStartPoint();
			case CallchainPackage.CALLS__LOG_DEFAULT:
				return isLogDefault();
			case CallchainPackage.CALLS__SWITCHES:
				return getSwitches();
			case CallchainPackage.CALLS__EXTERN_CALLABLES:
				return getExternCallables();
			case CallchainPackage.CALLS__NAME:
				return getName();
			case CallchainPackage.CALLS__STOP_ELEMENTS:
				return getStopElements();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CallchainPackage.CALLS__COMMENTS:
				getComments().clear();
				getComments().addAll((Collection<? extends Comment>)newValue);
				return;
			case CallchainPackage.CALLS__CALL:
				getCall().clear();
				getCall().addAll((Collection<? extends Call>)newValue);
				return;
			case CallchainPackage.CALLS__GENERATORS:
				getGenerators().clear();
				getGenerators().addAll((Collection<? extends Generator>)newValue);
				return;
			case CallchainPackage.CALLS__ARTIFACTS:
				getArtifacts().clear();
				getArtifacts().addAll((Collection<? extends Artifact>)newValue);
				return;
			case CallchainPackage.CALLS__PROPERTIES:
				getProperties().clear();
				getProperties().addAll((Collection<? extends Property>)newValue);
				return;
			case CallchainPackage.CALLS__DEFAULT_LIB:
				getDefaultLib().clear();
				getDefaultLib().addAll((Collection<? extends AtlLibary>)newValue);
				return;
			case CallchainPackage.CALLS__DEFAULT_SUPER_IMPOSED:
				getDefaultSuperImposed().clear();
				getDefaultSuperImposed().addAll((Collection<? extends AtlRes>)newValue);
				return;
			case CallchainPackage.CALLS__START_POINTS:
				getStartPoints().clear();
				getStartPoints().addAll((Collection<? extends Callable>)newValue);
				return;
			case CallchainPackage.CALLS__DEFAULT_START_POINT:
				setDefaultStartPoint((Callable)newValue);
				return;
			case CallchainPackage.CALLS__LOG_DEFAULT:
				setLogDefault((Boolean)newValue);
				return;
			case CallchainPackage.CALLS__SWITCHES:
				getSwitches().clear();
				getSwitches().addAll((Collection<? extends Switch>)newValue);
				return;
			case CallchainPackage.CALLS__EXTERN_CALLABLES:
				getExternCallables().clear();
				getExternCallables().addAll((Collection<? extends ExternalCallable>)newValue);
				return;
			case CallchainPackage.CALLS__NAME:
				setName((String)newValue);
				return;
			case CallchainPackage.CALLS__STOP_ELEMENTS:
				getStopElements().clear();
				getStopElements().addAll((Collection<? extends StopCall>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CallchainPackage.CALLS__COMMENTS:
				getComments().clear();
				return;
			case CallchainPackage.CALLS__CALL:
				getCall().clear();
				return;
			case CallchainPackage.CALLS__GENERATORS:
				getGenerators().clear();
				return;
			case CallchainPackage.CALLS__ARTIFACTS:
				getArtifacts().clear();
				return;
			case CallchainPackage.CALLS__PROPERTIES:
				getProperties().clear();
				return;
			case CallchainPackage.CALLS__DEFAULT_LIB:
				getDefaultLib().clear();
				return;
			case CallchainPackage.CALLS__DEFAULT_SUPER_IMPOSED:
				getDefaultSuperImposed().clear();
				return;
			case CallchainPackage.CALLS__START_POINTS:
				getStartPoints().clear();
				return;
			case CallchainPackage.CALLS__DEFAULT_START_POINT:
				setDefaultStartPoint((Callable)null);
				return;
			case CallchainPackage.CALLS__LOG_DEFAULT:
				setLogDefault(LOG_DEFAULT_EDEFAULT);
				return;
			case CallchainPackage.CALLS__SWITCHES:
				getSwitches().clear();
				return;
			case CallchainPackage.CALLS__EXTERN_CALLABLES:
				getExternCallables().clear();
				return;
			case CallchainPackage.CALLS__NAME:
				setName(NAME_EDEFAULT);
				return;
			case CallchainPackage.CALLS__STOP_ELEMENTS:
				getStopElements().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CallchainPackage.CALLS__COMMENTS:
				return comments != null && !comments.isEmpty();
			case CallchainPackage.CALLS__CALL:
				return call != null && !call.isEmpty();
			case CallchainPackage.CALLS__GENERATORS:
				return generators != null && !generators.isEmpty();
			case CallchainPackage.CALLS__ARTIFACTS:
				return artifacts != null && !artifacts.isEmpty();
			case CallchainPackage.CALLS__PROPERTIES:
				return properties != null && !properties.isEmpty();
			case CallchainPackage.CALLS__DEFAULT_LIB:
				return defaultLib != null && !defaultLib.isEmpty();
			case CallchainPackage.CALLS__DEFAULT_SUPER_IMPOSED:
				return defaultSuperImposed != null && !defaultSuperImposed.isEmpty();
			case CallchainPackage.CALLS__START_POINTS:
				return startPoints != null && !startPoints.isEmpty();
			case CallchainPackage.CALLS__DEFAULT_START_POINT:
				return defaultStartPoint != null;
			case CallchainPackage.CALLS__LOG_DEFAULT:
				return logDefault != LOG_DEFAULT_EDEFAULT;
			case CallchainPackage.CALLS__SWITCHES:
				return switches != null && !switches.isEmpty();
			case CallchainPackage.CALLS__EXTERN_CALLABLES:
				return externCallables != null && !externCallables.isEmpty();
			case CallchainPackage.CALLS__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case CallchainPackage.CALLS__STOP_ELEMENTS:
				return stopElements != null && !stopElements.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (logDefault: ");
		result.append(logDefault);
		result.append(", name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

	@Override
	public boolean inSubtitutionMode() {
		return subtitutionMode;
	}

	@Override
	public void setSubtitutionMode(boolean subtitutionMode) {
		this.subtitutionMode = subtitutionMode;
	}
	
} //CallsImpl
