/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings;
import org.eclipse.jface.viewers.ViewerFilter;



/**
 * @author Urs Zeidler
 * @generated
 */
public interface CallPropertiesEditionPart {

	/**
	 * @return the name
	 * @generated
	 */
	public String getName();

	/**
	 * Defines a new name
	 * @param newValue the new name to set
	 * @generated
	 */
	public void setName(String newValue);


	/**
	 * @return the res
	 * @generated
	 */
	public EObject getRes();

	/**
	 * Init the res
	 * @param settings the combo setting
	 */
	public void initRes(EObjectFlatComboSettings settings);

	/**
	 * Defines a new res
	 * @param newValue the new res to set
	 * @generated
	 */
	public void setRes(EObject newValue);

	/**
	 * Defines the button mode
	 * @param newValue the new mode to set
	 * @generated
	 */
	public void setResButtonMode(ButtonsModeEnum newValue);

	/**
	 * Adds the given filter to the res edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToRes(ViewerFilter filter);

	/**
	 * Adds the given filter to the res edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToRes(ViewerFilter filter);


	/**
   * @return the predicate
   * @generated
   */
  public EObject getPredicate();

  /**
   * Init the predicate
   * @param settings the combo setting
   */
  public void initPredicate(EObjectFlatComboSettings settings);

  /**
   * Defines a new predicate
   * @param newValue the new predicate to set
   * @generated
   */
  public void setPredicate(EObject newValue);

  /**
   * Defines the button mode
   * @param newValue the new mode to set
   * @generated
   */
  public void setPredicateButtonMode(ButtonsModeEnum newValue);

  /**
   * Adds the given filter to the predicate edition editor.
   * 
   * @param filter
   *            a viewer filter
   * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
   * @generated
   */
  public void addFilterToPredicate(ViewerFilter filter);

  /**
   * Adds the given filter to the predicate edition editor.
   * 
   * @param filter
   *            a viewer filter
   * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
   * @generated
   */
  public void addBusinessFilterToPredicate(ViewerFilter filter);

  /**
	 * @return the next
	 * @generated
	 */
	public EObject getNext();

	/**
	 * Init the next
	 * @param settings the combo setting
	 */
	public void initNext(EObjectFlatComboSettings settings);

	/**
	 * Defines a new next
	 * @param newValue the new next to set
	 * @generated
	 */
	public void setNext(EObject newValue);

	/**
	 * Defines the button mode
	 * @param newValue the new mode to set
	 * @generated
	 */
	public void setNextButtonMode(ButtonsModeEnum newValue);

	/**
	 * Adds the given filter to the next edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToNext(ViewerFilter filter);

	/**
	 * Adds the given filter to the next edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToNext(ViewerFilter filter);




	/**
	 * Init the in
	 * @param settings settings for the in ReferencesTable 
	 */
	public void initIn(ReferencesTableSettings settings);

	/**
	 * Update the in
	 * @param newValue the in to update
	 * @generated
	 */
	public void updateIn();

	/**
	 * Adds the given filter to the in edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToIn(ViewerFilter filter);

	/**
	 * Adds the given filter to the in edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToIn(ViewerFilter filter);

	/**
	 * @return true if the given element is contained inside the in table
	 * @generated
	 */
	public boolean isContainedInInTable(EObject element);




	/**
	 * Init the out
	 * @param settings settings for the out ReferencesTable 
	 */
	public void initOut(ReferencesTableSettings settings);

	/**
	 * Update the out
	 * @param newValue the out to update
	 * @generated
	 */
	public void updateOut();

	/**
	 * Adds the given filter to the out edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToOut(ViewerFilter filter);

	/**
	 * Adds the given filter to the out edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToOut(ViewerFilter filter);

	/**
	 * @return true if the given element is contained inside the out table
	 * @generated
	 */
	public boolean isContainedInOutTable(EObject element);


	/**
	 * @return the artifact
	 * @generated
	 */
	public EObject getArtifact();

	/**
	 * Init the artifact
	 * @param settings the combo setting
	 */
	public void initArtifact(EObjectFlatComboSettings settings);

	/**
	 * Defines a new artifact
	 * @param newValue the new artifact to set
	 * @generated
	 */
	public void setArtifact(EObject newValue);

	/**
	 * Defines the button mode
	 * @param newValue the new mode to set
	 * @generated
	 */
	public void setArtifactButtonMode(ButtonsModeEnum newValue);

	/**
	 * Adds the given filter to the artifact edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToArtifact(ViewerFilter filter);

	/**
	 * Adds the given filter to the artifact edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToArtifact(ViewerFilter filter);




	/**
	 * Init the libarys
	 * @param settings settings for the libarys ReferencesTable 
	 */
	public void initLibarys(ReferencesTableSettings settings);

	/**
	 * Update the libarys
	 * @param newValue the libarys to update
	 * @generated
	 */
	public void updateLibarys();

	/**
	 * Adds the given filter to the libarys edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToLibarys(ViewerFilter filter);

	/**
	 * Adds the given filter to the libarys edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToLibarys(ViewerFilter filter);

	/**
	 * @return true if the given element is contained inside the libarys table
	 * @generated
	 */
	public boolean isContainedInLibarysTable(EObject element);


	/**
	 * @return the allowInterModelReferences
	 * @generated
	 */
	public Boolean getAllowInterModelReferences();

	/**
	 * Defines a new allowInterModelReferences
	 * @param newValue the new allowInterModelReferences to set
	 * @generated
	 */
	public void setAllowInterModelReferences(Boolean newValue);


	/**
	 * @return the continueAfterErrors
	 * @generated
	 */
	public Boolean getContinueAfterErrors();

	/**
	 * Defines a new continueAfterErrors
	 * @param newValue the new continueAfterErrors to set
	 * @generated
	 */
	public void setContinueAfterErrors(Boolean newValue);


	/**
	 * @return the showSummary
	 * @generated
	 */
	public Boolean getShowSummary();

	/**
	 * Defines a new showSummary
	 * @param newValue the new showSummary to set
	 * @generated
	 */
	public void setShowSummary(Boolean newValue);


	/**
	 * @return the printExecutionTime
	 * @generated
	 */
	public Boolean getPrintExecutionTime();

	/**
	 * Defines a new printExecutionTime
	 * @param newValue the new printExecutionTime to set
	 * @generated
	 */
	public void setPrintExecutionTime(Boolean newValue);


	/**
	 * @return the disableAttributeHelperCache
	 * @generated
	 */
	public Boolean getDisableAttributeHelperCache();

	/**
	 * Defines a new disableAttributeHelperCache
	 * @param newValue the new disableAttributeHelperCache to set
	 * @generated
	 */
	public void setDisableAttributeHelperCache(Boolean newValue);


	/**
	 * @return the profile
	 * @generated
	 */
	public Boolean getProfile();

	/**
	 * Defines a new profile
	 * @param newValue the new profile to set
	 * @generated
	 */
	public void setProfile(Boolean newValue);





	/**
   * @return the refreshWorkspace
   * @generated
   */
  public Boolean getRefreshWorkspace();

  /**
   * Defines a new refreshWorkspace
   * @param newValue the new refreshWorkspace to set
   * @generated
   */
  public void setRefreshWorkspace(Boolean newValue);

  /**
	 * Returns the internationalized title text.
	 * 
	 * @return the internationalized title text.
	 * @generated
	 */
	public String getTitle();


}
