/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings;
import org.eclipse.jface.viewers.ViewerFilter;



/**
 * @author Urs Zeidler
 * @generated
 */
public interface CallsPropertiesEditionPart {

	/**
   * @return the name
   * @generated
   */
  public String getName();

  /**
   * Defines a new name
   * @param newValue the new name to set
   * @generated
   */
  public void setName(String newValue);

  /**
	 * @return the defaultStartPoint
	 * @generated
	 */
	public EObject getDefaultStartPoint();

	/**
	 * Init the defaultStartPoint
	 * @param settings the combo setting
	 */
	public void initDefaultStartPoint(EObjectFlatComboSettings settings);

	/**
	 * Defines a new defaultStartPoint
	 * @param newValue the new defaultStartPoint to set
	 * @generated
	 */
	public void setDefaultStartPoint(EObject newValue);

	/**
	 * Defines the button mode
	 * @param newValue the new mode to set
	 * @generated
	 */
	public void setDefaultStartPointButtonMode(ButtonsModeEnum newValue);

	/**
	 * Adds the given filter to the defaultStartPoint edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToDefaultStartPoint(ViewerFilter filter);

	/**
	 * Adds the given filter to the defaultStartPoint edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToDefaultStartPoint(ViewerFilter filter);




	/**
	 * Init the startPoints
	 * @param settings settings for the startPoints ReferencesTable 
	 */
	public void initStartPoints(ReferencesTableSettings settings);

	/**
	 * Update the startPoints
	 * @param newValue the startPoints to update
	 * @generated
	 */
	public void updateStartPoints();

	/**
	 * Adds the given filter to the startPoints edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToStartPoints(ViewerFilter filter);

	/**
	 * Adds the given filter to the startPoints edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToStartPoints(ViewerFilter filter);

	/**
	 * @return true if the given element is contained inside the startPoints table
	 * @generated
	 */
	public boolean isContainedInStartPointsTable(EObject element);




	/**
	 * Init the properties
	 * @param current the current value
	 * @param containgFeature the feature where to navigate if necessary
	 * @param feature the feature to manage
	 */
	public void initProperties(ReferencesTableSettings settings);

	/**
	 * Update the properties
	 * @param newValue the properties to update
	 * @generated
	 */
	public void updateProperties();

	/**
	 * Adds the given filter to the properties edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToProperties(ViewerFilter filter);

	/**
	 * Adds the given filter to the properties edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToProperties(ViewerFilter filter);

	/**
	 * @return true if the given element is contained inside the properties table
	 * @generated
	 */
	public boolean isContainedInPropertiesTable(EObject element);




	/**
	 * Init the defaultLib
	 * @param settings settings for the defaultLib ReferencesTable 
	 */
	public void initDefaultLib(ReferencesTableSettings settings);

	/**
	 * Update the defaultLib
	 * @param newValue the defaultLib to update
	 * @generated
	 */
	public void updateDefaultLib();

	/**
	 * Adds the given filter to the defaultLib edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToDefaultLib(ViewerFilter filter);

	/**
	 * Adds the given filter to the defaultLib edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToDefaultLib(ViewerFilter filter);

	/**
	 * @return true if the given element is contained inside the defaultLib table
	 * @generated
	 */
	public boolean isContainedInDefaultLibTable(EObject element);




	/**
	 * Init the defaultSuperImposed
	 * @param settings settings for the defaultSuperImposed ReferencesTable 
	 */
	public void initDefaultSuperImposed(ReferencesTableSettings settings);

	/**
	 * Update the defaultSuperImposed
	 * @param newValue the defaultSuperImposed to update
	 * @generated
	 */
	public void updateDefaultSuperImposed();

	/**
	 * Adds the given filter to the defaultSuperImposed edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToDefaultSuperImposed(ViewerFilter filter);

	/**
	 * Adds the given filter to the defaultSuperImposed edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToDefaultSuperImposed(ViewerFilter filter);

	/**
	 * @return true if the given element is contained inside the defaultSuperImposed table
	 * @generated
	 */
	public boolean isContainedInDefaultSuperImposedTable(EObject element);


	/**
	 * @return the logDefault
	 * @generated
	 */
	public Boolean getLogDefault();

	/**
	 * Defines a new logDefault
	 * @param newValue the new logDefault to set
	 * @generated
	 */
	public void setLogDefault(Boolean newValue);





	/**
	 * Returns the internationalized title text.
	 * 
	 * @return the internationalized title text.
	 * @generated
	 */
	public String getTitle();


}
