/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.forms;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.widgets.ReferencesTable;
import org.eclipse.emf.eef.runtime.ui.widgets.ReferencesTable.ReferencesTableListener;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableContentProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class AndPredicatePropertiesEditionPartForm extends CompositePropertiesEditionPart implements IFormPropertiesEditionPart, AndPredicatePropertiesEditionPart {

	protected ReferencesTable predicates;
	protected List<ViewerFilter> predicatesBusinessFilters = new ArrayList<ViewerFilter>();
	protected List<ViewerFilter> predicatesFilters = new ArrayList<ViewerFilter>();



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public AndPredicatePropertiesEditionPartForm(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createFigure(org.eclipse.swt.widgets.Composite, org.eclipse.ui.forms.widgets.FormToolkit)
	 * @generated
	 */
	public Composite createFigure(final Composite parent, final FormToolkit widgetFactory) {
    ScrolledForm scrolledForm = widgetFactory.createScrolledForm(parent);
    Form form = scrolledForm.getForm();
    view = form.getBody();
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(widgetFactory, view);
    return scrolledForm;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createControls(org.eclipse.ui.forms.widgets.FormToolkit, org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(final FormToolkit widgetFactory, Composite view) {
    CompositionSequence andPredicateStep = new BindingCompositionSequence(propertiesEditionComponent);
    andPredicateStep
      .addStep(CallchainViewsRepository.AndPredicate.Properties.class)
      .addStep(CallchainViewsRepository.AndPredicate.Properties.predicates);
    
    
    composer = new PartComposer(andPredicateStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.AndPredicate.Properties.class) {
          return createPropertiesGroup(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.AndPredicate.Properties.predicates) {
          return createPredicatesTableComposition(widgetFactory, parent);
        }
        return parent;
      }
    };
    composer.compose(view);
  }
	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(FormToolkit widgetFactory, final Composite parent) {
    Section propertiesSection = widgetFactory.createSection(parent, Section.TITLE_BAR | Section.TWISTIE | Section.EXPANDED);
    propertiesSection.setText(CallchainMessages.AndPredicatePropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesSectionData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesSectionData.horizontalSpan = 3;
    propertiesSection.setLayoutData(propertiesSectionData);
    Composite propertiesGroup = widgetFactory.createComposite(propertiesSection);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    propertiesSection.setClient(propertiesGroup);
    return propertiesGroup;
  }

	/**
	 * @param container
	 * @generated
	 */
	protected Composite createPredicatesTableComposition(FormToolkit widgetFactory, Composite parent) {
    this.predicates = new ReferencesTable(CallchainMessages.AndPredicatePropertiesEditionPart_PredicatesLabel, new ReferencesTableListener() {
      public void handleAdd() {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(AndPredicatePropertiesEditionPartForm.this, CallchainViewsRepository.AndPredicate.Properties.predicates, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, null));
        predicates.refresh();
      }
      public void handleEdit(EObject element) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(AndPredicatePropertiesEditionPartForm.this, CallchainViewsRepository.AndPredicate.Properties.predicates, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.EDIT, null, element));
        predicates.refresh();
      }
      public void handleMove(EObject element, int oldIndex, int newIndex) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(AndPredicatePropertiesEditionPartForm.this, CallchainViewsRepository.AndPredicate.Properties.predicates, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.MOVE, element, newIndex));
        predicates.refresh();
      }
      public void handleRemove(EObject element) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(AndPredicatePropertiesEditionPartForm.this, CallchainViewsRepository.AndPredicate.Properties.predicates, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.REMOVE, null, element));
        predicates.refresh();
      }
      public void navigateTo(EObject element) { }
    });
    for (ViewerFilter filter : this.predicatesFilters) {
      this.predicates.addFilter(filter);
    }
    this.predicates.setHelpText(propertiesEditionComponent.getHelpContent(CallchainViewsRepository.AndPredicate.Properties.predicates, CallchainViewsRepository.FORM_KIND));
    this.predicates.createControls(parent, widgetFactory);
    this.predicates.addSelectionListener(new SelectionAdapter() {
      
      public void widgetSelected(SelectionEvent e) {
        if (e.item != null && e.item.getData() instanceof EObject) {
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(AndPredicatePropertiesEditionPartForm.this, CallchainViewsRepository.AndPredicate.Properties.predicates, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SELECTION_CHANGED, null, e.item.getData()));
        }
      }
      
    });
    GridData predicatesData = new GridData(GridData.FILL_HORIZONTAL);
    predicatesData.horizontalSpan = 3;
    this.predicates.setLayoutData(predicatesData);
    this.predicates.setLowerBound(1);
    this.predicates.setUpperBound(-1);
    predicates.setID(CallchainViewsRepository.AndPredicate.Properties.predicates);
    predicates.setEEFType("eef::AdvancedTableComposition"); //$NON-NLS-1$
    return parent;
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart#initPredicates(EObject current, EReference containingFeature, EReference feature)
	 */
	public void initPredicates(ReferencesTableSettings settings) {
		if (current.eResource() != null && current.eResource().getResourceSet() != null)
			this.resourceSet = current.eResource().getResourceSet();
		ReferencesTableContentProvider contentProvider = new ReferencesTableContentProvider();
		predicates.setContentProvider(contentProvider);
		predicates.setInput(settings);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart#updatePredicates()
	 * @generated
	 */
	public void updatePredicates() {
  predicates.refresh();
}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart#addFilterPredicates(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToPredicates(ViewerFilter filter) {
    predicatesFilters.add(filter);
    if (this.predicates != null) {
      this.predicates.addFilter(filter);
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart#addBusinessFilterPredicates(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToPredicates(ViewerFilter filter) {
    predicatesBusinessFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart#isContainedInPredicatesTable(EObject element)
	 * @generated
	 */
	public boolean isContainedInPredicatesTable(EObject element) {
    return ((ReferencesTableSettings)predicates.getInput()).contains(element);
  }




	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.AndPredicate_Part_Title;
  }



}
