/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.forms;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.utils.EditingUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.EObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.FormUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.MMAliasPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class MMAliasPropertiesEditionPartForm extends CompositePropertiesEditionPart implements IFormPropertiesEditionPart, MMAliasPropertiesEditionPart {

	protected Text aliasName;
	protected EObjectFlatComboViewer decoratedmodel;



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public MMAliasPropertiesEditionPartForm(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createFigure(org.eclipse.swt.widgets.Composite, org.eclipse.ui.forms.widgets.FormToolkit)
	 * @generated
	 */
	public Composite createFigure(final Composite parent, final FormToolkit widgetFactory) {
    ScrolledForm scrolledForm = widgetFactory.createScrolledForm(parent);
    Form form = scrolledForm.getForm();
    view = form.getBody();
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(widgetFactory, view);
    return scrolledForm;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createControls(org.eclipse.ui.forms.widgets.FormToolkit, org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(final FormToolkit widgetFactory, Composite view) {
    CompositionSequence mMAliasStep = new BindingCompositionSequence(propertiesEditionComponent);
    CompositionStep propertiesStep = mMAliasStep.addStep(CallchainViewsRepository.MMAlias.Properties.class);
    propertiesStep.addStep(CallchainViewsRepository.MMAlias.Properties.aliasName);
    propertiesStep.addStep(CallchainViewsRepository.MMAlias.Properties.decoratedmodel);
    
    
    composer = new PartComposer(mMAliasStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.MMAlias.Properties.class) {
          return createPropertiesGroup(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.MMAlias.Properties.aliasName) {
          return 		createAliasNameText(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.MMAlias.Properties.decoratedmodel) {
          return createDecoratedmodelFlatComboViewer(parent, widgetFactory);
        }
        return parent;
      }
    };
    composer.compose(view);
  }
	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(FormToolkit widgetFactory, final Composite parent) {
    Section propertiesSection = widgetFactory.createSection(parent, Section.TITLE_BAR | Section.TWISTIE | Section.EXPANDED);
    propertiesSection.setText(CallchainMessages.MMAliasPropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesSectionData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesSectionData.horizontalSpan = 3;
    propertiesSection.setLayoutData(propertiesSectionData);
    Composite propertiesGroup = widgetFactory.createComposite(propertiesSection);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    propertiesSection.setClient(propertiesGroup);
    return propertiesGroup;
  }

	/**
	 * @generated
	 */
	
	protected Composite createAliasNameText(FormToolkit widgetFactory, Composite parent) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.MMAliasPropertiesEditionPart_AliasNameLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.MMAlias.Properties.aliasName, CallchainViewsRepository.FORM_KIND));
    aliasName = widgetFactory.createText(parent, ""); //$NON-NLS-1$
    aliasName.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
    widgetFactory.paintBordersFor(parent);
    GridData aliasNameData = new GridData(GridData.FILL_HORIZONTAL);
    aliasName.setLayoutData(aliasNameData);
    aliasName.addFocusListener(new FocusAdapter() {
      /**
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(MMAliasPropertiesEditionPartForm.this, CallchainViewsRepository.MMAlias.Properties.aliasName, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, aliasName.getText()));
      }
    });
    aliasName.addKeyListener(new KeyAdapter() {
      /**
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(MMAliasPropertiesEditionPartForm.this, CallchainViewsRepository.MMAlias.Properties.aliasName, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, aliasName.getText()));
        }
      }
    });
    EditingUtils.setID(aliasName, CallchainViewsRepository.MMAlias.Properties.aliasName);
    EditingUtils.setEEFtype(aliasName, "eef::Text"); //$NON-NLS-1$
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.MMAlias.Properties.aliasName, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @param parent the parent composite
	 * @param widgetFactory factory to use to instanciante widget of the form
	 * @generated
	 */
	protected Composite createDecoratedmodelFlatComboViewer(Composite parent, FormToolkit widgetFactory) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.MMAliasPropertiesEditionPart_DecoratedmodelLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.MMAlias.Properties.decoratedmodel, CallchainViewsRepository.FORM_KIND));
    decoratedmodel = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.MMAlias.Properties.decoratedmodel, CallchainViewsRepository.FORM_KIND));
    widgetFactory.adapt(decoratedmodel);
    decoratedmodel.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));
    GridData decoratedmodelData = new GridData(GridData.FILL_HORIZONTAL);
    decoratedmodel.setLayoutData(decoratedmodelData);
    decoratedmodel.addSelectionChangedListener(new ISelectionChangedListener() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.jface.viewers.ISelectionChangedListener#selectionChanged(org.eclipse.jface.viewers.SelectionChangedEvent)
       */
      public void selectionChanged(SelectionChangedEvent event) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(MMAliasPropertiesEditionPartForm.this, CallchainViewsRepository.MMAlias.Properties.decoratedmodel, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, getDecoratedmodel()));
      }

    });
    decoratedmodel.setID(CallchainViewsRepository.MMAlias.Properties.decoratedmodel);
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.MMAlias.Properties.decoratedmodel, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMAliasPropertiesEditionPart#getAliasName()
	 * @generated
	 */
	public String getAliasName() {
    return aliasName.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMAliasPropertiesEditionPart#setAliasName(String newValue)
	 * @generated
	 */
	public void setAliasName(String newValue) {
    if (newValue != null) {
      aliasName.setText(newValue);
    } else {
      aliasName.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMAliasPropertiesEditionPart#getDecoratedmodel()
	 * @generated
	 */
	public EObject getDecoratedmodel() {
    if (decoratedmodel.getSelection() instanceof StructuredSelection) {
      Object firstElement = ((StructuredSelection) decoratedmodel.getSelection()).getFirstElement();
      if (firstElement instanceof EObject)
        return (EObject) firstElement;
    }
    return null;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMAliasPropertiesEditionPart#initDecoratedmodel(EObjectFlatComboSettings)
	 */
	public void initDecoratedmodel(EObjectFlatComboSettings settings) {
		decoratedmodel.setInput(settings);
		if (current != null) {
			decoratedmodel.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMAliasPropertiesEditionPart#setDecoratedmodel(EObject newValue)
	 * @generated
	 */
	public void setDecoratedmodel(EObject newValue) {
    if (newValue != null) {
      decoratedmodel.setSelection(new StructuredSelection(newValue));
    } else {
      decoratedmodel.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMAliasPropertiesEditionPart#setDecoratedmodelButtonMode(ButtonsModeEnum newValue)
	 */
	public void setDecoratedmodelButtonMode(ButtonsModeEnum newValue) {
		decoratedmodel.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMAliasPropertiesEditionPart#addFilterDecoratedmodel(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToDecoratedmodel(ViewerFilter filter) {
    decoratedmodel.addFilter(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMAliasPropertiesEditionPart#addBusinessFilterDecoratedmodel(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToDecoratedmodel(ViewerFilter filter) {
    decoratedmodel.addBusinessRuleFilter(filter);
  }




	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.MMAlias_Part_Title;
  }



}
