/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.forms;

import java.util.Arrays;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EEnumLiteral;
import org.eclipse.emf.ecore.presentation.EcoreActionBarContributor.ExtendedLoadResourceAction.ExtendedLoadResourceDialog;
import org.eclipse.emf.ecore.presentation.EcoreActionBarContributor.ExtendedLoadResourceAction.RegisteredPackageDialog;
import org.eclipse.emf.ecore.util.EcoreAdapterFactory;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.utils.EditingUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.EMFComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.FormUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.SelectionDialog;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.MMPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class MMPropertiesEditionPartForm extends CompositePropertiesEditionPart implements IFormPropertiesEditionPart, MMPropertiesEditionPart {

	protected Text name;
	protected SelectionDialog uri;
	protected EMFComboViewer handler;



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public MMPropertiesEditionPartForm(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createFigure(org.eclipse.swt.widgets.Composite, org.eclipse.ui.forms.widgets.FormToolkit)
	 * @generated
	 */
	public Composite createFigure(final Composite parent, final FormToolkit widgetFactory) {
    ScrolledForm scrolledForm = widgetFactory.createScrolledForm(parent);
    Form form = scrolledForm.getForm();
    view = form.getBody();
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(widgetFactory, view);
    return scrolledForm;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createControls(org.eclipse.ui.forms.widgets.FormToolkit, org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(final FormToolkit widgetFactory, Composite view) {
    CompositionSequence mMStep = new BindingCompositionSequence(propertiesEditionComponent);
    CompositionStep propertiesStep = mMStep.addStep(CallchainViewsRepository.MM.Properties.class);
    propertiesStep.addStep(CallchainViewsRepository.MM.Properties.name);
    propertiesStep.addStep(CallchainViewsRepository.MM.Properties.uri);
    propertiesStep.addStep(CallchainViewsRepository.MM.Properties.handler);
    
    
    composer = new PartComposer(mMStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.MM.Properties.class) {
          return createPropertiesGroup(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.MM.Properties.name) {
          return 		createNameText(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.MM.Properties.uri) {
          return createUriSelectionDialog(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.MM.Properties.handler) {
          return createHandlerEMFComboViewer(widgetFactory, parent);
        }
        return parent;
      }
    };
    composer.compose(view);
  }
	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(FormToolkit widgetFactory, final Composite parent) {
    Section propertiesSection = widgetFactory.createSection(parent, Section.TITLE_BAR | Section.TWISTIE | Section.EXPANDED);
    propertiesSection.setText(CallchainMessages.MMPropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesSectionData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesSectionData.horizontalSpan = 3;
    propertiesSection.setLayoutData(propertiesSectionData);
    Composite propertiesGroup = widgetFactory.createComposite(propertiesSection);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    propertiesSection.setClient(propertiesGroup);
    return propertiesGroup;
  }

	/**
	 * @generated
	 */
	
	protected Composite createNameText(FormToolkit widgetFactory, Composite parent) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.MMPropertiesEditionPart_NameLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.MM.Properties.name, CallchainViewsRepository.FORM_KIND));
    name = widgetFactory.createText(parent, ""); //$NON-NLS-1$
    name.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
    widgetFactory.paintBordersFor(parent);
    GridData nameData = new GridData(GridData.FILL_HORIZONTAL);
    name.setLayoutData(nameData);
    name.addFocusListener(new FocusAdapter() {
      /**
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(MMPropertiesEditionPartForm.this, CallchainViewsRepository.MM.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
      }
    });
    name.addKeyListener(new KeyAdapter() {
      /**
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(MMPropertiesEditionPartForm.this, CallchainViewsRepository.MM.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
        }
      }
    });
    EditingUtils.setID(name, CallchainViewsRepository.MM.Properties.name);
    EditingUtils.setEEFtype(name, "eef::Text"); //$NON-NLS-1$
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.MM.Properties.name, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	
	protected Composite createUriSelectionDialog(FormToolkit widgetFactory, Composite parent) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.MMPropertiesEditionPart_UriLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.MM.Properties.uri, CallchainViewsRepository.FORM_KIND));
    uri = new SelectionDialog(parent, SWT.NONE, widgetFactory);

    GridData generatorData = new GridData(GridData.FILL_HORIZONTAL);
    uri.setLayoutData(generatorData);

    uri.addSelectionListener(new SelectionAdapter() {
      @Override
      public void widgetSelected(SelectionEvent e) {
          uriSelectionDialog();
      }
    });

    uri.addFocusListener(new FocusAdapter() {
      /**
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(MMPropertiesEditionPartForm.this, CallchainViewsRepository.MM.Properties.uri, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, uri.getText()));
      }
    });
    uri.addKeyListener(new KeyAdapter() {
      /**
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(MMPropertiesEditionPartForm.this, CallchainViewsRepository.MM.Properties.uri, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, uri.getText()));
        }
      }
    });
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.MM.Properties.uri, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

	protected void uriSelectionDialog() {
	//Start of user code browse button selection dialog
		if (PlatformUI.getWorkbench() != null && PlatformUI.getWorkbench().getActiveWorkbenchWindow() != null) {
			Shell theShell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
			
		       ExtendedLoadResourceDialog loadResourceDialog = new ExtendedLoadResourceDialog(
		                PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),
		                (EditingDomain) null) {

		            protected void prepareBrowseRegisteredPackagesButton(
		                    Button browseRegisteredPackagesButton) {
		                uriText = uri.getText();
		                browseRegisteredPackagesButton
		                        .addSelectionListener(new SelectionAdapter() {
		                            public void widgetSelected(SelectionEvent event) {
		                                RegisteredPackageDialog registeredPackageDialog = new RegisteredPackageDialog(
		                                        getShell());
		                                registeredPackageDialog.open();
		                                Object[] result = registeredPackageDialog
		                                        .getResult();
		                                if (result != null) {
		                                    List<?> nsURIs = Arrays.asList(result);
		                                    for (Object uri : nsURIs) {
		                                        uriField.setText((uriField.getText()
		                                                + "  uri:" + uri.toString())
		                                                .trim());
		                                    }
		                                }
		                            }
		                        });
		            }

		        };


		        int i = loadResourceDialog.open();

			
			
			
		//	IFile[] file = WorkspaceResourceDialog.openFileSelection(theShell, "File Selection", "", false, null, null);
			//if(file.length == 1) {
		     if (i == Window.OK){
		        uri.setText(loadResourceDialog.getURIText());
		    	 //uri.setText(file[0].getProject().getName() + "/" + file[0].getProjectRelativePath().toString());
				propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(MMPropertiesEditionPartForm.this, CallchainViewsRepository.MM.Properties.uri, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, uri.getText()));
			}
		}
	//End of user code
	}

	/**
	 * @generated
	 */
	
	protected Composite createHandlerEMFComboViewer(FormToolkit widgetFactory, Composite parent) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.MMPropertiesEditionPart_HandlerLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.MM.Properties.handler, CallchainViewsRepository.FORM_KIND));
    handler = new EMFComboViewer(parent);
    handler.setContentProvider(new ArrayContentProvider());
    handler.setLabelProvider(new AdapterFactoryLabelProvider(new EcoreAdapterFactory()));
    GridData handlerData = new GridData(GridData.FILL_HORIZONTAL);
    handler.getCombo().setLayoutData(handlerData);
    handler.addSelectionChangedListener(new ISelectionChangedListener() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.jface.viewers.ISelectionChangedListener#selectionChanged(org.eclipse.jface.viewers.SelectionChangedEvent)
       * 	@generated
       */
      public void selectionChanged(SelectionChangedEvent event) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(MMPropertiesEditionPartForm.this, CallchainViewsRepository.MM.Properties.handler, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, getHandler()));
      }

    });
    handler.setID(CallchainViewsRepository.MM.Properties.handler);
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.MM.Properties.handler, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMPropertiesEditionPart#getName()
	 * @generated
	 */
	public String getName() {
    return name.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMPropertiesEditionPart#setName(String newValue)
	 * @generated
	 */
	public void setName(String newValue) {
    if (newValue != null) {
      name.setText(newValue);
    } else {
      name.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMPropertiesEditionPart#getUri()
	 * @generated
	 */
	public String getUri() {
    return uri.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMPropertiesEditionPart#setUri(String newValue)
	 * @generated
	 */
	public void setUri(String newValue) {
    if (newValue != null) {
      uri.setText(newValue);
    } else {
      uri.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMPropertiesEditionPart#getHandler()
	 * @generated
	 */
	public Enumerator getHandler() {
    EEnumLiteral selection = (EEnumLiteral) ((StructuredSelection) handler.getSelection()).getFirstElement();
    return selection.getInstance();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMPropertiesEditionPart#initHandler(EEnum eenum, Enumerator current)
	 */
	public void initHandler(EEnum eenum, Enumerator current) {
		handler.setInput(eenum.getELiterals());
		handler.modelUpdating(new StructuredSelection(current));
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.MMPropertiesEditionPart#setHandler(Enumerator newValue)
	 * @generated
	 */
	public void setHandler(Enumerator newValue) {
    handler.modelUpdating(new StructuredSelection(newValue));
  }




	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.MM_Part_Title;
  }



}
