/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.forms;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.ui.dialogs.WorkspaceResourceDialog;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.utils.EditingUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.EObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.FormUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.SelectionDialog;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class ModelPropertiesEditionPartForm extends CompositePropertiesEditionPart implements IFormPropertiesEditionPart, ModelPropertiesEditionPart {

	protected Text name;
	protected SelectionDialog uri;
	protected EObjectFlatComboViewer mm;
	protected Button derived;
	protected Button isTemporary;



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public ModelPropertiesEditionPartForm(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createFigure(org.eclipse.swt.widgets.Composite, org.eclipse.ui.forms.widgets.FormToolkit)
	 * @generated
	 */
	public Composite createFigure(final Composite parent, final FormToolkit widgetFactory) {
    ScrolledForm scrolledForm = widgetFactory.createScrolledForm(parent);
    Form form = scrolledForm.getForm();
    view = form.getBody();
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(widgetFactory, view);
    return scrolledForm;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createControls(org.eclipse.ui.forms.widgets.FormToolkit, org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(final FormToolkit widgetFactory, Composite view) {
    CompositionSequence modelStep = new BindingCompositionSequence(propertiesEditionComponent);
    CompositionStep propertiesStep = modelStep.addStep(CallchainViewsRepository.Model.Properties.class);
    propertiesStep.addStep(CallchainViewsRepository.Model.Properties.name);
    propertiesStep.addStep(CallchainViewsRepository.Model.Properties.uri);
    propertiesStep.addStep(CallchainViewsRepository.Model.Properties.mm);
    propertiesStep.addStep(CallchainViewsRepository.Model.Properties.derived);
    propertiesStep.addStep(CallchainViewsRepository.Model.Properties.isTemporary);
    
    
    composer = new PartComposer(modelStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.Model.Properties.class) {
          return createPropertiesGroup(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.Model.Properties.name) {
          return 		createNameText(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.Model.Properties.uri) {
          return createUriSelectionDialog(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.Model.Properties.mm) {
          return createMmFlatComboViewer(parent, widgetFactory);
        }
        if (key == CallchainViewsRepository.Model.Properties.derived) {
          return createDerivedCheckbox(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.Model.Properties.isTemporary) {
          return createIsTemporaryCheckbox(widgetFactory, parent);
        }
        return parent;
      }
    };
    composer.compose(view);
  }
	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(FormToolkit widgetFactory, final Composite parent) {
    Section propertiesSection = widgetFactory.createSection(parent, Section.TITLE_BAR | Section.TWISTIE | Section.EXPANDED);
    propertiesSection.setText(CallchainMessages.ModelPropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesSectionData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesSectionData.horizontalSpan = 3;
    propertiesSection.setLayoutData(propertiesSectionData);
    Composite propertiesGroup = widgetFactory.createComposite(propertiesSection);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    propertiesSection.setClient(propertiesGroup);
    return propertiesGroup;
  }

	/**
	 * @generated
	 */
	
	protected Composite createNameText(FormToolkit widgetFactory, Composite parent) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.ModelPropertiesEditionPart_NameLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Model.Properties.name, CallchainViewsRepository.FORM_KIND));
    name = widgetFactory.createText(parent, ""); //$NON-NLS-1$
    name.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
    widgetFactory.paintBordersFor(parent);
    GridData nameData = new GridData(GridData.FILL_HORIZONTAL);
    name.setLayoutData(nameData);
    name.addFocusListener(new FocusAdapter() {
      /**
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelPropertiesEditionPartForm.this, CallchainViewsRepository.Model.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
      }
    });
    name.addKeyListener(new KeyAdapter() {
      /**
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelPropertiesEditionPartForm.this, CallchainViewsRepository.Model.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
        }
      }
    });
    EditingUtils.setID(name, CallchainViewsRepository.Model.Properties.name);
    EditingUtils.setEEFtype(name, "eef::Text"); //$NON-NLS-1$
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Model.Properties.name, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	
	protected Composite createUriSelectionDialog(FormToolkit widgetFactory, Composite parent) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.ModelPropertiesEditionPart_UriLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Model.Properties.uri, CallchainViewsRepository.FORM_KIND));
    uri = new SelectionDialog(parent, SWT.NONE, widgetFactory);

    GridData generatorData = new GridData(GridData.FILL_HORIZONTAL);
    uri.setLayoutData(generatorData);

    uri.addSelectionListener(new SelectionAdapter() {
      @Override
      public void widgetSelected(SelectionEvent e) {
          uriSelectionDialog();
      }
    });

    uri.addFocusListener(new FocusAdapter() {
      /**
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelPropertiesEditionPartForm.this, CallchainViewsRepository.Model.Properties.uri, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, uri.getText()));
      }
    });
    uri.addKeyListener(new KeyAdapter() {
      /**
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelPropertiesEditionPartForm.this, CallchainViewsRepository.Model.Properties.uri, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, uri.getText()));
        }
      }
    });
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Model.Properties.uri, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

	protected void uriSelectionDialog() {
	//Start of user code browse button selection dialog
		if (PlatformUI.getWorkbench() != null && PlatformUI.getWorkbench().getActiveWorkbenchWindow() != null) {
			Shell theShell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
			IFile[] file = WorkspaceResourceDialog.openFileSelection(theShell, "File Selection", "", false, null, null);
			if(file.length == 1) {
				uri.setText(file[0].getProject().getName() + "/" + file[0].getProjectRelativePath().toString());
				propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelPropertiesEditionPartForm.this, CallchainViewsRepository.Model.Properties.uri, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, uri.getText()));
			}
		}
	//End of user code
	}

	/**
	 * @param parent the parent composite
	 * @param widgetFactory factory to use to instanciante widget of the form
	 * @generated
	 */
	protected Composite createMmFlatComboViewer(Composite parent, FormToolkit widgetFactory) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.ModelPropertiesEditionPart_MmLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Model.Properties.mm, CallchainViewsRepository.FORM_KIND));
    mm = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.Model.Properties.mm, CallchainViewsRepository.FORM_KIND));
    widgetFactory.adapt(mm);
    mm.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));
    GridData mmData = new GridData(GridData.FILL_HORIZONTAL);
    mm.setLayoutData(mmData);
    mm.addSelectionChangedListener(new ISelectionChangedListener() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.jface.viewers.ISelectionChangedListener#selectionChanged(org.eclipse.jface.viewers.SelectionChangedEvent)
       */
      public void selectionChanged(SelectionChangedEvent event) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelPropertiesEditionPartForm.this, CallchainViewsRepository.Model.Properties.mm, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, getMm()));
      }

    });
    mm.setID(CallchainViewsRepository.Model.Properties.mm);
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Model.Properties.mm, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	
	protected Composite createDerivedCheckbox(FormToolkit widgetFactory, Composite parent) {
    derived = widgetFactory.createButton(parent, CallchainMessages.ModelPropertiesEditionPart_DerivedLabel, SWT.CHECK);
    derived.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelPropertiesEditionPartForm.this, CallchainViewsRepository.Model.Properties.derived, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(derived.getSelection())));
      }

    });
    GridData derivedData = new GridData(GridData.FILL_HORIZONTAL);
    derivedData.horizontalSpan = 2;
    derived.setLayoutData(derivedData);
    EditingUtils.setID(derived, CallchainViewsRepository.Model.Properties.derived);
    EditingUtils.setEEFtype(derived, "eef::Checkbox"); //$NON-NLS-1$
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Model.Properties.derived, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	
	protected Composite createIsTemporaryCheckbox(FormToolkit widgetFactory, Composite parent) {
    isTemporary = widgetFactory.createButton(parent, CallchainMessages.ModelPropertiesEditionPart_IsTemporaryLabel, SWT.CHECK);
    isTemporary.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelPropertiesEditionPartForm.this, CallchainViewsRepository.Model.Properties.isTemporary, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(isTemporary.getSelection())));
      }

    });
    GridData isTemporaryData = new GridData(GridData.FILL_HORIZONTAL);
    isTemporaryData.horizontalSpan = 2;
    isTemporary.setLayoutData(isTemporaryData);
    EditingUtils.setID(isTemporary, CallchainViewsRepository.Model.Properties.isTemporary);
    EditingUtils.setEEFtype(isTemporary, "eef::Checkbox"); //$NON-NLS-1$
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Model.Properties.isTemporary, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#getName()
	 * @generated
	 */
	public String getName() {
    return name.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#setName(String newValue)
	 * @generated
	 */
	public void setName(String newValue) {
    if (newValue != null) {
      name.setText(newValue);
    } else {
      name.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#getUri()
	 * @generated
	 */
	public String getUri() {
    return uri.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#setUri(String newValue)
	 * @generated
	 */
	public void setUri(String newValue) {
    if (newValue != null) {
      uri.setText(newValue);
    } else {
      uri.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#getMm()
	 * @generated
	 */
	public EObject getMm() {
    if (mm.getSelection() instanceof StructuredSelection) {
      Object firstElement = ((StructuredSelection) mm.getSelection()).getFirstElement();
      if (firstElement instanceof EObject)
        return (EObject) firstElement;
    }
    return null;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#initMm(EObjectFlatComboSettings)
	 */
	public void initMm(EObjectFlatComboSettings settings) {
		mm.setInput(settings);
		if (current != null) {
			mm.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#setMm(EObject newValue)
	 * @generated
	 */
	public void setMm(EObject newValue) {
    if (newValue != null) {
      mm.setSelection(new StructuredSelection(newValue));
    } else {
      mm.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#setMmButtonMode(ButtonsModeEnum newValue)
	 */
	public void setMmButtonMode(ButtonsModeEnum newValue) {
		mm.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#addFilterMm(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToMm(ViewerFilter filter) {
    mm.addFilter(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#addBusinessFilterMm(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToMm(ViewerFilter filter) {
    mm.addBusinessRuleFilter(filter);
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#getDerived()
	 * @generated
	 */
	public Boolean getDerived() {
    return Boolean.valueOf(derived.getSelection());
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#setDerived(Boolean newValue)
	 * @generated
	 */
	public void setDerived(Boolean newValue) {
    if (newValue != null) {
      derived.setSelection(newValue.booleanValue());
    } else {
      derived.setSelection(false);
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#getIsTemporary()
	 * @generated
	 */
	public Boolean getIsTemporary() {
    return Boolean.valueOf(isTemporary.getSelection());
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelPropertiesEditionPart#setIsTemporary(Boolean newValue)
	 * @generated
	 */
	public void setIsTemporary(Boolean newValue) {
    if (newValue != null) {
      isTemporary.setSelection(newValue.booleanValue());
    } else {
      isTemporary.setSelection(false);
    }
  }




	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.Model_Part_Title;
  }



}
