/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.forms;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.EObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.FormUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class PropertyMapperPropertiesEditionPartForm extends CompositePropertiesEditionPart implements IFormPropertiesEditionPart, PropertyMapperPropertiesEditionPart {

	protected EObjectFlatComboViewer input;
	protected EObjectFlatComboViewer output;



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public PropertyMapperPropertiesEditionPartForm(IPropertiesEditionComponent editionComponent) {
		super(editionComponent);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createFigure(org.eclipse.swt.widgets.Composite, org.eclipse.ui.forms.widgets.FormToolkit)
	 * @generated
	 */
	public Composite createFigure(final Composite parent, final FormToolkit widgetFactory) {
		ScrolledForm scrolledForm = widgetFactory.createScrolledForm(parent);
		Form form = scrolledForm.getForm();
		view = form.getBody();
		GridLayout layout = new GridLayout();
		layout.numColumns = 3;
		view.setLayout(layout);
		createControls(widgetFactory, view);
		return scrolledForm;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createControls(org.eclipse.ui.forms.widgets.FormToolkit, org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(final FormToolkit widgetFactory, Composite view) {
		CompositionSequence propertyMapperStep = new BindingCompositionSequence(propertiesEditionComponent);
		CompositionStep propertiesStep = propertyMapperStep.addStep(CallchainViewsRepository.PropertyMapper.Properties.class);
		propertiesStep.addStep(CallchainViewsRepository.PropertyMapper.Properties.input);
		propertiesStep.addStep(CallchainViewsRepository.PropertyMapper.Properties.output);
		
		
		composer = new PartComposer(propertyMapperStep) {

			@Override
			public Composite addToPart(Composite parent, Object key) {
				if (key == CallchainViewsRepository.PropertyMapper.Properties.class) {
					return createPropertiesGroup(widgetFactory, parent);
				}
				if (key == CallchainViewsRepository.PropertyMapper.Properties.input) {
					return createInputFlatComboViewer(parent, widgetFactory);
				}
				if (key == CallchainViewsRepository.PropertyMapper.Properties.output) {
					return createOutputFlatComboViewer(parent, widgetFactory);
				}
				return parent;
			}
		};
		composer.compose(view);
	}
	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(FormToolkit widgetFactory, final Composite parent) {
		Section propertiesSection = widgetFactory.createSection(parent, Section.TITLE_BAR | Section.TWISTIE | Section.EXPANDED);
		propertiesSection.setText(CallchainMessages.PropertyMapperPropertiesEditionPart_PropertiesGroupLabel);
		GridData propertiesSectionData = new GridData(GridData.FILL_HORIZONTAL);
		propertiesSectionData.horizontalSpan = 3;
		propertiesSection.setLayoutData(propertiesSectionData);
		Composite propertiesGroup = widgetFactory.createComposite(propertiesSection);
		GridLayout propertiesGroupLayout = new GridLayout();
		propertiesGroupLayout.numColumns = 3;
		propertiesGroup.setLayout(propertiesGroupLayout);
		propertiesSection.setClient(propertiesGroup);
		return propertiesGroup;
	}

	/**
	 * @param parent the parent composite
	 * @param widgetFactory factory to use to instanciante widget of the form
	 * @generated
	 */
	protected Composite createInputFlatComboViewer(Composite parent, FormToolkit widgetFactory) {
		FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.PropertyMapperPropertiesEditionPart_InputLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyMapper.Properties.input, CallchainViewsRepository.FORM_KIND));
		input = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyMapper.Properties.input, CallchainViewsRepository.FORM_KIND));
		widgetFactory.adapt(input);
		input.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));
		GridData inputData = new GridData(GridData.FILL_HORIZONTAL);
		input.setLayoutData(inputData);
		input.addSelectionChangedListener(new ISelectionChangedListener() {

			/**
			 * {@inheritDoc}
			 * 
			 * @see org.eclipse.jface.viewers.ISelectionChangedListener#selectionChanged(org.eclipse.jface.viewers.SelectionChangedEvent)
			 */
			public void selectionChanged(SelectionChangedEvent event) {
				if (propertiesEditionComponent != null)
					propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(PropertyMapperPropertiesEditionPartForm.this, CallchainViewsRepository.PropertyMapper.Properties.input, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, getInput()));
			}

		});
		input.setID(CallchainViewsRepository.PropertyMapper.Properties.input);
		FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.PropertyMapper.Properties.input, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
		return parent;
	}

	/**
	 * @param parent the parent composite
	 * @param widgetFactory factory to use to instanciante widget of the form
	 * @generated
	 */
	protected Composite createOutputFlatComboViewer(Composite parent, FormToolkit widgetFactory) {
		FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.PropertyMapperPropertiesEditionPart_OutputLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyMapper.Properties.output, CallchainViewsRepository.FORM_KIND));
		output = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyMapper.Properties.output, CallchainViewsRepository.FORM_KIND));
		widgetFactory.adapt(output);
		output.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));
		GridData outputData = new GridData(GridData.FILL_HORIZONTAL);
		output.setLayoutData(outputData);
		output.addSelectionChangedListener(new ISelectionChangedListener() {

			/**
			 * {@inheritDoc}
			 * 
			 * @see org.eclipse.jface.viewers.ISelectionChangedListener#selectionChanged(org.eclipse.jface.viewers.SelectionChangedEvent)
			 */
			public void selectionChanged(SelectionChangedEvent event) {
				if (propertiesEditionComponent != null)
					propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(PropertyMapperPropertiesEditionPartForm.this, CallchainViewsRepository.PropertyMapper.Properties.output, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, getOutput()));
			}

		});
		output.setID(CallchainViewsRepository.PropertyMapper.Properties.output);
		FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.PropertyMapper.Properties.output, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
		return parent;
	}



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#getInput()
	 * @generated
	 */
	public EObject getInput() {
		if (input.getSelection() instanceof StructuredSelection) {
			Object firstElement = ((StructuredSelection) input.getSelection()).getFirstElement();
			if (firstElement instanceof EObject)
				return (EObject) firstElement;
		}
		return null;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#initInput(EObjectFlatComboSettings)
	 */
	public void initInput(EObjectFlatComboSettings settings) {
		input.setInput(settings);
		if (current != null) {
			input.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#setInput(EObject newValue)
	 * @generated
	 */
	public void setInput(EObject newValue) {
		if (newValue != null) {
			input.setSelection(new StructuredSelection(newValue));
		} else {
			input.setSelection(new StructuredSelection()); //$NON-NLS-1$
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#setInputButtonMode(ButtonsModeEnum newValue)
	 */
	public void setInputButtonMode(ButtonsModeEnum newValue) {
		input.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#addFilterInput(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToInput(ViewerFilter filter) {
		input.addFilter(filter);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#addBusinessFilterInput(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToInput(ViewerFilter filter) {
		input.addBusinessRuleFilter(filter);
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#getOutput()
	 * @generated
	 */
	public EObject getOutput() {
		if (output.getSelection() instanceof StructuredSelection) {
			Object firstElement = ((StructuredSelection) output.getSelection()).getFirstElement();
			if (firstElement instanceof EObject)
				return (EObject) firstElement;
		}
		return null;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#initOutput(EObjectFlatComboSettings)
	 */
	public void initOutput(EObjectFlatComboSettings settings) {
		output.setInput(settings);
		if (current != null) {
			output.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#setOutput(EObject newValue)
	 * @generated
	 */
	public void setOutput(EObject newValue) {
		if (newValue != null) {
			output.setSelection(new StructuredSelection(newValue));
		} else {
			output.setSelection(new StructuredSelection()); //$NON-NLS-1$
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#setOutputButtonMode(ButtonsModeEnum newValue)
	 */
	public void setOutputButtonMode(ButtonsModeEnum newValue) {
		output.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#addFilterOutput(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToOutput(ViewerFilter filter) {
		output.addFilter(filter);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#addBusinessFilterOutput(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToOutput(ViewerFilter filter) {
		output.addBusinessRuleFilter(filter);
	}




	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
		return CallchainMessages.PropertyMapper_Part_Title;
	}



}
