/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.impl;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.widgets.ReferencesTable;
import org.eclipse.emf.eef.runtime.ui.widgets.ReferencesTable.ReferencesTableListener;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableContentProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

import de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class AndPredicatePropertiesEditionPartImpl extends CompositePropertiesEditionPart implements ISWTPropertiesEditionPart, AndPredicatePropertiesEditionPart {

protected ReferencesTable predicates;
protected List<ViewerFilter> predicatesBusinessFilters = new ArrayList<ViewerFilter>();
protected List<ViewerFilter> predicatesFilters = new ArrayList<ViewerFilter>();



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public AndPredicatePropertiesEditionPartImpl(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createFigure(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public Composite createFigure(final Composite parent) {
    view = new Composite(parent, SWT.NONE);
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(view);
    return view;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createControls(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(Composite view) { 
    CompositionSequence andPredicateStep = new BindingCompositionSequence(propertiesEditionComponent);
    andPredicateStep
      .addStep(CallchainViewsRepository.AndPredicate.Properties.class)
      .addStep(CallchainViewsRepository.AndPredicate.Properties.predicates);
    
    
    composer = new PartComposer(andPredicateStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.AndPredicate.Properties.class) {
          return createPropertiesGroup(parent);
        }
        if (key == CallchainViewsRepository.AndPredicate.Properties.predicates) {
          return createPredicatesAdvancedTableComposition(parent);
        }
        return parent;
      }
    };
    composer.compose(view);
  }

	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(Composite parent) {
    Group propertiesGroup = new Group(parent, SWT.NONE);
    propertiesGroup.setText(CallchainMessages.AndPredicatePropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesGroupData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesGroupData.horizontalSpan = 3;
    propertiesGroup.setLayoutData(propertiesGroupData);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    return propertiesGroup;
  }

	/**
	 * @param container
	 * @generated
	 */
	protected Composite createPredicatesAdvancedTableComposition(Composite parent) {
    this.predicates = new ReferencesTable(CallchainMessages.AndPredicatePropertiesEditionPart_PredicatesLabel, new ReferencesTableListener() {
      public void handleAdd() { 
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(AndPredicatePropertiesEditionPartImpl.this, CallchainViewsRepository.AndPredicate.Properties.predicates, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, null));
        predicates.refresh();
      }
      public void handleEdit(EObject element) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(AndPredicatePropertiesEditionPartImpl.this, CallchainViewsRepository.AndPredicate.Properties.predicates, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.EDIT, null, element));
        predicates.refresh();
      }
      public void handleMove(EObject element, int oldIndex, int newIndex) { 
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(AndPredicatePropertiesEditionPartImpl.this, CallchainViewsRepository.AndPredicate.Properties.predicates, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.MOVE, element, newIndex));
        predicates.refresh();
      }
      public void handleRemove(EObject element) { 
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(AndPredicatePropertiesEditionPartImpl.this, CallchainViewsRepository.AndPredicate.Properties.predicates, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.REMOVE, null, element));
        predicates.refresh();
      }
      public void navigateTo(EObject element) { }
    });
    for (ViewerFilter filter : this.predicatesFilters) {
      this.predicates.addFilter(filter);
    }
    this.predicates.setHelpText(propertiesEditionComponent.getHelpContent(CallchainViewsRepository.AndPredicate.Properties.predicates, CallchainViewsRepository.SWT_KIND));
    this.predicates.createControls(parent);
    this.predicates.addSelectionListener(new SelectionAdapter() {
      
      public void widgetSelected(SelectionEvent e) {
        if (e.item != null && e.item.getData() instanceof EObject) {
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(AndPredicatePropertiesEditionPartImpl.this, CallchainViewsRepository.AndPredicate.Properties.predicates, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SELECTION_CHANGED, null, e.item.getData()));
        }
      }
      
    });
    GridData predicatesData = new GridData(GridData.FILL_HORIZONTAL);
    predicatesData.horizontalSpan = 3;
    this.predicates.setLayoutData(predicatesData);
    this.predicates.setLowerBound(1);
    this.predicates.setUpperBound(-1);
    predicates.setID(CallchainViewsRepository.AndPredicate.Properties.predicates);
    predicates.setEEFType("eef::AdvancedTableComposition"); //$NON-NLS-1$
    return parent;
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart#initPredicates(EObject current, EReference containingFeature, EReference feature)
	 */
	public void initPredicates(ReferencesTableSettings settings) {
		if (current.eResource() != null && current.eResource().getResourceSet() != null)
			this.resourceSet = current.eResource().getResourceSet();
		ReferencesTableContentProvider contentProvider = new ReferencesTableContentProvider();
		predicates.setContentProvider(contentProvider);
		predicates.setInput(settings);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart#updatePredicates()
	 * @generated
	 */
	public void updatePredicates() {
  predicates.refresh();
}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart#addFilterPredicates(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToPredicates(ViewerFilter filter) {
    predicatesFilters.add(filter);
    if (this.predicates != null) {
      this.predicates.addFilter(filter);
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart#addBusinessFilterPredicates(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToPredicates(ViewerFilter filter) {
    predicatesBusinessFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.AndPredicatePropertiesEditionPart#isContainedInPredicatesTable(EObject element)
	 * @generated
	 */
	public boolean isContainedInPredicatesTable(EObject element) {
    return ((ReferencesTableSettings)predicates.getInput()).contains(element);
  }







	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.AndPredicate_Part_Title;
  }



}
