/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.impl;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.context.impl.EObjectPropertiesEditionContext;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.policies.PropertiesEditingPolicy;
import org.eclipse.emf.eef.runtime.providers.PropertiesEditingProvider;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.utils.EditingUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.AdvancedEObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.AdvancedEObjectFlatComboViewer.EObjectFlatComboViewerListener;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.EObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.ReferencesTable;
import org.eclipse.emf.eef.runtime.ui.widgets.ReferencesTable.ReferencesTableListener;
import org.eclipse.emf.eef.runtime.ui.widgets.SWTUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.TabElementTreeSelectionDialog;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableContentProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;

import de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class CallPropertiesEditionPartImpl extends CompositePropertiesEditionPart implements ISWTPropertiesEditionPart, CallPropertiesEditionPart {

	protected Text name;
	protected EObjectFlatComboViewer res;
	private AdvancedEObjectFlatComboViewer predicate;
  protected ViewerFilter predicateFilter;
  protected EObjectFlatComboViewer next;
	protected ReferencesTable in;
	protected List<ViewerFilter> inBusinessFilters = new ArrayList<ViewerFilter>();
	protected List<ViewerFilter> inFilters = new ArrayList<ViewerFilter>();
	protected ReferencesTable out;
	protected List<ViewerFilter> outBusinessFilters = new ArrayList<ViewerFilter>();
	protected List<ViewerFilter> outFilters = new ArrayList<ViewerFilter>();
	protected EObjectFlatComboViewer artifact;
	protected ReferencesTable libarys;
	protected List<ViewerFilter> libarysBusinessFilters = new ArrayList<ViewerFilter>();
	protected List<ViewerFilter> libarysFilters = new ArrayList<ViewerFilter>();
	protected Button allowInterModelReferences;
	protected Button continueAfterErrors;
	protected Button showSummary;
	protected Button printExecutionTime;
	protected Button disableAttributeHelperCache;
	protected Button profile;



	protected Button refreshWorkspace;



  /**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public CallPropertiesEditionPartImpl(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createFigure(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public Composite createFigure(final Composite parent) {
    view = new Composite(parent, SWT.NONE);
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(view);
    return view;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createControls(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(Composite view) { 
    CompositionSequence callStep = new BindingCompositionSequence(propertiesEditionComponent);
    CompositionStep propertiesStep = callStep.addStep(CallchainViewsRepository.Call.Properties.class);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.name);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.res);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.predicate);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.next);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.in);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.out);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.artifact);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.libarys);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.allowInterModelReferences);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.continueAfterErrors);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.showSummary);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.printExecutionTime);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.disableAttributeHelperCache);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.profile);
    propertiesStep.addStep(CallchainViewsRepository.Call.Properties.refreshWorkspace);
    
    
    composer = new PartComposer(callStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.Call.Properties.class) {
          return createPropertiesGroup(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.name) {
          return createNameText(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.res) {
          return createResFlatComboViewer(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.predicate) {
          return createPredicateAdvancedFlatComboViewer(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.next) {
          return createNextFlatComboViewer(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.in) {
          return createInAdvancedReferencesTable(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.out) {
          return createOutAdvancedReferencesTable(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.artifact) {
          return createArtifactFlatComboViewer(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.libarys) {
          return createLibarysAdvancedReferencesTable(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.allowInterModelReferences) {
          return createAllowInterModelReferencesCheckbox(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.continueAfterErrors) {
          return createContinueAfterErrorsCheckbox(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.showSummary) {
          return createShowSummaryCheckbox(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.printExecutionTime) {
          return createPrintExecutionTimeCheckbox(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.disableAttributeHelperCache) {
          return createDisableAttributeHelperCacheCheckbox(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.profile) {
          return createProfileCheckbox(parent);
        }
        if (key == CallchainViewsRepository.Call.Properties.refreshWorkspace) {
          return createRefreshWorkspaceCheckbox(parent);
        }
        return parent;
      }
    };
    composer.compose(view);
  }

	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(Composite parent) {
    Group propertiesGroup = new Group(parent, SWT.NONE);
    propertiesGroup.setText(CallchainMessages.CallPropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesGroupData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesGroupData.horizontalSpan = 3;
    propertiesGroup.setLayoutData(propertiesGroupData);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    return propertiesGroup;
  }

	/**
	 * @generated
	 */
	
	protected Composite createNameText(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.CallPropertiesEditionPart_NameLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Call.Properties.name, CallchainViewsRepository.SWT_KIND));
    name = new Text(parent, SWT.BORDER);
    GridData nameData = new GridData(GridData.FILL_HORIZONTAL);
    name.setLayoutData(nameData);
    name.addFocusListener(new FocusAdapter() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
      }

    });
    name.addKeyListener(new KeyAdapter() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
        }
      }

    });
    EditingUtils.setID(name, CallchainViewsRepository.Call.Properties.name);
    EditingUtils.setEEFtype(name, "eef::Text"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.name, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @param parent the parent composite
	 * @generated
	 */
	protected Composite createResFlatComboViewer(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.CallPropertiesEditionPart_ResLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Call.Properties.res, CallchainViewsRepository.SWT_KIND));
    res = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.Call.Properties.res, CallchainViewsRepository.SWT_KIND));
    res.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));

    res.addSelectionChangedListener(new ISelectionChangedListener() {

      public void selectionChanged(SelectionChangedEvent event) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.res, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SET, null, getRes()));
      }

    });
    GridData resData = new GridData(GridData.FILL_HORIZONTAL);
    res.setLayoutData(resData);
    res.setID(CallchainViewsRepository.Call.Properties.res);
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.res, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
   * @param parent the parent composite
   * @generated
   */
  protected Composite createPredicateAdvancedFlatComboViewer(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.CallPropertiesEditionPart_PredicateLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Call.Properties.predicate, CallchainViewsRepository.SWT_KIND));
    // create callback listener
    EObjectFlatComboViewerListener listener = new EObjectFlatComboViewerListener(){
      public void handleSet(EObject element){
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.predicate, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, element)); 
      }
      public void navigateTo(EObject element){ }

      public EObject handleCreate() {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.predicate, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, null)); 
        return null;
      }
    };
    //create widget
    predicate = new AdvancedEObjectFlatComboViewer(CallchainMessages.CallPropertiesEditionPart_PredicateLabel, resourceSet, predicateFilter, propertiesEditionComponent.getEditingContext().getAdapterFactory(), listener);
    predicate.createControls(parent);
    GridData predicateData = new GridData(GridData.FILL_HORIZONTAL);
    predicate.setLayoutData(predicateData);
    predicate.setID(CallchainViewsRepository.Call.Properties.predicate);
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.predicate, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

  /**
	 * @param parent the parent composite
	 * @generated
	 */
	protected Composite createNextFlatComboViewer(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.CallPropertiesEditionPart_NextLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Call.Properties.next, CallchainViewsRepository.SWT_KIND));
    next = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.Call.Properties.next, CallchainViewsRepository.SWT_KIND));
    next.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));

    next.addSelectionChangedListener(new ISelectionChangedListener() {

      public void selectionChanged(SelectionChangedEvent event) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.next, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SET, null, getNext()));
      }

    });
    GridData nextData = new GridData(GridData.FILL_HORIZONTAL);
    next.setLayoutData(nextData);
    next.setID(CallchainViewsRepository.Call.Properties.next);
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.next, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	protected Composite createInAdvancedReferencesTable(Composite parent) {
    this.in = new ReferencesTable(CallchainMessages.CallPropertiesEditionPart_InLabel, new ReferencesTableListener() {
      public void handleAdd() { addIn(); }
      public void handleEdit(EObject element) { editIn(element); }
      public void handleMove(EObject element, int oldIndex, int newIndex) { moveIn(element, oldIndex, newIndex); }
      public void handleRemove(EObject element) { removeFromIn(element); }
      public void navigateTo(EObject element) { }
    });
    this.in.setHelpText(propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.in, CallchainViewsRepository.SWT_KIND));
    this.in.createControls(parent);
    this.in.addSelectionListener(new SelectionAdapter() {
      
      public void widgetSelected(SelectionEvent e) {
        if (e.item != null && e.item.getData() instanceof EObject) {
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.in, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SELECTION_CHANGED, null, e.item.getData()));
        }
      }
      
    });
    GridData inData = new GridData(GridData.FILL_HORIZONTAL);
    inData.horizontalSpan = 3;
    this.in.setLayoutData(inData);
    this.in.disableMove();
    in.setID(CallchainViewsRepository.Call.Properties.in);
    in.setEEFType("eef::AdvancedReferencesTable"); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	protected void addIn() {
    TabElementTreeSelectionDialog dialog = new TabElementTreeSelectionDialog(in.getInput(), inFilters, inBusinessFilters,
    "in", propertiesEditionComponent.getEditingContext().getAdapterFactory(), current.eResource()) {
      @Override
      public void process(IStructuredSelection selection) {
        for (Iterator<?> iter = selection.iterator(); iter.hasNext();) {
          EObject elem = (EObject) iter.next();
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.in,
            PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, elem));
        }
        in.refresh();
      }
    };
    dialog.open();
  }

	/**
	 * @generated
	 */
	protected void moveIn(EObject element, int oldIndex, int newIndex) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.in, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.MOVE, element, newIndex));
    in.refresh();
  }

	/**
	 * @generated
	 */
	protected void removeFromIn(EObject element) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.in, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.REMOVE, null, element));
    in.refresh();
  }

	/**
	 * @generated
	 */
	protected void editIn(EObject element) {
    EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(propertiesEditionComponent.getEditingContext(), propertiesEditionComponent, element, adapterFactory);
    PropertiesEditingProvider provider = (PropertiesEditingProvider)adapterFactory.adapt(element, PropertiesEditingProvider.class);
    if (provider != null) {
      PropertiesEditingPolicy policy = provider.getPolicy(context);
      if (policy != null) {
        policy.execute();
        in.refresh();
      }
    }
  }

	/**
	 * @generated
	 */
	protected Composite createOutAdvancedReferencesTable(Composite parent) {
    this.out = new ReferencesTable(CallchainMessages.CallPropertiesEditionPart_OutLabel, new ReferencesTableListener() {
      public void handleAdd() { addOut(); }
      public void handleEdit(EObject element) { editOut(element); }
      public void handleMove(EObject element, int oldIndex, int newIndex) { moveOut(element, oldIndex, newIndex); }
      public void handleRemove(EObject element) { removeFromOut(element); }
      public void navigateTo(EObject element) { }
    });
    this.out.setHelpText(propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.out, CallchainViewsRepository.SWT_KIND));
    this.out.createControls(parent);
    this.out.addSelectionListener(new SelectionAdapter() {
      
      public void widgetSelected(SelectionEvent e) {
        if (e.item != null && e.item.getData() instanceof EObject) {
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.out, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SELECTION_CHANGED, null, e.item.getData()));
        }
      }
      
    });
    GridData outData = new GridData(GridData.FILL_HORIZONTAL);
    outData.horizontalSpan = 3;
    this.out.setLayoutData(outData);
    this.out.disableMove();
    out.setID(CallchainViewsRepository.Call.Properties.out);
    out.setEEFType("eef::AdvancedReferencesTable"); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	protected void addOut() {
    TabElementTreeSelectionDialog dialog = new TabElementTreeSelectionDialog(out.getInput(), outFilters, outBusinessFilters,
    "out", propertiesEditionComponent.getEditingContext().getAdapterFactory(), current.eResource()) {
      @Override
      public void process(IStructuredSelection selection) {
        for (Iterator<?> iter = selection.iterator(); iter.hasNext();) {
          EObject elem = (EObject) iter.next();
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.out,
            PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, elem));
        }
        out.refresh();
      }
    };
    dialog.open();
  }

	/**
	 * @generated
	 */
	protected void moveOut(EObject element, int oldIndex, int newIndex) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.out, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.MOVE, element, newIndex));
    out.refresh();
  }

	/**
	 * @generated
	 */
	protected void removeFromOut(EObject element) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.out, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.REMOVE, null, element));
    out.refresh();
  }

	/**
	 * @generated
	 */
	protected void editOut(EObject element) {
    EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(propertiesEditionComponent.getEditingContext(), propertiesEditionComponent, element, adapterFactory);
    PropertiesEditingProvider provider = (PropertiesEditingProvider)adapterFactory.adapt(element, PropertiesEditingProvider.class);
    if (provider != null) {
      PropertiesEditingPolicy policy = provider.getPolicy(context);
      if (policy != null) {
        policy.execute();
        out.refresh();
      }
    }
  }

	/**
	 * @param parent the parent composite
	 * @generated
	 */
	protected Composite createArtifactFlatComboViewer(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.CallPropertiesEditionPart_ArtifactLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Call.Properties.artifact, CallchainViewsRepository.SWT_KIND));
    artifact = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.Call.Properties.artifact, CallchainViewsRepository.SWT_KIND));
    artifact.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));

    artifact.addSelectionChangedListener(new ISelectionChangedListener() {

      public void selectionChanged(SelectionChangedEvent event) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.artifact, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SET, null, getArtifact()));
      }

    });
    GridData artifactData = new GridData(GridData.FILL_HORIZONTAL);
    artifact.setLayoutData(artifactData);
    artifact.setID(CallchainViewsRepository.Call.Properties.artifact);
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.artifact, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	protected Composite createLibarysAdvancedReferencesTable(Composite parent) {
    this.libarys = new ReferencesTable(CallchainMessages.CallPropertiesEditionPart_LibarysLabel, new ReferencesTableListener() {
      public void handleAdd() { addLibarys(); }
      public void handleEdit(EObject element) { editLibarys(element); }
      public void handleMove(EObject element, int oldIndex, int newIndex) { moveLibarys(element, oldIndex, newIndex); }
      public void handleRemove(EObject element) { removeFromLibarys(element); }
      public void navigateTo(EObject element) { }
    });
    this.libarys.setHelpText(propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.libarys, CallchainViewsRepository.SWT_KIND));
    this.libarys.createControls(parent);
    this.libarys.addSelectionListener(new SelectionAdapter() {
      
      public void widgetSelected(SelectionEvent e) {
        if (e.item != null && e.item.getData() instanceof EObject) {
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.libarys, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SELECTION_CHANGED, null, e.item.getData()));
        }
      }
      
    });
    GridData libarysData = new GridData(GridData.FILL_HORIZONTAL);
    libarysData.horizontalSpan = 3;
    this.libarys.setLayoutData(libarysData);
    this.libarys.disableMove();
    libarys.setID(CallchainViewsRepository.Call.Properties.libarys);
    libarys.setEEFType("eef::AdvancedReferencesTable"); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	protected void addLibarys() {
    TabElementTreeSelectionDialog dialog = new TabElementTreeSelectionDialog(libarys.getInput(), libarysFilters, libarysBusinessFilters,
    "libarys", propertiesEditionComponent.getEditingContext().getAdapterFactory(), current.eResource()) {
      @Override
      public void process(IStructuredSelection selection) {
        for (Iterator<?> iter = selection.iterator(); iter.hasNext();) {
          EObject elem = (EObject) iter.next();
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.libarys,
            PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, elem));
        }
        libarys.refresh();
      }
    };
    dialog.open();
  }

	/**
	 * @generated
	 */
	protected void moveLibarys(EObject element, int oldIndex, int newIndex) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.libarys, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.MOVE, element, newIndex));
    libarys.refresh();
  }

	/**
	 * @generated
	 */
	protected void removeFromLibarys(EObject element) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.libarys, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.REMOVE, null, element));
    libarys.refresh();
  }

	/**
	 * @generated
	 */
	protected void editLibarys(EObject element) {
    EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(propertiesEditionComponent.getEditingContext(), propertiesEditionComponent, element, adapterFactory);
    PropertiesEditingProvider provider = (PropertiesEditingProvider)adapterFactory.adapt(element, PropertiesEditingProvider.class);
    if (provider != null) {
      PropertiesEditingPolicy policy = provider.getPolicy(context);
      if (policy != null) {
        policy.execute();
        libarys.refresh();
      }
    }
  }

	/**
	 * @generated
	 */
	
	protected Composite createAllowInterModelReferencesCheckbox(Composite parent) {
    allowInterModelReferences = new Button(parent, SWT.CHECK);
    allowInterModelReferences.setText(CallchainMessages.CallPropertiesEditionPart_AllowInterModelReferencesLabel);
    allowInterModelReferences.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.allowInterModelReferences, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(allowInterModelReferences.getSelection())));
      }

    });
    GridData allowInterModelReferencesData = new GridData(GridData.FILL_HORIZONTAL);
    allowInterModelReferencesData.horizontalSpan = 2;
    allowInterModelReferences.setLayoutData(allowInterModelReferencesData);
    EditingUtils.setID(allowInterModelReferences, CallchainViewsRepository.Call.Properties.allowInterModelReferences);
    EditingUtils.setEEFtype(allowInterModelReferences, "eef::Checkbox"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.allowInterModelReferences, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	
	protected Composite createContinueAfterErrorsCheckbox(Composite parent) {
    continueAfterErrors = new Button(parent, SWT.CHECK);
    continueAfterErrors.setText(CallchainMessages.CallPropertiesEditionPart_ContinueAfterErrorsLabel);
    continueAfterErrors.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.continueAfterErrors, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(continueAfterErrors.getSelection())));
      }

    });
    GridData continueAfterErrorsData = new GridData(GridData.FILL_HORIZONTAL);
    continueAfterErrorsData.horizontalSpan = 2;
    continueAfterErrors.setLayoutData(continueAfterErrorsData);
    EditingUtils.setID(continueAfterErrors, CallchainViewsRepository.Call.Properties.continueAfterErrors);
    EditingUtils.setEEFtype(continueAfterErrors, "eef::Checkbox"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.continueAfterErrors, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	
	protected Composite createShowSummaryCheckbox(Composite parent) {
    showSummary = new Button(parent, SWT.CHECK);
    showSummary.setText(CallchainMessages.CallPropertiesEditionPart_ShowSummaryLabel);
    showSummary.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.showSummary, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(showSummary.getSelection())));
      }

    });
    GridData showSummaryData = new GridData(GridData.FILL_HORIZONTAL);
    showSummaryData.horizontalSpan = 2;
    showSummary.setLayoutData(showSummaryData);
    EditingUtils.setID(showSummary, CallchainViewsRepository.Call.Properties.showSummary);
    EditingUtils.setEEFtype(showSummary, "eef::Checkbox"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.showSummary, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	
	protected Composite createPrintExecutionTimeCheckbox(Composite parent) {
    printExecutionTime = new Button(parent, SWT.CHECK);
    printExecutionTime.setText(CallchainMessages.CallPropertiesEditionPart_PrintExecutionTimeLabel);
    printExecutionTime.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.printExecutionTime, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(printExecutionTime.getSelection())));
      }

    });
    GridData printExecutionTimeData = new GridData(GridData.FILL_HORIZONTAL);
    printExecutionTimeData.horizontalSpan = 2;
    printExecutionTime.setLayoutData(printExecutionTimeData);
    EditingUtils.setID(printExecutionTime, CallchainViewsRepository.Call.Properties.printExecutionTime);
    EditingUtils.setEEFtype(printExecutionTime, "eef::Checkbox"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.printExecutionTime, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	
	protected Composite createDisableAttributeHelperCacheCheckbox(Composite parent) {
    disableAttributeHelperCache = new Button(parent, SWT.CHECK);
    disableAttributeHelperCache.setText(CallchainMessages.CallPropertiesEditionPart_DisableAttributeHelperCacheLabel);
    disableAttributeHelperCache.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.disableAttributeHelperCache, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(disableAttributeHelperCache.getSelection())));
      }

    });
    GridData disableAttributeHelperCacheData = new GridData(GridData.FILL_HORIZONTAL);
    disableAttributeHelperCacheData.horizontalSpan = 2;
    disableAttributeHelperCache.setLayoutData(disableAttributeHelperCacheData);
    EditingUtils.setID(disableAttributeHelperCache, CallchainViewsRepository.Call.Properties.disableAttributeHelperCache);
    EditingUtils.setEEFtype(disableAttributeHelperCache, "eef::Checkbox"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.disableAttributeHelperCache, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	
	protected Composite createProfileCheckbox(Composite parent) {
    profile = new Button(parent, SWT.CHECK);
    profile.setText(CallchainMessages.CallPropertiesEditionPart_ProfileLabel);
    profile.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.profile, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(profile.getSelection())));
      }

    });
    GridData profileData = new GridData(GridData.FILL_HORIZONTAL);
    profileData.horizontalSpan = 2;
    profile.setLayoutData(profileData);
    EditingUtils.setID(profile, CallchainViewsRepository.Call.Properties.profile);
    EditingUtils.setEEFtype(profile, "eef::Checkbox"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.profile, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }



	/**
   * @generated
   */
  
  protected Composite createRefreshWorkspaceCheckbox(Composite parent) {
    refreshWorkspace = new Button(parent, SWT.CHECK);
    refreshWorkspace.setText(CallchainMessages.CallPropertiesEditionPart_RefreshWorkspaceLabel);
    refreshWorkspace.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallPropertiesEditionPartImpl.this, CallchainViewsRepository.Call.Properties.refreshWorkspace, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(refreshWorkspace.getSelection())));
      }

    });
    GridData refreshWorkspaceData = new GridData(GridData.FILL_HORIZONTAL);
    refreshWorkspaceData.horizontalSpan = 2;
    refreshWorkspace.setLayoutData(refreshWorkspaceData);
    EditingUtils.setID(refreshWorkspace, CallchainViewsRepository.Call.Properties.refreshWorkspace);
    EditingUtils.setEEFtype(refreshWorkspace, "eef::Checkbox"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Call.Properties.refreshWorkspace, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

  /**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getName()
	 * @generated
	 */
	public String getName() {
    return name.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setName(String newValue)
	 * @generated
	 */
	public void setName(String newValue) {
    if (newValue != null) {
      name.setText(newValue);
    } else {
      name.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getRes()
	 * @generated
	 */
	public EObject getRes() {
    if (res.getSelection() instanceof StructuredSelection) {
      Object firstElement = ((StructuredSelection) res.getSelection()).getFirstElement();
      if (firstElement instanceof EObject)
        return (EObject) firstElement;
    }
    return null;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#initRes(EObjectFlatComboSettings)
	 */
	public void initRes(EObjectFlatComboSettings settings) {
		res.setInput(settings);
		if (current != null) {
			res.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setRes(EObject newValue)
	 * @generated
	 */
	public void setRes(EObject newValue) {
    if (newValue != null) {
      res.setSelection(new StructuredSelection(newValue));
    } else {
      res.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setResButtonMode(ButtonsModeEnum newValue)
	 */
	public void setResButtonMode(ButtonsModeEnum newValue) {
		res.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addFilterRes(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToRes(ViewerFilter filter) {
    res.addFilter(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addBusinessFilterRes(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToRes(ViewerFilter filter) {
    res.addBusinessRuleFilter(filter);
  }


	/**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getPredicate()
   * @generated
   */
  public EObject getPredicate() {
    return predicate.getSelection();
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#initPredicate(EObjectFlatComboSettings)
   */
  public void initPredicate(EObjectFlatComboSettings settings) {
    predicate.setInput(settings);
    if (current != null) {
      predicate.setSelection(new StructuredSelection(settings.getValue()));
    }
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setPredicate(EObject newValue)
   * @generated
   */
  public void setPredicate(EObject newValue) {
    if (newValue != null) {
      predicate.setSelection(new StructuredSelection(newValue));
    } else {
      predicate.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setPredicateButtonMode(ButtonsModeEnum newValue)
   */
  public void setPredicateButtonMode(ButtonsModeEnum newValue) {
    predicate.setButtonMode(newValue);
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addFilterPredicate(ViewerFilter filter)
   * @generated
   */
  public void addFilterToPredicate(ViewerFilter filter) {
    predicate.addFilter(filter);
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addBusinessFilterPredicate(ViewerFilter filter)
   * @generated
   */
  public void addBusinessFilterToPredicate(ViewerFilter filter) {
    predicate.addBusinessRuleFilter(filter);
  }

  /**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getNext()
	 * @generated
	 */
	public EObject getNext() {
    if (next.getSelection() instanceof StructuredSelection) {
      Object firstElement = ((StructuredSelection) next.getSelection()).getFirstElement();
      if (firstElement instanceof EObject)
        return (EObject) firstElement;
    }
    return null;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#initNext(EObjectFlatComboSettings)
	 */
	public void initNext(EObjectFlatComboSettings settings) {
		next.setInput(settings);
		if (current != null) {
			next.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setNext(EObject newValue)
	 * @generated
	 */
	public void setNext(EObject newValue) {
    if (newValue != null) {
      next.setSelection(new StructuredSelection(newValue));
    } else {
      next.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setNextButtonMode(ButtonsModeEnum newValue)
	 */
	public void setNextButtonMode(ButtonsModeEnum newValue) {
		next.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addFilterNext(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToNext(ViewerFilter filter) {
    next.addFilter(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addBusinessFilterNext(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToNext(ViewerFilter filter) {
    next.addBusinessRuleFilter(filter);
  }




	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#initIn(org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings)
	 */
	public void initIn(ReferencesTableSettings settings) {
		if (current.eResource() != null && current.eResource().getResourceSet() != null)
			this.resourceSet = current.eResource().getResourceSet();
		ReferencesTableContentProvider contentProvider = new ReferencesTableContentProvider();
		in.setContentProvider(contentProvider);
		in.setInput(settings);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#updateIn()
	 * @generated
	 */
	public void updateIn() {
  in.refresh();
}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addFilterIn(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToIn(ViewerFilter filter) {
    inFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addBusinessFilterIn(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToIn(ViewerFilter filter) {
    inBusinessFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#isContainedInInTable(EObject element)
	 * @generated
	 */
	public boolean isContainedInInTable(EObject element) {
    return ((ReferencesTableSettings)in.getInput()).contains(element);
  }




	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#initOut(org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings)
	 */
	public void initOut(ReferencesTableSettings settings) {
		if (current.eResource() != null && current.eResource().getResourceSet() != null)
			this.resourceSet = current.eResource().getResourceSet();
		ReferencesTableContentProvider contentProvider = new ReferencesTableContentProvider();
		out.setContentProvider(contentProvider);
		out.setInput(settings);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#updateOut()
	 * @generated
	 */
	public void updateOut() {
  out.refresh();
}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addFilterOut(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToOut(ViewerFilter filter) {
    outFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addBusinessFilterOut(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToOut(ViewerFilter filter) {
    outBusinessFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#isContainedInOutTable(EObject element)
	 * @generated
	 */
	public boolean isContainedInOutTable(EObject element) {
    return ((ReferencesTableSettings)out.getInput()).contains(element);
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getArtifact()
	 * @generated
	 */
	public EObject getArtifact() {
    if (artifact.getSelection() instanceof StructuredSelection) {
      Object firstElement = ((StructuredSelection) artifact.getSelection()).getFirstElement();
      if (firstElement instanceof EObject)
        return (EObject) firstElement;
    }
    return null;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#initArtifact(EObjectFlatComboSettings)
	 */
	public void initArtifact(EObjectFlatComboSettings settings) {
		artifact.setInput(settings);
		if (current != null) {
			artifact.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setArtifact(EObject newValue)
	 * @generated
	 */
	public void setArtifact(EObject newValue) {
    if (newValue != null) {
      artifact.setSelection(new StructuredSelection(newValue));
    } else {
      artifact.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setArtifactButtonMode(ButtonsModeEnum newValue)
	 */
	public void setArtifactButtonMode(ButtonsModeEnum newValue) {
		artifact.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addFilterArtifact(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToArtifact(ViewerFilter filter) {
    artifact.addFilter(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addBusinessFilterArtifact(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToArtifact(ViewerFilter filter) {
    artifact.addBusinessRuleFilter(filter);
  }




	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#initLibarys(org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings)
	 */
	public void initLibarys(ReferencesTableSettings settings) {
		if (current.eResource() != null && current.eResource().getResourceSet() != null)
			this.resourceSet = current.eResource().getResourceSet();
		ReferencesTableContentProvider contentProvider = new ReferencesTableContentProvider();
		libarys.setContentProvider(contentProvider);
		libarys.setInput(settings);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#updateLibarys()
	 * @generated
	 */
	public void updateLibarys() {
  libarys.refresh();
}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addFilterLibarys(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToLibarys(ViewerFilter filter) {
    libarysFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#addBusinessFilterLibarys(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToLibarys(ViewerFilter filter) {
    libarysBusinessFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#isContainedInLibarysTable(EObject element)
	 * @generated
	 */
	public boolean isContainedInLibarysTable(EObject element) {
    return ((ReferencesTableSettings)libarys.getInput()).contains(element);
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getAllowInterModelReferences()
	 * @generated
	 */
	public Boolean getAllowInterModelReferences() {
    return Boolean.valueOf(allowInterModelReferences.getSelection());
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setAllowInterModelReferences(Boolean newValue)
	 * @generated
	 */
	public void setAllowInterModelReferences(Boolean newValue) {
    if (newValue != null) {
      allowInterModelReferences.setSelection(newValue.booleanValue());
    } else {
      allowInterModelReferences.setSelection(false);
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getContinueAfterErrors()
	 * @generated
	 */
	public Boolean getContinueAfterErrors() {
    return Boolean.valueOf(continueAfterErrors.getSelection());
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setContinueAfterErrors(Boolean newValue)
	 * @generated
	 */
	public void setContinueAfterErrors(Boolean newValue) {
    if (newValue != null) {
      continueAfterErrors.setSelection(newValue.booleanValue());
    } else {
      continueAfterErrors.setSelection(false);
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getShowSummary()
	 * @generated
	 */
	public Boolean getShowSummary() {
    return Boolean.valueOf(showSummary.getSelection());
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setShowSummary(Boolean newValue)
	 * @generated
	 */
	public void setShowSummary(Boolean newValue) {
    if (newValue != null) {
      showSummary.setSelection(newValue.booleanValue());
    } else {
      showSummary.setSelection(false);
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getPrintExecutionTime()
	 * @generated
	 */
	public Boolean getPrintExecutionTime() {
    return Boolean.valueOf(printExecutionTime.getSelection());
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setPrintExecutionTime(Boolean newValue)
	 * @generated
	 */
	public void setPrintExecutionTime(Boolean newValue) {
    if (newValue != null) {
      printExecutionTime.setSelection(newValue.booleanValue());
    } else {
      printExecutionTime.setSelection(false);
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getDisableAttributeHelperCache()
	 * @generated
	 */
	public Boolean getDisableAttributeHelperCache() {
    return Boolean.valueOf(disableAttributeHelperCache.getSelection());
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setDisableAttributeHelperCache(Boolean newValue)
	 * @generated
	 */
	public void setDisableAttributeHelperCache(Boolean newValue) {
    if (newValue != null) {
      disableAttributeHelperCache.setSelection(newValue.booleanValue());
    } else {
      disableAttributeHelperCache.setSelection(false);
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getProfile()
	 * @generated
	 */
	public Boolean getProfile() {
    return Boolean.valueOf(profile.getSelection());
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setProfile(Boolean newValue)
	 * @generated
	 */
	public void setProfile(Boolean newValue) {
    if (newValue != null) {
      profile.setSelection(newValue.booleanValue());
    } else {
      profile.setSelection(false);
    }
  }







	/**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#getRefreshWorkspace()
   * @generated
   */
  public Boolean getRefreshWorkspace() {
    return Boolean.valueOf(refreshWorkspace.getSelection());
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.CallPropertiesEditionPart#setRefreshWorkspace(Boolean newValue)
   * @generated
   */
  public void setRefreshWorkspace(Boolean newValue) {
    if (newValue != null) {
      refreshWorkspace.setSelection(newValue.booleanValue());
    } else {
      refreshWorkspace.setSelection(false);
    }
  }

  /**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.Call_Part_Title;
  }



}
