/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.impl;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.context.impl.EObjectPropertiesEditionContext;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.policies.PropertiesEditingPolicy;
import org.eclipse.emf.eef.runtime.providers.PropertiesEditingProvider;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.utils.EditingUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.EObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.ReferencesTable;
import org.eclipse.emf.eef.runtime.ui.widgets.ReferencesTable.ReferencesTableListener;
import org.eclipse.emf.eef.runtime.ui.widgets.SWTUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.TabElementTreeSelectionDialog;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableContentProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class CallsPropertiesEditionPartImpl extends CompositePropertiesEditionPart implements ISWTPropertiesEditionPart, CallsPropertiesEditionPart {

	protected Text name;
	protected EObjectFlatComboViewer defaultStartPoint;
	protected ReferencesTable startPoints;
	protected List<ViewerFilter> startPointsBusinessFilters = new ArrayList<ViewerFilter>();
	protected List<ViewerFilter> startPointsFilters = new ArrayList<ViewerFilter>();
protected ReferencesTable properties;
protected List<ViewerFilter> propertiesBusinessFilters = new ArrayList<ViewerFilter>();
protected List<ViewerFilter> propertiesFilters = new ArrayList<ViewerFilter>();
	protected ReferencesTable defaultLib;
	protected List<ViewerFilter> defaultLibBusinessFilters = new ArrayList<ViewerFilter>();
	protected List<ViewerFilter> defaultLibFilters = new ArrayList<ViewerFilter>();
	protected ReferencesTable defaultSuperImposed;
	protected List<ViewerFilter> defaultSuperImposedBusinessFilters = new ArrayList<ViewerFilter>();
	protected List<ViewerFilter> defaultSuperImposedFilters = new ArrayList<ViewerFilter>();
	protected Button logDefault;



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public CallsPropertiesEditionPartImpl(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createFigure(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public Composite createFigure(final Composite parent) {
    view = new Composite(parent, SWT.NONE);
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(view);
    return view;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createControls(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(Composite view) { 
    CompositionSequence callsStep = new BindingCompositionSequence(propertiesEditionComponent);
    CompositionStep propertiesStep = callsStep.addStep(CallchainViewsRepository.Calls.Properties.class);
    propertiesStep.addStep(CallchainViewsRepository.Calls.Properties.name);
    propertiesStep.addStep(CallchainViewsRepository.Calls.Properties.defaultStartPoint);
    propertiesStep.addStep(CallchainViewsRepository.Calls.Properties.startPoints);
    propertiesStep.addStep(CallchainViewsRepository.Calls.Properties.properties_);
    propertiesStep.addStep(CallchainViewsRepository.Calls.Properties.defaultLib);
    propertiesStep.addStep(CallchainViewsRepository.Calls.Properties.defaultSuperImposed);
    propertiesStep.addStep(CallchainViewsRepository.Calls.Properties.logDefault);
    
    
    composer = new PartComposer(callsStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.Calls.Properties.class) {
          return createPropertiesGroup(parent);
        }
        if (key == CallchainViewsRepository.Calls.Properties.name) {
          return createNameText(parent);
        }
        if (key == CallchainViewsRepository.Calls.Properties.defaultStartPoint) {
          return createDefaultStartPointFlatComboViewer(parent);
        }
        if (key == CallchainViewsRepository.Calls.Properties.startPoints) {
          return createStartPointsAdvancedReferencesTable(parent);
        }
        if (key == CallchainViewsRepository.Calls.Properties.properties_) {
          return createPropertiesAdvancedTableComposition(parent);
        }
        if (key == CallchainViewsRepository.Calls.Properties.defaultLib) {
          return createDefaultLibAdvancedReferencesTable(parent);
        }
        if (key == CallchainViewsRepository.Calls.Properties.defaultSuperImposed) {
          return createDefaultSuperImposedAdvancedReferencesTable(parent);
        }
        if (key == CallchainViewsRepository.Calls.Properties.logDefault) {
          return createLogDefaultCheckbox(parent);
        }
        return parent;
      }
    };
    composer.compose(view);
  }

	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(Composite parent) {
    Group propertiesGroup = new Group(parent, SWT.NONE);
    propertiesGroup.setText(CallchainMessages.CallsPropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesGroupData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesGroupData.horizontalSpan = 3;
    propertiesGroup.setLayoutData(propertiesGroupData);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    return propertiesGroup;
  }

	/**
	 * @generated
	 */
	
	protected Composite createNameText(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.CallsPropertiesEditionPart_NameLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Calls.Properties.name, CallchainViewsRepository.SWT_KIND));
    name = new Text(parent, SWT.BORDER);
    GridData nameData = new GridData(GridData.FILL_HORIZONTAL);
    name.setLayoutData(nameData);
    name.addFocusListener(new FocusAdapter() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
      }

    });
    name.addKeyListener(new KeyAdapter() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
        }
      }

    });
    EditingUtils.setID(name, CallchainViewsRepository.Calls.Properties.name);
    EditingUtils.setEEFtype(name, "eef::Text"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Calls.Properties.name, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @param parent the parent composite
	 * @generated
	 */
	protected Composite createDefaultStartPointFlatComboViewer(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.CallsPropertiesEditionPart_DefaultStartPointLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Calls.Properties.defaultStartPoint, CallchainViewsRepository.SWT_KIND));
    defaultStartPoint = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.Calls.Properties.defaultStartPoint, CallchainViewsRepository.SWT_KIND));
    defaultStartPoint.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));

    defaultStartPoint.addSelectionChangedListener(new ISelectionChangedListener() {

      public void selectionChanged(SelectionChangedEvent event) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.defaultStartPoint, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SET, null, getDefaultStartPoint()));
      }

    });
    GridData defaultStartPointData = new GridData(GridData.FILL_HORIZONTAL);
    defaultStartPoint.setLayoutData(defaultStartPointData);
    defaultStartPoint.setID(CallchainViewsRepository.Calls.Properties.defaultStartPoint);
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Calls.Properties.defaultStartPoint, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	protected Composite createStartPointsAdvancedReferencesTable(Composite parent) {
    this.startPoints = new ReferencesTable(CallchainMessages.CallsPropertiesEditionPart_StartPointsLabel, new ReferencesTableListener() {
      public void handleAdd() { addStartPoints(); }
      public void handleEdit(EObject element) { editStartPoints(element); }
      public void handleMove(EObject element, int oldIndex, int newIndex) { moveStartPoints(element, oldIndex, newIndex); }
      public void handleRemove(EObject element) { removeFromStartPoints(element); }
      public void navigateTo(EObject element) { }
    });
    this.startPoints.setHelpText(propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Calls.Properties.startPoints, CallchainViewsRepository.SWT_KIND));
    this.startPoints.createControls(parent);
    this.startPoints.addSelectionListener(new SelectionAdapter() {
      
      public void widgetSelected(SelectionEvent e) {
        if (e.item != null && e.item.getData() instanceof EObject) {
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.startPoints, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SELECTION_CHANGED, null, e.item.getData()));
        }
      }
      
    });
    GridData startPointsData = new GridData(GridData.FILL_HORIZONTAL);
    startPointsData.horizontalSpan = 3;
    this.startPoints.setLayoutData(startPointsData);
    this.startPoints.disableMove();
    startPoints.setID(CallchainViewsRepository.Calls.Properties.startPoints);
    startPoints.setEEFType("eef::AdvancedReferencesTable"); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	protected void addStartPoints() {
    TabElementTreeSelectionDialog dialog = new TabElementTreeSelectionDialog(startPoints.getInput(), startPointsFilters, startPointsBusinessFilters,
    "startPoints", propertiesEditionComponent.getEditingContext().getAdapterFactory(), current.eResource()) {
      @Override
      public void process(IStructuredSelection selection) {
        for (Iterator<?> iter = selection.iterator(); iter.hasNext();) {
          EObject elem = (EObject) iter.next();
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.startPoints,
            PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, elem));
        }
        startPoints.refresh();
      }
    };
    dialog.open();
  }

	/**
	 * @generated
	 */
	protected void moveStartPoints(EObject element, int oldIndex, int newIndex) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.startPoints, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.MOVE, element, newIndex));
    startPoints.refresh();
  }

	/**
	 * @generated
	 */
	protected void removeFromStartPoints(EObject element) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.startPoints, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.REMOVE, null, element));
    startPoints.refresh();
  }

	/**
	 * @generated
	 */
	protected void editStartPoints(EObject element) {
    EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(propertiesEditionComponent.getEditingContext(), propertiesEditionComponent, element, adapterFactory);
    PropertiesEditingProvider provider = (PropertiesEditingProvider)adapterFactory.adapt(element, PropertiesEditingProvider.class);
    if (provider != null) {
      PropertiesEditingPolicy policy = provider.getPolicy(context);
      if (policy != null) {
        policy.execute();
        startPoints.refresh();
      }
    }
  }

	/**
	 * @param container
	 * @generated
	 */
	protected Composite createPropertiesAdvancedTableComposition(Composite parent) {
    this.properties = new ReferencesTable(CallchainMessages.CallsPropertiesEditionPart_PropertiesLabel, new ReferencesTableListener() {
      public void handleAdd() { 
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.properties_, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, null));
        properties.refresh();
      }
      public void handleEdit(EObject element) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.properties_, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.EDIT, null, element));
        properties.refresh();
      }
      public void handleMove(EObject element, int oldIndex, int newIndex) { 
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.properties_, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.MOVE, element, newIndex));
        properties.refresh();
      }
      public void handleRemove(EObject element) { 
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.properties_, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.REMOVE, null, element));
        properties.refresh();
      }
      public void navigateTo(EObject element) { }
    });
    for (ViewerFilter filter : this.propertiesFilters) {
      this.properties.addFilter(filter);
    }
    this.properties.setHelpText(propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Calls.Properties.properties_, CallchainViewsRepository.SWT_KIND));
    this.properties.createControls(parent);
    this.properties.addSelectionListener(new SelectionAdapter() {
      
      public void widgetSelected(SelectionEvent e) {
        if (e.item != null && e.item.getData() instanceof EObject) {
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.properties_, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SELECTION_CHANGED, null, e.item.getData()));
        }
      }
      
    });
    GridData propertiesData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesData.horizontalSpan = 3;
    this.properties.setLayoutData(propertiesData);
    this.properties.setLowerBound(0);
    this.properties.setUpperBound(-1);
    properties.setID(CallchainViewsRepository.Calls.Properties.properties_);
    properties.setEEFType("eef::AdvancedTableComposition"); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	protected Composite createDefaultLibAdvancedReferencesTable(Composite parent) {
    this.defaultLib = new ReferencesTable(CallchainMessages.CallsPropertiesEditionPart_DefaultLibLabel, new ReferencesTableListener() {
      public void handleAdd() { addDefaultLib(); }
      public void handleEdit(EObject element) { editDefaultLib(element); }
      public void handleMove(EObject element, int oldIndex, int newIndex) { moveDefaultLib(element, oldIndex, newIndex); }
      public void handleRemove(EObject element) { removeFromDefaultLib(element); }
      public void navigateTo(EObject element) { }
    });
    this.defaultLib.setHelpText(propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Calls.Properties.defaultLib, CallchainViewsRepository.SWT_KIND));
    this.defaultLib.createControls(parent);
    this.defaultLib.addSelectionListener(new SelectionAdapter() {
      
      public void widgetSelected(SelectionEvent e) {
        if (e.item != null && e.item.getData() instanceof EObject) {
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.defaultLib, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SELECTION_CHANGED, null, e.item.getData()));
        }
      }
      
    });
    GridData defaultLibData = new GridData(GridData.FILL_HORIZONTAL);
    defaultLibData.horizontalSpan = 3;
    this.defaultLib.setLayoutData(defaultLibData);
    this.defaultLib.disableMove();
    defaultLib.setID(CallchainViewsRepository.Calls.Properties.defaultLib);
    defaultLib.setEEFType("eef::AdvancedReferencesTable"); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	protected void addDefaultLib() {
    TabElementTreeSelectionDialog dialog = new TabElementTreeSelectionDialog(defaultLib.getInput(), defaultLibFilters, defaultLibBusinessFilters,
    "defaultLib", propertiesEditionComponent.getEditingContext().getAdapterFactory(), current.eResource()) {
      @Override
      public void process(IStructuredSelection selection) {
        for (Iterator<?> iter = selection.iterator(); iter.hasNext();) {
          EObject elem = (EObject) iter.next();
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.defaultLib,
            PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, elem));
        }
        defaultLib.refresh();
      }
    };
    dialog.open();
  }

	/**
	 * @generated
	 */
	protected void moveDefaultLib(EObject element, int oldIndex, int newIndex) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.defaultLib, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.MOVE, element, newIndex));
    defaultLib.refresh();
  }

	/**
	 * @generated
	 */
	protected void removeFromDefaultLib(EObject element) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.defaultLib, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.REMOVE, null, element));
    defaultLib.refresh();
  }

	/**
	 * @generated
	 */
	protected void editDefaultLib(EObject element) {
    EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(propertiesEditionComponent.getEditingContext(), propertiesEditionComponent, element, adapterFactory);
    PropertiesEditingProvider provider = (PropertiesEditingProvider)adapterFactory.adapt(element, PropertiesEditingProvider.class);
    if (provider != null) {
      PropertiesEditingPolicy policy = provider.getPolicy(context);
      if (policy != null) {
        policy.execute();
        defaultLib.refresh();
      }
    }
  }

	/**
	 * @generated
	 */
	protected Composite createDefaultSuperImposedAdvancedReferencesTable(Composite parent) {
    this.defaultSuperImposed = new ReferencesTable(CallchainMessages.CallsPropertiesEditionPart_DefaultSuperImposedLabel, new ReferencesTableListener() {
      public void handleAdd() { addDefaultSuperImposed(); }
      public void handleEdit(EObject element) { editDefaultSuperImposed(element); }
      public void handleMove(EObject element, int oldIndex, int newIndex) { moveDefaultSuperImposed(element, oldIndex, newIndex); }
      public void handleRemove(EObject element) { removeFromDefaultSuperImposed(element); }
      public void navigateTo(EObject element) { }
    });
    this.defaultSuperImposed.setHelpText(propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Calls.Properties.defaultSuperImposed, CallchainViewsRepository.SWT_KIND));
    this.defaultSuperImposed.createControls(parent);
    this.defaultSuperImposed.addSelectionListener(new SelectionAdapter() {
      
      public void widgetSelected(SelectionEvent e) {
        if (e.item != null && e.item.getData() instanceof EObject) {
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.defaultSuperImposed, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SELECTION_CHANGED, null, e.item.getData()));
        }
      }
      
    });
    GridData defaultSuperImposedData = new GridData(GridData.FILL_HORIZONTAL);
    defaultSuperImposedData.horizontalSpan = 3;
    this.defaultSuperImposed.setLayoutData(defaultSuperImposedData);
    this.defaultSuperImposed.disableMove();
    defaultSuperImposed.setID(CallchainViewsRepository.Calls.Properties.defaultSuperImposed);
    defaultSuperImposed.setEEFType("eef::AdvancedReferencesTable"); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	protected void addDefaultSuperImposed() {
    TabElementTreeSelectionDialog dialog = new TabElementTreeSelectionDialog(defaultSuperImposed.getInput(), defaultSuperImposedFilters, defaultSuperImposedBusinessFilters,
    "defaultSuperImposed", propertiesEditionComponent.getEditingContext().getAdapterFactory(), current.eResource()) {
      @Override
      public void process(IStructuredSelection selection) {
        for (Iterator<?> iter = selection.iterator(); iter.hasNext();) {
          EObject elem = (EObject) iter.next();
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.defaultSuperImposed,
            PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, elem));
        }
        defaultSuperImposed.refresh();
      }
    };
    dialog.open();
  }

	/**
	 * @generated
	 */
	protected void moveDefaultSuperImposed(EObject element, int oldIndex, int newIndex) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.defaultSuperImposed, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.MOVE, element, newIndex));
    defaultSuperImposed.refresh();
  }

	/**
	 * @generated
	 */
	protected void removeFromDefaultSuperImposed(EObject element) {
    propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.defaultSuperImposed, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.REMOVE, null, element));
    defaultSuperImposed.refresh();
  }

	/**
	 * @generated
	 */
	protected void editDefaultSuperImposed(EObject element) {
    EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(propertiesEditionComponent.getEditingContext(), propertiesEditionComponent, element, adapterFactory);
    PropertiesEditingProvider provider = (PropertiesEditingProvider)adapterFactory.adapt(element, PropertiesEditingProvider.class);
    if (provider != null) {
      PropertiesEditingPolicy policy = provider.getPolicy(context);
      if (policy != null) {
        policy.execute();
        defaultSuperImposed.refresh();
      }
    }
  }

	/**
	 * @generated
	 */
	
	protected Composite createLogDefaultCheckbox(Composite parent) {
    logDefault = new Button(parent, SWT.CHECK);
    logDefault.setText(CallchainMessages.CallsPropertiesEditionPart_LogDefaultLabel);
    logDefault.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(CallsPropertiesEditionPartImpl.this, CallchainViewsRepository.Calls.Properties.logDefault, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(logDefault.getSelection())));
      }

    });
    GridData logDefaultData = new GridData(GridData.FILL_HORIZONTAL);
    logDefaultData.horizontalSpan = 2;
    logDefault.setLayoutData(logDefaultData);
    EditingUtils.setID(logDefault, CallchainViewsRepository.Calls.Properties.logDefault);
    EditingUtils.setEEFtype(logDefault, "eef::Checkbox"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Calls.Properties.logDefault, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#getName()
	 * @generated
	 */
	public String getName() {
    return name.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#setName(String newValue)
	 * @generated
	 */
	public void setName(String newValue) {
    if (newValue != null) {
      name.setText(newValue);
    } else {
      name.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#getDefaultStartPoint()
	 * @generated
	 */
	public EObject getDefaultStartPoint() {
    if (defaultStartPoint.getSelection() instanceof StructuredSelection) {
      Object firstElement = ((StructuredSelection) defaultStartPoint.getSelection()).getFirstElement();
      if (firstElement instanceof EObject)
        return (EObject) firstElement;
    }
    return null;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#initDefaultStartPoint(EObjectFlatComboSettings)
	 */
	public void initDefaultStartPoint(EObjectFlatComboSettings settings) {
		defaultStartPoint.setInput(settings);
		if (current != null) {
			defaultStartPoint.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#setDefaultStartPoint(EObject newValue)
	 * @generated
	 */
	public void setDefaultStartPoint(EObject newValue) {
    if (newValue != null) {
      defaultStartPoint.setSelection(new StructuredSelection(newValue));
    } else {
      defaultStartPoint.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#setDefaultStartPointButtonMode(ButtonsModeEnum newValue)
	 */
	public void setDefaultStartPointButtonMode(ButtonsModeEnum newValue) {
		defaultStartPoint.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#addFilterDefaultStartPoint(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToDefaultStartPoint(ViewerFilter filter) {
    defaultStartPoint.addFilter(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#addBusinessFilterDefaultStartPoint(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToDefaultStartPoint(ViewerFilter filter) {
    defaultStartPoint.addBusinessRuleFilter(filter);
  }




	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#initStartPoints(org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings)
	 */
	public void initStartPoints(ReferencesTableSettings settings) {
		if (current.eResource() != null && current.eResource().getResourceSet() != null)
			this.resourceSet = current.eResource().getResourceSet();
		ReferencesTableContentProvider contentProvider = new ReferencesTableContentProvider();
		startPoints.setContentProvider(contentProvider);
		startPoints.setInput(settings);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#updateStartPoints()
	 * @generated
	 */
	public void updateStartPoints() {
  startPoints.refresh();
}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#addFilterStartPoints(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToStartPoints(ViewerFilter filter) {
    startPointsFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#addBusinessFilterStartPoints(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToStartPoints(ViewerFilter filter) {
    startPointsBusinessFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#isContainedInStartPointsTable(EObject element)
	 * @generated
	 */
	public boolean isContainedInStartPointsTable(EObject element) {
    return ((ReferencesTableSettings)startPoints.getInput()).contains(element);
  }




	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#initProperties(EObject current, EReference containingFeature, EReference feature)
	 */
	public void initProperties(ReferencesTableSettings settings) {
		if (current.eResource() != null && current.eResource().getResourceSet() != null)
			this.resourceSet = current.eResource().getResourceSet();
		ReferencesTableContentProvider contentProvider = new ReferencesTableContentProvider();
		properties.setContentProvider(contentProvider);
		properties.setInput(settings);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#updateProperties()
	 * @generated
	 */
	public void updateProperties() {
  properties.refresh();
}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#addFilterProperties(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToProperties(ViewerFilter filter) {
    propertiesFilters.add(filter);
    if (this.properties != null) {
      this.properties.addFilter(filter);
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#addBusinessFilterProperties(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToProperties(ViewerFilter filter) {
    propertiesBusinessFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#isContainedInPropertiesTable(EObject element)
	 * @generated
	 */
	public boolean isContainedInPropertiesTable(EObject element) {
    return ((ReferencesTableSettings)properties.getInput()).contains(element);
  }




	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#initDefaultLib(org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings)
	 */
	public void initDefaultLib(ReferencesTableSettings settings) {
		if (current.eResource() != null && current.eResource().getResourceSet() != null)
			this.resourceSet = current.eResource().getResourceSet();
		ReferencesTableContentProvider contentProvider = new ReferencesTableContentProvider();
		defaultLib.setContentProvider(contentProvider);
		defaultLib.setInput(settings);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#updateDefaultLib()
	 * @generated
	 */
	public void updateDefaultLib() {
  defaultLib.refresh();
}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#addFilterDefaultLib(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToDefaultLib(ViewerFilter filter) {
    defaultLibFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#addBusinessFilterDefaultLib(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToDefaultLib(ViewerFilter filter) {
    defaultLibBusinessFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#isContainedInDefaultLibTable(EObject element)
	 * @generated
	 */
	public boolean isContainedInDefaultLibTable(EObject element) {
    return ((ReferencesTableSettings)defaultLib.getInput()).contains(element);
  }




	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#initDefaultSuperImposed(org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings)
	 */
	public void initDefaultSuperImposed(ReferencesTableSettings settings) {
		if (current.eResource() != null && current.eResource().getResourceSet() != null)
			this.resourceSet = current.eResource().getResourceSet();
		ReferencesTableContentProvider contentProvider = new ReferencesTableContentProvider();
		defaultSuperImposed.setContentProvider(contentProvider);
		defaultSuperImposed.setInput(settings);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#updateDefaultSuperImposed()
	 * @generated
	 */
	public void updateDefaultSuperImposed() {
  defaultSuperImposed.refresh();
}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#addFilterDefaultSuperImposed(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToDefaultSuperImposed(ViewerFilter filter) {
    defaultSuperImposedFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#addBusinessFilterDefaultSuperImposed(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToDefaultSuperImposed(ViewerFilter filter) {
    defaultSuperImposedBusinessFilters.add(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#isContainedInDefaultSuperImposedTable(EObject element)
	 * @generated
	 */
	public boolean isContainedInDefaultSuperImposedTable(EObject element) {
    return ((ReferencesTableSettings)defaultSuperImposed.getInput()).contains(element);
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#getLogDefault()
	 * @generated
	 */
	public Boolean getLogDefault() {
    return Boolean.valueOf(logDefault.getSelection());
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.CallsPropertiesEditionPart#setLogDefault(Boolean newValue)
	 * @generated
	 */
	public void setLogDefault(Boolean newValue) {
    if (newValue != null) {
      logDefault.setSelection(newValue.booleanValue());
    } else {
      logDefault.setSelection(false);
    }
  }







	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.Calls_Part_Title;
  }



}
