/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.impl;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.widgets.AdvancedEObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.AdvancedEObjectFlatComboViewer.EObjectFlatComboViewerListener;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.SWTUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.NotPredicatePropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class NotPredicatePropertiesEditionPartImpl extends CompositePropertiesEditionPart implements ISWTPropertiesEditionPart, NotPredicatePropertiesEditionPart {

	private AdvancedEObjectFlatComboViewer predicate;
	protected ViewerFilter predicateFilter;



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public NotPredicatePropertiesEditionPartImpl(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createFigure(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public Composite createFigure(final Composite parent) {
    view = new Composite(parent, SWT.NONE);
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(view);
    return view;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createControls(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(Composite view) { 
    CompositionSequence notPredicateStep = new BindingCompositionSequence(propertiesEditionComponent);
    notPredicateStep
      .addStep(CallchainViewsRepository.NotPredicate.Properties.class)
      .addStep(CallchainViewsRepository.NotPredicate.Properties.predicate);
    
    
    composer = new PartComposer(notPredicateStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.NotPredicate.Properties.class) {
          return createPropertiesGroup(parent);
        }
        if (key == CallchainViewsRepository.NotPredicate.Properties.predicate) {
          return createPredicateAdvancedFlatComboViewer(parent);
        }
        return parent;
      }
    };
    composer.compose(view);
  }

	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(Composite parent) {
    Group propertiesGroup = new Group(parent, SWT.NONE);
    propertiesGroup.setText(CallchainMessages.NotPredicatePropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesGroupData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesGroupData.horizontalSpan = 3;
    propertiesGroup.setLayoutData(propertiesGroupData);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    return propertiesGroup;
  }

	/**
	 * @param parent the parent composite
	 * @generated
	 */
	protected Composite createPredicateAdvancedFlatComboViewer(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.NotPredicatePropertiesEditionPart_PredicateLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.NotPredicate.Properties.predicate, CallchainViewsRepository.SWT_KIND));
    // create callback listener
    EObjectFlatComboViewerListener listener = new EObjectFlatComboViewerListener(){
      public void handleSet(EObject element){
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(NotPredicatePropertiesEditionPartImpl.this, CallchainViewsRepository.NotPredicate.Properties.predicate, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, element)); 
      }
      public void navigateTo(EObject element){ }

      public EObject handleCreate() {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(NotPredicatePropertiesEditionPartImpl.this, CallchainViewsRepository.NotPredicate.Properties.predicate, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, null)); 
        return null;
      }
    };
    //create widget
    predicate = new AdvancedEObjectFlatComboViewer(CallchainMessages.NotPredicatePropertiesEditionPart_PredicateLabel, resourceSet, predicateFilter, propertiesEditionComponent.getEditingContext().getAdapterFactory(), listener);
    predicate.createControls(parent);
    GridData predicateData = new GridData(GridData.FILL_HORIZONTAL);
    predicate.setLayoutData(predicateData);
    predicate.setID(CallchainViewsRepository.NotPredicate.Properties.predicate);
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.NotPredicate.Properties.predicate, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.NotPredicatePropertiesEditionPart#getPredicate()
	 * @generated
	 */
	public EObject getPredicate() {
    return predicate.getSelection();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.NotPredicatePropertiesEditionPart#initPredicate(EObjectFlatComboSettings)
	 */
	public void initPredicate(EObjectFlatComboSettings settings) {
		predicate.setInput(settings);
		if (current != null) {
			predicate.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.NotPredicatePropertiesEditionPart#setPredicate(EObject newValue)
	 * @generated
	 */
	public void setPredicate(EObject newValue) {
    if (newValue != null) {
      predicate.setSelection(new StructuredSelection(newValue));
    } else {
      predicate.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.NotPredicatePropertiesEditionPart#setPredicateButtonMode(ButtonsModeEnum newValue)
	 */
	public void setPredicateButtonMode(ButtonsModeEnum newValue) {
		predicate.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.NotPredicatePropertiesEditionPart#addFilterPredicate(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToPredicate(ViewerFilter filter) {
    predicate.addFilter(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.NotPredicatePropertiesEditionPart#addBusinessFilterPredicate(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToPredicate(ViewerFilter filter) {
    predicate.addBusinessRuleFilter(filter);
  }







	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.NotPredicate_Part_Title;
  }



}
