/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.impl;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.EObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.SWTUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class PropertyMapperPropertiesEditionPartImpl extends CompositePropertiesEditionPart implements ISWTPropertiesEditionPart, PropertyMapperPropertiesEditionPart {

	protected EObjectFlatComboViewer input;
	protected EObjectFlatComboViewer output;



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public PropertyMapperPropertiesEditionPartImpl(IPropertiesEditionComponent editionComponent) {
		super(editionComponent);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createFigure(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public Composite createFigure(final Composite parent) {
		view = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.numColumns = 3;
		view.setLayout(layout);
		createControls(view);
		return view;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createControls(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(Composite view) { 
		CompositionSequence propertyMapperStep = new BindingCompositionSequence(propertiesEditionComponent);
		CompositionStep propertiesStep = propertyMapperStep.addStep(CallchainViewsRepository.PropertyMapper.Properties.class);
		propertiesStep.addStep(CallchainViewsRepository.PropertyMapper.Properties.input);
		propertiesStep.addStep(CallchainViewsRepository.PropertyMapper.Properties.output);
		
		
		composer = new PartComposer(propertyMapperStep) {

			@Override
			public Composite addToPart(Composite parent, Object key) {
				if (key == CallchainViewsRepository.PropertyMapper.Properties.class) {
					return createPropertiesGroup(parent);
				}
				if (key == CallchainViewsRepository.PropertyMapper.Properties.input) {
					return createInputFlatComboViewer(parent);
				}
				if (key == CallchainViewsRepository.PropertyMapper.Properties.output) {
					return createOutputFlatComboViewer(parent);
				}
				return parent;
			}
		};
		composer.compose(view);
	}

	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(Composite parent) {
		Group propertiesGroup = new Group(parent, SWT.NONE);
		propertiesGroup.setText(CallchainMessages.PropertyMapperPropertiesEditionPart_PropertiesGroupLabel);
		GridData propertiesGroupData = new GridData(GridData.FILL_HORIZONTAL);
		propertiesGroupData.horizontalSpan = 3;
		propertiesGroup.setLayoutData(propertiesGroupData);
		GridLayout propertiesGroupLayout = new GridLayout();
		propertiesGroupLayout.numColumns = 3;
		propertiesGroup.setLayout(propertiesGroupLayout);
		return propertiesGroup;
	}

	/**
	 * @param parent the parent composite
	 * @generated
	 */
	protected Composite createInputFlatComboViewer(Composite parent) {
		SWTUtils.createPartLabel(parent, CallchainMessages.PropertyMapperPropertiesEditionPart_InputLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyMapper.Properties.input, CallchainViewsRepository.SWT_KIND));
		input = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyMapper.Properties.input, CallchainViewsRepository.SWT_KIND));
		input.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));

		input.addSelectionChangedListener(new ISelectionChangedListener() {

			public void selectionChanged(SelectionChangedEvent event) {
				propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(PropertyMapperPropertiesEditionPartImpl.this, CallchainViewsRepository.PropertyMapper.Properties.input, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SET, null, getInput()));
			}

		});
		GridData inputData = new GridData(GridData.FILL_HORIZONTAL);
		input.setLayoutData(inputData);
		input.setID(CallchainViewsRepository.PropertyMapper.Properties.input);
		SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.PropertyMapper.Properties.input, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
		return parent;
	}

	/**
	 * @param parent the parent composite
	 * @generated
	 */
	protected Composite createOutputFlatComboViewer(Composite parent) {
		SWTUtils.createPartLabel(parent, CallchainMessages.PropertyMapperPropertiesEditionPart_OutputLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyMapper.Properties.output, CallchainViewsRepository.SWT_KIND));
		output = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyMapper.Properties.output, CallchainViewsRepository.SWT_KIND));
		output.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));

		output.addSelectionChangedListener(new ISelectionChangedListener() {

			public void selectionChanged(SelectionChangedEvent event) {
				propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(PropertyMapperPropertiesEditionPartImpl.this, CallchainViewsRepository.PropertyMapper.Properties.output, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SET, null, getOutput()));
			}

		});
		GridData outputData = new GridData(GridData.FILL_HORIZONTAL);
		output.setLayoutData(outputData);
		output.setID(CallchainViewsRepository.PropertyMapper.Properties.output);
		SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.PropertyMapper.Properties.output, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
		return parent;
	}



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#getInput()
	 * @generated
	 */
	public EObject getInput() {
		if (input.getSelection() instanceof StructuredSelection) {
			Object firstElement = ((StructuredSelection) input.getSelection()).getFirstElement();
			if (firstElement instanceof EObject)
				return (EObject) firstElement;
		}
		return null;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#initInput(EObjectFlatComboSettings)
	 */
	public void initInput(EObjectFlatComboSettings settings) {
		input.setInput(settings);
		if (current != null) {
			input.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#setInput(EObject newValue)
	 * @generated
	 */
	public void setInput(EObject newValue) {
		if (newValue != null) {
			input.setSelection(new StructuredSelection(newValue));
		} else {
			input.setSelection(new StructuredSelection()); //$NON-NLS-1$
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#setInputButtonMode(ButtonsModeEnum newValue)
	 */
	public void setInputButtonMode(ButtonsModeEnum newValue) {
		input.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#addFilterInput(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToInput(ViewerFilter filter) {
		input.addFilter(filter);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#addBusinessFilterInput(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToInput(ViewerFilter filter) {
		input.addBusinessRuleFilter(filter);
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#getOutput()
	 * @generated
	 */
	public EObject getOutput() {
		if (output.getSelection() instanceof StructuredSelection) {
			Object firstElement = ((StructuredSelection) output.getSelection()).getFirstElement();
			if (firstElement instanceof EObject)
				return (EObject) firstElement;
		}
		return null;
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#initOutput(EObjectFlatComboSettings)
	 */
	public void initOutput(EObjectFlatComboSettings settings) {
		output.setInput(settings);
		if (current != null) {
			output.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#setOutput(EObject newValue)
	 * @generated
	 */
	public void setOutput(EObject newValue) {
		if (newValue != null) {
			output.setSelection(new StructuredSelection(newValue));
		} else {
			output.setSelection(new StructuredSelection()); //$NON-NLS-1$
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#setOutputButtonMode(ButtonsModeEnum newValue)
	 */
	public void setOutputButtonMode(ButtonsModeEnum newValue) {
		output.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#addFilterOutput(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToOutput(ViewerFilter filter) {
		output.addFilter(filter);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyMapperPropertiesEditionPart#addBusinessFilterOutput(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToOutput(ViewerFilter filter) {
		output.addBusinessRuleFilter(filter);
	}







	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
		return CallchainMessages.PropertyMapper_Part_Title;
	}



}
