/*
 * (c) urs zeidler
 */
package de.urszeidler.eclipse.callchain.propertySource;

import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.presentation.EcoreActionBarContributor.ExtendedLoadResourceAction.ExtendedLoadResourceDialog;
import org.eclipse.emf.ecore.presentation.EcoreActionBarContributor.ExtendedLoadResourceAction.RegisteredPackageDialog;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.DialogCellEditor;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

/**
 * <p>
 * EMFDialog
 * </p>
 * Created : 13.03.2007
 * 
 * @author urs
 * @version $Revision: 1.1 $, $Id: EMFDialog.java,v 1.1 2008/04/09 22:41:56 urs
 *          Exp $
 */
public class EMFDialog extends org.eclipse.emf.edit.ui.provider.PropertyDescriptor {

	private String text;

	public EMFDialog(Object object, IItemPropertyDescriptor itemPropertyDescriptor) {
		super(object, itemPropertyDescriptor);
	}

	@Override
	protected CellEditor createEDataTypeCellEditor(EDataType eDataType, Composite composite) {
		return super.createEDataTypeCellEditor(eDataType, composite);
	}

	@Override
	public CellEditor createPropertyEditor(Composite composite) {
		return new DialogCellEditor(composite) {
			@Override
			protected Object openDialogBox(Control cellEditorWindow) {
				ExtendedLoadResourceDialog loadResourceDialog = new ExtendedLoadResourceDialog(cellEditorWindow
						.getShell(), (EditingDomain) null) {

					protected void prepareBrowseRegisteredPackagesButton(Button browseRegisteredPackagesButton) {
						uriText = text;
						browseRegisteredPackagesButton.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent event) {
								RegisteredPackageDialog registeredPackageDialog = new RegisteredPackageDialog(
										getShell());
								registeredPackageDialog.open();
								Object result = registeredPackageDialog.getFirstResult();
								if (result != null) {
									uriField.setText((uriField.getText() + "  uri:" + result.toString()).trim());

								}
							}
						});
					}
				};

				loadResourceDialog.open();

				return loadResourceDialog.getURIText();
			}
		};
	}
}
