/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallItemProvider.java,v 1.1 2008/04/09 22:41:56 urs Exp $
 */
package de.urszeidler.eclipse.callchain.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.CallchainFactory;
import de.urszeidler.eclipse.callchain.CallchainPackage;

/**
 * This is the item provider adapter for a {@link de.urszeidler.eclipse.callchain.Call} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CallItemProvider
	extends ItemProviderAdapter
	implements	
		IEditingDomainItemProvider,	
		IStructuredItemContentProvider,	
		ITreeItemContentProvider,	
		IItemLabelProvider,	
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addCommentsPropertyDescriptor(object);
			addNextPropertyDescriptor(object);
			addNamePropertyDescriptor(object);
			addRefreshWorkspacePropertyDescriptor(object);
			addInPropertyDescriptor(object);
			addOutPropertyDescriptor(object);
			addResPropertyDescriptor(object);
			addLibarysPropertyDescriptor(object);
			addAllowInterModelReferencesPropertyDescriptor(object);
			addContinueAfterErrorsPropertyDescriptor(object);
			addArtifactPropertyDescriptor(object);
			addShowSummaryPropertyDescriptor(object);
			addPrintExecutionTimePropertyDescriptor(object);
			addDisableAttributeHelperCachePropertyDescriptor(object);
			addProfilePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Comments feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addCommentsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Documentable_comments_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Documentable_comments_feature", "_UI_Documentable_type"),
				 CallchainPackage.Literals.DOCUMENTABLE__COMMENTS,
				 true,
				 true,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Next feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNextPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Callable_next_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Callable_next_feature", "_UI_Callable_type"),
				 CallchainPackage.Literals.CALLABLE__NEXT,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Callable_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Callable_name_feature", "_UI_Callable_type"),
				 CallchainPackage.Literals.CALLABLE__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Refresh Workspace feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addRefreshWorkspacePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Callable_refreshWorkspace_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Callable_refreshWorkspace_feature", "_UI_Callable_type"),
				 CallchainPackage.Literals.CALLABLE__REFRESH_WORKSPACE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the In feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addInPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_in_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_in_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__IN,
				 true,
				 false,
				 false,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Out feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addOutPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_out_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_out_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__OUT,
				 true,
				 false,
				 false,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Res feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addResPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_res_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_res_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__RES,
				 true,
				 false,
				 false,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Libarys feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLibarysPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_libarys_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_libarys_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__LIBARYS,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Allow Inter Model References feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addAllowInterModelReferencesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_allowInterModelReferences_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_allowInterModelReferences_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__ALLOW_INTER_MODEL_REFERENCES,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Continue After Errors feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addContinueAfterErrorsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_continueAfterErrors_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_continueAfterErrors_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__CONTINUE_AFTER_ERRORS,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Artifact feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addArtifactPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_artifact_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_artifact_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__ARTIFACT,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Show Summary feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addShowSummaryPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_showSummary_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_showSummary_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__SHOW_SUMMARY,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Print Execution Time feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addPrintExecutionTimePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_printExecutionTime_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_printExecutionTime_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__PRINT_EXECUTION_TIME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Disable Attribute Helper Cache feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addDisableAttributeHelperCachePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_disableAttributeHelperCache_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_disableAttributeHelperCache_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__DISABLE_ATTRIBUTE_HELPER_CACHE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Profile feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addProfilePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Call_profile_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Call_profile_feature", "_UI_Call_type"),
				 CallchainPackage.Literals.CALL__PROFILE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(CallchainPackage.Literals.DOCUMENTABLE__COMMENTS);
			childrenFeatures.add(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Call.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Call"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((Call)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_Call_type") :
			getString("_UI_Call_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Call.class)) {
			case CallchainPackage.CALL__NAME:
			case CallchainPackage.CALL__REFRESH_WORKSPACE:
			case CallchainPackage.CALL__IN:
			case CallchainPackage.CALL__OUT:
			case CallchainPackage.CALL__RES:
			case CallchainPackage.CALL__ALLOW_INTER_MODEL_REFERENCES:
			case CallchainPackage.CALL__CONTINUE_AFTER_ERRORS:
			case CallchainPackage.CALL__SHOW_SUMMARY:
			case CallchainPackage.CALL__PRINT_EXECUTION_TIME:
			case CallchainPackage.CALL__DISABLE_ATTRIBUTE_HELPER_CACHE:
			case CallchainPackage.CALL__PROFILE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case CallchainPackage.CALL__COMMENTS:
			case CallchainPackage.CALL__PREDICATE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.DOCUMENTABLE__COMMENTS,
				 CallchainFactory.eINSTANCE.createComment()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createPropertyHasValue()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createPropertyExist()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createResourceExistPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createAndPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createOrPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createNotPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createBooleanPredicate()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return CallchainEditPlugin.INSTANCE;
	}

}
