/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallsItemProvider.java,v 1.2 2008/04/13 20:27:37 urs Exp $
 */
package de.urszeidler.eclipse.callchain.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.urszeidler.eclipse.callchain.CallchainFactory;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;

/**
 * This is the item provider adapter for a {@link de.urszeidler.eclipse.callchain.Calls} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CallsItemProvider
	extends ItemProviderAdapter
	implements	
		IEditingDomainItemProvider,	
		IStructuredItemContentProvider,	
		ITreeItemContentProvider,	
		IItemLabelProvider,	
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallsItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addCommentsPropertyDescriptor(object);
			addDefaultLibPropertyDescriptor(object);
			addDefaultSuperImposedPropertyDescriptor(object);
			addStartPointsPropertyDescriptor(object);
			addDefaultStartPointPropertyDescriptor(object);
			addLogDefaultPropertyDescriptor(object);
			addNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Comments feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addCommentsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Documentable_comments_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Documentable_comments_feature", "_UI_Documentable_type"),
				 CallchainPackage.Literals.DOCUMENTABLE__COMMENTS,
				 true,
				 true,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Default Lib feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addDefaultLibPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Calls_defaultLib_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Calls_defaultLib_feature", "_UI_Calls_type"),
				 CallchainPackage.Literals.CALLS__DEFAULT_LIB,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Default Super Imposed feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addDefaultSuperImposedPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Calls_defaultSuperImposed_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Calls_defaultSuperImposed_feature", "_UI_Calls_type"),
				 CallchainPackage.Literals.CALLS__DEFAULT_SUPER_IMPOSED,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Start Points feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addStartPointsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Calls_startPoints_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Calls_startPoints_feature", "_UI_Calls_type"),
				 CallchainPackage.Literals.CALLS__START_POINTS,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Default Start Point feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addDefaultStartPointPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Calls_defaultStartPoint_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Calls_defaultStartPoint_feature", "_UI_Calls_type"),
				 CallchainPackage.Literals.CALLS__DEFAULT_START_POINT,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Log Default feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLogDefaultPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Calls_logDefault_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Calls_logDefault_feature", "_UI_Calls_type"),
				 CallchainPackage.Literals.CALLS__LOG_DEFAULT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Calls_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Calls_name_feature", "_UI_Calls_type"),
				 CallchainPackage.Literals.CALLS__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(CallchainPackage.Literals.DOCUMENTABLE__COMMENTS);
			childrenFeatures.add(CallchainPackage.Literals.CALLS__CALL);
			childrenFeatures.add(CallchainPackage.Literals.CALLS__GENERATORS);
			childrenFeatures.add(CallchainPackage.Literals.CALLS__ARTIFACTS);
			childrenFeatures.add(CallchainPackage.Literals.CALLS__PROPERTIES);
			childrenFeatures.add(CallchainPackage.Literals.CALLS__SWITCHES);
			childrenFeatures.add(CallchainPackage.Literals.CALLS__EXTERN_CALLABLES);
			childrenFeatures.add(CallchainPackage.Literals.CALLS__STOP_ELEMENTS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Calls.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Calls"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((Calls)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_Calls_type") :
			getString("_UI_Calls_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Calls.class)) {
			case CallchainPackage.CALLS__LOG_DEFAULT:
			case CallchainPackage.CALLS__NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case CallchainPackage.CALLS__COMMENTS:
			case CallchainPackage.CALLS__CALL:
			case CallchainPackage.CALLS__GENERATORS:
			case CallchainPackage.CALLS__ARTIFACTS:
			case CallchainPackage.CALLS__PROPERTIES:
			case CallchainPackage.CALLS__SWITCHES:
			case CallchainPackage.CALLS__EXTERN_CALLABLES:
			case CallchainPackage.CALLS__STOP_ELEMENTS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.DOCUMENTABLE__COMMENTS,
				 CallchainFactory.eINSTANCE.createComment()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__CALL,
				 CallchainFactory.eINSTANCE.createCall()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__GENERATORS,
				 CallchainFactory.eINSTANCE.createGeneric_Generator()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__ARTIFACTS,
				 CallchainFactory.eINSTANCE.createArtifact()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__ARTIFACTS,
				 CallchainFactory.eINSTANCE.createModel()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__ARTIFACTS,
				 CallchainFactory.eINSTANCE.createAtlRes()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__ARTIFACTS,
				 CallchainFactory.eINSTANCE.createMM()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__ARTIFACTS,
				 CallchainFactory.eINSTANCE.createAtlLibary()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__ARTIFACTS,
				 CallchainFactory.eINSTANCE.createModelAlias()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__ARTIFACTS,
				 CallchainFactory.eINSTANCE.createMMAlias()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__PROPERTIES,
				 CallchainFactory.eINSTANCE.createProperty()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__SWITCHES,
				 CallchainFactory.eINSTANCE.createPredicateSwitch()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__SWITCHES,
				 CallchainFactory.eINSTANCE.createPropertyValueSwitch()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__EXTERN_CALLABLES,
				 CallchainFactory.eINSTANCE.createExternalCallable()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.CALLS__STOP_ELEMENTS,
				 CallchainFactory.eINSTANCE.createStopCall()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return CallchainEditPlugin.INSTANCE;
	}

}
