/**
 * 
 */
package de.urszeidler.eclipse.callchain.provider;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.edit.provider.AdapterFactoryItemDelegator;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.ReflectiveItemProviderAdapterFactory;
import org.eclipse.emf.edit.provider.resource.ResourceItemProviderAdapterFactory;

/**
 * @author urs
 *
 */
public class DefaultAdapterFactory {

	private static DefaultAdapterFactory instance;
	private ComposedAdapterFactory adapterFactory;
	private AdapterFactoryItemDelegator itemDelegator;

	/**
	 * 
	 */
	public DefaultAdapterFactory() {
		super();
		adapterFactory = new ComposedAdapterFactory(ComposedAdapterFactory.Descriptor.Registry.INSTANCE);

		adapterFactory.addAdapterFactory(new ResourceItemProviderAdapterFactory());
		adapterFactory.addAdapterFactory(new CallchainItemProviderAdapterFactory());
		adapterFactory.addAdapterFactory(new ReflectiveItemProviderAdapterFactory());
		itemDelegator = new AdapterFactoryItemDelegator(adapterFactory);
	}

	public static DefaultAdapterFactory getInstance(){
		if(instance==null){
			instance = new DefaultAdapterFactory();
		}
		return instance;
	}

	public ComposedAdapterFactory getAdapterFactory() {
		return adapterFactory;
	}

	public AdapterFactoryItemDelegator getItemDelegator() {
		return itemDelegator;
	}
	
}
