/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.urszeidler.eclipse.callchain.provider;

import de.urszeidler.eclipse.callchain.CallchainFactory;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.ExternalCallable;

/**
 * This is the item provider adapter for a
 * {@link de.urszeidler.eclipse.callchain.ExternalCallable} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ExternalCallableItemProvider extends ItemProviderAdapter implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ExternalCallableItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNextPropertyDescriptor(object);
			addNamePropertyDescriptor(object);
			addRefreshWorkspacePropertyDescriptor(object);
			addCommentsPropertyDescriptor(object);
			addDelegatedCallablePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Next feature.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNextPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Callable_next_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Callable_next_feature", "_UI_Callable_type"),
				 CallchainPackage.Literals.CALLABLE__NEXT,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Callable_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Callable_name_feature", "_UI_Callable_type"),
				 CallchainPackage.Literals.CALLABLE__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Refresh Workspace feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addRefreshWorkspacePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Callable_refreshWorkspace_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Callable_refreshWorkspace_feature", "_UI_Callable_type"),
				 CallchainPackage.Literals.CALLABLE__REFRESH_WORKSPACE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Comments feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addCommentsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Documentable_comments_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Documentable_comments_feature", "_UI_Documentable_type"),
				 CallchainPackage.Literals.DOCUMENTABLE__COMMENTS,
				 true,
				 true,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Delegated Callable feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addDelegatedCallablePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ExternalCallable_delegatedCallable_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ExternalCallable_delegatedCallable_feature", "_UI_ExternalCallable_type"),
				 CallchainPackage.Literals.EXTERNAL_CALLABLE__DELEGATED_CALLABLE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(CallchainPackage.Literals.DOCUMENTABLE__COMMENTS);
			childrenFeatures.add(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE);
			childrenFeatures.add(CallchainPackage.Literals.EXTERNAL_CALLABLE__MAPPERS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns ExternalCallable.gif.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ExternalCallable"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public String getText(Object object) {
		ExternalCallable externalCallable = (ExternalCallable) object;
		String name = "";
		if (externalCallable.getEnviorment() != null)
			name = externalCallable.getEnviorment().getName();
		String delegatedName = "";
		if (externalCallable.getDelegatedCallable() != null) {
			Callable delegatedCallable = externalCallable.getDelegatedCallable();
			delegatedName = externalCallable.getDelegatedCallable().getName();
			if (delegatedCallable.eContainer() instanceof Calls) {
				Calls calls = (Calls) delegatedCallable.eContainer();
				delegatedName = calls.getName() + " -> " + delegatedName;
			}
		}

		String label = "";
		if (externalCallable.getName() != null)
			label = externalCallable.getName();

		label = label + "[" + delegatedName + "]";
		return getString("_UI_ExternalCallable_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ExternalCallable.class)) {
			case CallchainPackage.EXTERNAL_CALLABLE__NAME:
			case CallchainPackage.EXTERNAL_CALLABLE__REFRESH_WORKSPACE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__COMMENTS:
			case CallchainPackage.EXTERNAL_CALLABLE__PREDICATE:
			case CallchainPackage.EXTERNAL_CALLABLE__MAPPERS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.DOCUMENTABLE__COMMENTS,
				 CallchainFactory.eINSTANCE.createComment()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createPropertyHasValue()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createPropertyExist()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createResourceExistPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createAndPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createOrPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createNotPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EAVALUATEABLE__PREDICATE,
				 CallchainFactory.eINSTANCE.createBooleanPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(CallchainPackage.Literals.EXTERNAL_CALLABLE__MAPPERS,
				 CallchainFactory.eINSTANCE.createPropertyMapper()));
	}

	/**
	 * Return the resource locator for this item provider's resources. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return CallchainEditPlugin.INSTANCE;
	}

}
