/**
 * 
 */
package de.urszeidler.eclipse.callchain.tabbedpropery.sections;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.viewers.IFilter;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.MM;

/**
 * @author urs
 *
 */
public class ArtifactPropertyFilter implements IFilter {

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.IFilter#select(java.lang.Object)
	 */
	@Override
	public boolean select(Object toTest) {
		if(toTest == null)
			return false;
		
		if(!(toTest instanceof EObject))
			toTest = adaptObject(toTest);
//		if(toTest instanceof ModelEditPart)
//			return true;
//		if(toTest instanceof ArtifactEditPart)
//			return true;
		
		
		if(toTest instanceof Artifact){
//			if(toTest instanceof Model)
//				return false;			
			if(toTest instanceof MM)
				return false;
			
			return true;
		}		
		return false;
	}

	
	   public static EObject adaptObject(Object object)
	    {
	        if (object == null)
	        {
	            return null;
	        }
	        else if (object instanceof EObject)
	        {
	            return (EObject) object;
	        }
	        else if (object instanceof IAdaptable)
	        {
	            // Try IAdaptable
	            IAdaptable adapted = (IAdaptable) object;
	            Object eObject = adapted.getAdapter(EObject.class);
	            if (eObject != null)
	            {
	                return (EObject) eObject;
	            }
	        }
	        else
	        {
	            // Try registered adapter
	            Object adapted = Platform.getAdapterManager().getAdapter(object, EObject.class);
	            if (adapted != null)
	            {
	                return (EObject) adapted;
	            }
	        }
	        return null;
	    }

}
