package de.urszeidler.eclipse.callchain.tabbedpropery.sections;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecoretools.tabbedproperties.AbstractTabbedPropertySheetPage;
import org.eclipse.emf.ecoretools.tabbedproperties.EMFRecordingChangeCommand;
import org.eclipse.emf.ecoretools.tabbedproperties.providers.TabbedPropertiesLabelProvider;
import org.eclipse.emf.ecoretools.tabbedproperties.sections.AbstractTabbedPropertySection;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.ColumnViewerEditor;
import org.eclipse.jface.viewers.ColumnViewerEditorActivationEvent;
import org.eclipse.jface.viewers.ColumnViewerEditorActivationStrategy;
import org.eclipse.jface.viewers.EditingSupport;
import org.eclipse.jface.viewers.FocusCellOwnerDrawHighlighter;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.TreeViewerColumn;
import org.eclipse.jface.viewers.TreeViewerEditor;
import org.eclipse.jface.viewers.TreeViewerFocusCellManager;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.views.properties.tabbed.ITabbedPropertyConstants;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetWidgetFactory;

import de.urszeidler.eclipse.callchain.CallchainFactory;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Property;
import de.urszeidler.eclipse.callchain.provider.CallchainItemProviderAdapterFactory;

/**
 * A section which displays the multi features.<br>
 * The section features a table with two buttons letting the user to<br>
 * add or remove items from the selected object.
 *
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 *
 * @generated
 */
public class CallsPropertySection extends AbstractTabbedPropertySection {


	private class ViewerContentProvider implements ITreeContentProvider {

		public Object[] getChildren(Object parentElement) {
			if (parentElement instanceof List<?>) {
				return ((List<?>) parentElement).toArray();
			}
			if (parentElement instanceof Map<?, ?>) {
				return ((Map<?, ?>) parentElement).entrySet().toArray();
			}
			return Collections.EMPTY_LIST.toArray();
		}

		public Object getParent(Object element) {
			return null;
		}

		public boolean hasChildren(Object element) {
			if (element instanceof List<?>) {
				return ((List<?>) element).isEmpty();
			}
			if (element instanceof Map<?, ?>) {
				return ((Map<?, ?>) element).isEmpty();
			}
			return false;
		}

		public Object[] getElements(Object inputElement) {
			return getChildren(inputElement);
		}

		public void dispose() {
			// Ignore
		}

		public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
			// Ignore
		}
	}


	
    private Composite groupProperties;
	private TreeViewer propertiesViewer;
	protected Property currentProperty;

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
     * @generated
     */
    protected String getLabelText() {
        return "Properties:";
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
     * @generated not
     */
    protected EStructuralFeature getFeature() {
        return CallchainPackage.Literals.CALLS__PROPERTIES;
    }

	/**
	 * @see org.eclipse.emf.ecoretools.tabbedproperties.sections.AbstractTabbedPropertySection#createWidgets(org.eclipse.swt.widgets.Composite)
	 */
	@Override
	protected void createWidgets(Composite composite) {
//		super.createWidgets(composite);
//		
//		groupProperties = getWidgetFactory().createGroup(composite, "Properties");
//		groupProperties.setLayout(new GridLayout());
		
	
		createGroupEAnnotationContents(composite);
	}
    
     private void createGroupEAnnotationContents(Composite parent) {
 		TabbedPropertySheetWidgetFactory widgetFactory = getWidgetFactory();
		groupProperties = widgetFactory.createComposite(parent);
		groupProperties.setLayout(new GridLayout(2, false));
		//composite.setLayoutData(new GridData(GridData.FILL_BOTH));

		GridData featureViewerData2 = new GridData(GridData.FILL_BOTH);
		featureViewerData2.grabExcessHorizontalSpace = true;
		featureViewerData2.grabExcessVerticalSpace = true;
		featureViewerData2.verticalSpan = 2;
		featureViewerData2.heightHint = 80;

		createEAnnotationViewer(groupProperties, featureViewerData2);

		addRemoveButtonEAnnotationComposite(groupProperties, propertiesViewer);
	}
	
 

 	private void createEAnnotationViewer(Composite parent, GridData layoutData) {
 		propertiesViewer = createTreeViewer(parent, layoutData);

 		
 		TreeViewerColumn columnName = new TreeViewerColumn(propertiesViewer, SWT.NONE);
 		columnName.getColumn().setResizable(true);
 		columnName.getColumn().setMoveable(true);
 		columnName.getColumn().setWidth(200);
 		columnName.getColumn().setText("Name");
 		columnName.setLabelProvider(new ColumnLabelProvider() {

 		private ILabelProvider labelProvider = getLabelProvider();

 			/**
 			 * @see org.eclipse.jface.viewers.ColumnLabelProvider#getText(java.lang.Object)
 			 */
 			@Override
 			public String getText(Object element) {
 				if (element instanceof Property) {
 					return ((Property) element).getName();
 				}
 				return "---";
 			}

 			/**
 			 * @see org.eclipse.jface.viewers.ColumnLabelProvider#getImage(java.lang.Object)
 			 */
 			@Override
 			public Image getImage(Object element) {
 				return labelProvider.getImage(element);
 			}

 			/**
 			 * @see org.eclipse.jface.viewers.BaseLabelProvider#dispose()
 			 */
 			@Override
 			public void dispose() {
 				labelProvider.dispose();
 				super.dispose();
 			}

 		});
 		columnName.setEditingSupport(new EditingSupport(propertiesViewer) {
 			final TextCellEditor textCellEditor = new TextCellEditor(propertiesViewer.getTree());
 			@Override
 			protected boolean canEdit(Object element) {
 				if (false == element instanceof Property) {
 					return false;
 				}
 				return true;
 			}

 			@Override
 			protected CellEditor getCellEditor(Object element) {
 				return textCellEditor;
 			}

 			@Override
 			protected Object getValue(Object element) {
 				if (false == element instanceof Property) {
 					return ""; //$NON-NLS-1$
 				}
 				return ((((Property) element).getName() == null) ? "" : ((Property) element).getName()); //$NON-NLS-1$
 			}

 			@Override
 			protected void setValue(Object element, Object value) {
 				if (false == element instanceof Property) {
 					return;
 				}
 				final String text = value.toString();
 				final Property property = (Property) element;
 				getEditingDomain().getCommandStack().execute(new EMFRecordingChangeCommand(getEObject().eResource()) {

 					@Override
 					protected void doExecute() {
 						property.setName(text);
 					}
 				});

 				propertiesViewer.update(element, null);
 			}

 		});

 		TreeViewerColumn columnEReference = new TreeViewerColumn(propertiesViewer, SWT.NONE);
 		columnEReference.getColumn().setResizable(true);
 		columnEReference.getColumn().setMoveable(true);
 		columnEReference.getColumn().setWidth(200);
 		columnEReference.getColumn().setText("default value");
 		columnEReference.setLabelProvider(new ColumnLabelProvider() {

 			private ILabelProvider labelProvider = getLabelProvider();

 			/**
 			 * @see org.eclipse.jface.viewers.ColumnLabelProvider#getText(java.lang.Object)
 			 */
 			@Override
 			public String getText(Object element) {
 				if (false == element instanceof Property) {
 					return ""; //$NON-NLS-1$
 				}
 				return ((Property)element).getDefaultValue();
 			}

 			/**
 			 * @see org.eclipse.jface.viewers.BaseLabelProvider#dispose()
 			 */
 			@Override
 			public void dispose() {
 				labelProvider.dispose();
 				super.dispose();
 			}

 		});

 		columnEReference.setEditingSupport(new EditingSupport(propertiesViewer) {

 			//private ILabelProvider labelProvider = getLabelProvider();
 			final TextCellEditor textCellEditor = new TextCellEditor(propertiesViewer.getTree());
 			@Override
 			protected boolean canEdit(Object element) {
 				if (false == element instanceof Property) {
 					return false;
 				}
 				return true;
 			}

 			@Override
 			protected CellEditor getCellEditor(Object element) {
 				return textCellEditor;
 			}

 			@Override
 			protected Object getValue(Object element) {
 				if (false == element instanceof Property) {
 					return ""; //$NON-NLS-1$
 				}
 				return ((Property)element).getDefaultValue();
 			}

 			@Override
 			protected void setValue(Object element, final Object value) {
 				if (false == element instanceof Property || value == null) {
 					return;
 				}
 				final Property property = (Property) element;
 				getEditingDomain().getCommandStack().execute(new EMFRecordingChangeCommand(getEObject().eResource()) {

 					@Override
 					protected void doExecute() {
 						property.setDefaultValue((String) value);
 					}
 				});

 				propertiesViewer.update(element, null);
 			}

 		});

 		propertiesViewer.setContentProvider(new ViewerContentProvider());
 		propertiesViewer.addSelectionChangedListener(new ISelectionChangedListener() {

			public void selectionChanged(SelectionChangedEvent event) {
 				if (false == event.getSelection() instanceof IStructuredSelection) {
 					currentProperty = null;
 					return;
 				}
 				Object selection = ((IStructuredSelection) event.getSelection()).getFirstElement();
 				if (false == selection instanceof Property) {
 					currentProperty = null;
 					return;
 				}
 				currentProperty = (Property) selection;
 				
 			}

 		});
 		
 		
 	}


     

 	private void addRemoveButtonEAnnotationComposite(Composite parent, TreeViewer viewer) {
 		TabbedPropertySheetWidgetFactory widgetFactory = getWidgetFactory();
 		Composite comp = widgetFactory.createComposite(parent);
 		comp.setLayout(new GridLayout());

 		Button add = widgetFactory.createButton(comp, "add", SWT.NONE);
 		add.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
 		add.addSelectionListener(new SelectionListener() {

 			public void widgetDefaultSelected(SelectionEvent e) {
 				// Nothing to do
 			}

 			public void widgetSelected(SelectionEvent e) {
 				if (false == getEObject() instanceof Calls) {
 					return;
 				}
 				final Property property = CallchainFactory.eINSTANCE.createProperty();
 
 				getEditingDomain().getCommandStack().execute(new EMFRecordingChangeCommand(getEObject().eResource()) {

 					@Override
 					protected void doExecute() {
 						((Calls) getEObject()).getProperties().add(property);
 					}
 				});

 				propertiesViewer.setInput(((Calls) getEObject()).getProperties());
 			}

 
 		});

 		Button remove = widgetFactory.createButton(comp, "remove", SWT.NONE);
 		remove.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
 		remove.addSelectionListener(new SelectionListener() {

 			public void widgetDefaultSelected(SelectionEvent e) {
 				// Nothing to do
 			}

 			public void widgetSelected(SelectionEvent e) {
 				if (false == getEObject() instanceof Calls) {
 					return;
 				}
 				getEditingDomain().getCommandStack().execute(new EMFRecordingChangeCommand(getEObject().eResource()) {

 					@Override
 					protected void doExecute() {
 						((Calls) getEObject()).getProperties().remove(currentProperty);
 					}
 				});

 				propertiesViewer.setInput(((Calls) getEObject()).getProperties());
 			}

 		});
 	}

 	private TreeViewer createTreeViewer(Composite parent, GridData layoutData) {
		TreeViewer treeViewer = new TreeViewer(parent, SWT.SINGLE | SWT.V_SCROLL | SWT.BORDER | SWT.FULL_SELECTION);
		treeViewer.getTree().setLinesVisible(true);
		treeViewer.getTree().setHeaderVisible(true);
		treeViewer.getTree().setLayoutData(layoutData);

		TreeViewerFocusCellManager focusCellManager = new TreeViewerFocusCellManager(treeViewer, new FocusCellOwnerDrawHighlighter(treeViewer));
		ColumnViewerEditorActivationStrategy actSupport = new ColumnViewerEditorActivationStrategy(treeViewer) {

			@Override
			protected boolean isEditorActivationEvent(ColumnViewerEditorActivationEvent event) {
				return event.eventType == ColumnViewerEditorActivationEvent.TRAVERSAL || event.eventType == ColumnViewerEditorActivationEvent.MOUSE_CLICK_SELECTION
						|| (event.eventType == ColumnViewerEditorActivationEvent.KEY_PRESSED && event.keyCode == SWT.CR) || event.eventType == ColumnViewerEditorActivationEvent.PROGRAMMATIC;
			}
		};

		TreeViewerEditor.create(treeViewer, focusCellManager, actSupport, ColumnViewerEditor.TABBING_HORIZONTAL | ColumnViewerEditor.TABBING_MOVE_TO_ROW_NEIGHBOR | ColumnViewerEditor.TABBING_VERTICAL
				| ColumnViewerEditor.KEYBOARD_ACTIVATION);

		return treeViewer;
	}

	
	@Override
	public void refresh() {
		super.refresh();
		propertiesViewer.setInput(((Calls)getEObject()).getProperties());	
	}

	
	@Override
	protected void setSectionData(Composite composite) {
		super.setSectionData(composite);
		FormData data = new FormData();
		data.left = new FormAttachment(0, 0);
		data.right = new FormAttachment(100, 0);
		data.top = new FormAttachment(0, ITabbedPropertyConstants.VSPACE);
		groupProperties.setLayoutData(data);
	}
	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractListPropertySection#getLabelProvider()
     * @generated
     */
    @SuppressWarnings("unchecked")
	protected ILabelProvider getLabelProvider() {
        if (getFeature() instanceof EReference) {
            List f = new ArrayList();
            f.add(new CallchainItemProviderAdapterFactory());
            f.addAll(AbstractTabbedPropertySheetPage
                    .getPrincipalAdapterFactories());
            return new TabbedPropertiesLabelProvider(
                    new ComposedAdapterFactory(f));
        }
        return null;
    }


}