/**
 * 
 */
package de.urszeidler.eclipse.callchain.ui;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.handlers.HandlerUtil;

import de.urszeidler.eclipse.callchain.Artifact;

/**
 * @author urs
 * 
 */
public class OpenResource extends AbstractHandler implements IHandler {

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.
	 * ExecutionEvent)
	 */
	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		EObject eobject = getEObject(HandlerUtil.getCurrentSelection(event));
		IWorkbenchSite activeSite = HandlerUtil.getActiveSite(event);
		IWorkbenchPage page = activeSite.getPage();
		if (eobject instanceof Artifact) {
			Artifact af = (Artifact) eobject;
			openArtifact(af, page);
		}// end of if (selection instanceof Artifact)
		return null;
	}
	
	private void openArtifact(Artifact af, IWorkbenchPage page) {
		if (af.getUri() == null)
			return;

		Path path = new Path(af.getUri());
		IFile file = ResourcesPlugin.getWorkspace().getRoot().getFile(path);
		try {
			org.eclipse.ui.ide.IDE.openEditor(page, file);
		} catch (PartInitException e) {
		}

	}

	protected EObject getEObject(ISelection sel) {
		if (sel instanceof StructuredSelection) {
			StructuredSelection ss = (StructuredSelection) sel;
			if (ss.getFirstElement() instanceof EObject) {
				EObject eo = (EObject) ss.getFirstElement();
				return eo;
			} else if (ss.getFirstElement() instanceof GraphicalEditPart) {
				Object model = ((GraphicalEditPart) ss.getFirstElement())
						.getModel();
				if (model instanceof View) {
					View view = (View) model;
					return view.getElement();
				}
			}
		}// end of if (sel instanceof StructuredSelection)
		return null;
	}

}
