/**
 * 
 */
package de.urszeidler.eclipse.callchain.ui.emf.actions;

import java.io.InputStream;
import java.io.StringBufferInputStream;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IWorkbenchPart;

import de.urszeidler.eclipse.callchain.AtlRes;

/**
 * @author urs
 *
 */
public class GenerateATLFile extends SelectionAction {

	public GenerateATLFile(IWorkbenchPart part) {
		super(part);
		initAction();
		
	}

	public GenerateATLFile(String text, ImageDescriptor image) {
		super(text, image);
		initAction();
	}

	public GenerateATLFile(String text, int style) {
		super(text, style);
		initAction();
	}

	public GenerateATLFile(String text) {
		super(text);
		initAction();
	}

	public GenerateATLFile() {
		this("generate ATL file");
	}

	/* (non-Javadoc)
	 * @see de.urszeidler.eclipse.tcdiasupport.action.SelectionAction#initAction()
	 */
	@Override
	protected void initAction() {
        setId("executeGenerateATLFile.id");
        setActionDefinitionId("executeGenerateATLFile");

	}
    public boolean isEnabled() {
        return selection != null && (selection instanceof AtlRes);
    }

    @Override
    public void run() {
    	if (selection instanceof AtlRes) {
    		
    		AtlRes art = (AtlRes) selection;
			
    		String uri = art.getUri();
			if(uri!=null){
				Path path = new Path(uri);
				IFile file = ResourcesPlugin.getWorkspace().getRoot().getFile(path);
				//file.c
				IProgressMonitor monitor = null;
				StringBuilder sb=new StringBuilder();
				
				InputStream source = new StringBufferInputStream(sb.toString());
				try {
					file.create(source, false, monitor);
				} catch (CoreException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
				
		}
    }
}
