/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainSwitch.java,v 1.2 2008/04/13 20:29:20 urs Exp $
 */
package de.urszeidler.eclipse.callchain.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;

import de.urszeidler.eclipse.callchain.AndPredicate;
import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.BooleanPredicate;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.CompositePredicate;
import de.urszeidler.eclipse.callchain.Documentable;
import de.urszeidler.eclipse.callchain.Eavaluateable;
import de.urszeidler.eclipse.callchain.ExternalCallable;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.MM;
import de.urszeidler.eclipse.callchain.MMAlias;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.ModelAlias;
import de.urszeidler.eclipse.callchain.NamedSwitch;
import de.urszeidler.eclipse.callchain.NotPredicate;
import de.urszeidler.eclipse.callchain.OrPredicate;
import de.urszeidler.eclipse.callchain.Predicate;
import de.urszeidler.eclipse.callchain.PredicateSwitch;
import de.urszeidler.eclipse.callchain.Property;
import de.urszeidler.eclipse.callchain.PropertyExist;
import de.urszeidler.eclipse.callchain.PropertyHasValue;
import de.urszeidler.eclipse.callchain.PropertyMapper;
import de.urszeidler.eclipse.callchain.PropertyPredicate;
import de.urszeidler.eclipse.callchain.PropertyValueSwitch;
import de.urszeidler.eclipse.callchain.ResourceExistPredicate;
import de.urszeidler.eclipse.callchain.ResourcePredicate;
import de.urszeidler.eclipse.callchain.StopCall;
import de.urszeidler.eclipse.callchain.Transition;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see de.urszeidler.eclipse.callchain.CallchainPackage
 * @generated
 */
public class CallchainSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static CallchainPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallchainSwitch() {
		if (modelPackage == null) {
			modelPackage = CallchainPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case CallchainPackage.MODEL: {
				Model model = (Model)theEObject;
				T result = caseModel(model);
				if (result == null) result = caseArtifact(model);
				if (result == null) result = caseDocumentable(model);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.ATL_RES: {
				AtlRes atlRes = (AtlRes)theEObject;
				T result = caseAtlRes(atlRes);
				if (result == null) result = caseArtifact(atlRes);
				if (result == null) result = caseDocumentable(atlRes);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.CALL: {
				Call call = (Call)theEObject;
				T result = caseCall(call);
				if (result == null) result = caseDocumentable(call);
				if (result == null) result = caseCallable(call);
				if (result == null) result = caseEavaluateable(call);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.MM: {
				MM mm = (MM)theEObject;
				T result = caseMM(mm);
				if (result == null) result = caseArtifact(mm);
				if (result == null) result = caseDocumentable(mm);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.CALLS: {
				Calls calls = (Calls)theEObject;
				T result = caseCalls(calls);
				if (result == null) result = caseDocumentable(calls);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.ATL_LIBARY: {
				AtlLibary atlLibary = (AtlLibary)theEObject;
				T result = caseAtlLibary(atlLibary);
				if (result == null) result = caseArtifact(atlLibary);
				if (result == null) result = caseDocumentable(atlLibary);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.MODEL_ALIAS: {
				ModelAlias modelAlias = (ModelAlias)theEObject;
				T result = caseModelAlias(modelAlias);
				if (result == null) result = caseModel(modelAlias);
				if (result == null) result = caseArtifact(modelAlias);
				if (result == null) result = caseDocumentable(modelAlias);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.GENERATOR: {
				Generator generator = (Generator)theEObject;
				T result = caseGenerator(generator);
				if (result == null) result = caseDocumentable(generator);
				if (result == null) result = caseCallable(generator);
				if (result == null) result = caseEavaluateable(generator);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.ARTIFACT: {
				Artifact artifact = (Artifact)theEObject;
				T result = caseArtifact(artifact);
				if (result == null) result = caseDocumentable(artifact);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.MM_ALIAS: {
				MMAlias mmAlias = (MMAlias)theEObject;
				T result = caseMMAlias(mmAlias);
				if (result == null) result = caseMM(mmAlias);
				if (result == null) result = caseArtifact(mmAlias);
				if (result == null) result = caseDocumentable(mmAlias);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.DOCUMENTABLE: {
				Documentable documentable = (Documentable)theEObject;
				T result = caseDocumentable(documentable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.COMMENT: {
				Comment comment = (Comment)theEObject;
				T result = caseComment(comment);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.CALLABLE: {
				Callable callable = (Callable)theEObject;
				T result = caseCallable(callable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.GENERIC_GENERATOR: {
				Generic_Generator generic_Generator = (Generic_Generator)theEObject;
				T result = caseGeneric_Generator(generic_Generator);
				if (result == null) result = caseGenerator(generic_Generator);
				if (result == null) result = caseDocumentable(generic_Generator);
				if (result == null) result = caseCallable(generic_Generator);
				if (result == null) result = caseEavaluateable(generic_Generator);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.PROPERTY: {
				Property property = (Property)theEObject;
				T result = caseProperty(property);
				if (result == null) result = caseDocumentable(property);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.SWITCH: {
				de.urszeidler.eclipse.callchain.Switch switch_ = (de.urszeidler.eclipse.callchain.Switch)theEObject;
				T result = caseSwitch(switch_);
				if (result == null) result = caseCallable(switch_);
				if (result == null) result = caseDocumentable(switch_);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.PREDICATE_SWITCH: {
				PredicateSwitch predicateSwitch = (PredicateSwitch)theEObject;
				T result = casePredicateSwitch(predicateSwitch);
				if (result == null) result = caseSwitch(predicateSwitch);
				if (result == null) result = caseCallable(predicateSwitch);
				if (result == null) result = caseDocumentable(predicateSwitch);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.NAMED_SWITCH: {
				NamedSwitch namedSwitch = (NamedSwitch)theEObject;
				T result = caseNamedSwitch(namedSwitch);
				if (result == null) result = caseSwitch(namedSwitch);
				if (result == null) result = caseCallable(namedSwitch);
				if (result == null) result = caseDocumentable(namedSwitch);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.TRANSITION: {
				Transition transition = (Transition)theEObject;
				T result = caseTransition(transition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.PREDICATE: {
				Predicate predicate = (Predicate)theEObject;
				T result = casePredicate(predicate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.PROPERTY_PREDICATE: {
				PropertyPredicate propertyPredicate = (PropertyPredicate)theEObject;
				T result = casePropertyPredicate(propertyPredicate);
				if (result == null) result = casePredicate(propertyPredicate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.PROPERTY_HAS_VALUE: {
				PropertyHasValue propertyHasValue = (PropertyHasValue)theEObject;
				T result = casePropertyHasValue(propertyHasValue);
				if (result == null) result = casePropertyPredicate(propertyHasValue);
				if (result == null) result = casePredicate(propertyHasValue);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.PROPERTY_EXIST: {
				PropertyExist propertyExist = (PropertyExist)theEObject;
				T result = casePropertyExist(propertyExist);
				if (result == null) result = casePropertyPredicate(propertyExist);
				if (result == null) result = casePredicate(propertyExist);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.RESOURCE_PREDICATE: {
				ResourcePredicate resourcePredicate = (ResourcePredicate)theEObject;
				T result = caseResourcePredicate(resourcePredicate);
				if (result == null) result = casePredicate(resourcePredicate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.RESOURCE_EXIST_PREDICATE: {
				ResourceExistPredicate resourceExistPredicate = (ResourceExistPredicate)theEObject;
				T result = caseResourceExistPredicate(resourceExistPredicate);
				if (result == null) result = caseResourcePredicate(resourceExistPredicate);
				if (result == null) result = casePredicate(resourceExistPredicate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.COMPOSITE_PREDICATE: {
				CompositePredicate compositePredicate = (CompositePredicate)theEObject;
				T result = caseCompositePredicate(compositePredicate);
				if (result == null) result = casePredicate(compositePredicate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.AND_PREDICATE: {
				AndPredicate andPredicate = (AndPredicate)theEObject;
				T result = caseAndPredicate(andPredicate);
				if (result == null) result = caseCompositePredicate(andPredicate);
				if (result == null) result = casePredicate(andPredicate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.OR_PREDICATE: {
				OrPredicate orPredicate = (OrPredicate)theEObject;
				T result = caseOrPredicate(orPredicate);
				if (result == null) result = caseCompositePredicate(orPredicate);
				if (result == null) result = casePredicate(orPredicate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.NOT_PREDICATE: {
				NotPredicate notPredicate = (NotPredicate)theEObject;
				T result = caseNotPredicate(notPredicate);
				if (result == null) result = casePredicate(notPredicate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.PROPERTY_VALUE_SWITCH: {
				PropertyValueSwitch propertyValueSwitch = (PropertyValueSwitch)theEObject;
				T result = casePropertyValueSwitch(propertyValueSwitch);
				if (result == null) result = caseNamedSwitch(propertyValueSwitch);
				if (result == null) result = caseSwitch(propertyValueSwitch);
				if (result == null) result = caseCallable(propertyValueSwitch);
				if (result == null) result = caseDocumentable(propertyValueSwitch);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.EXTERNAL_CALLABLE: {
				ExternalCallable externalCallable = (ExternalCallable)theEObject;
				T result = caseExternalCallable(externalCallable);
				if (result == null) result = caseCallable(externalCallable);
				if (result == null) result = caseDocumentable(externalCallable);
				if (result == null) result = caseEavaluateable(externalCallable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.STOP_CALL: {
				StopCall stopCall = (StopCall)theEObject;
				T result = caseStopCall(stopCall);
				if (result == null) result = caseCallable(stopCall);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.BOOLEAN_PREDICATE: {
				BooleanPredicate booleanPredicate = (BooleanPredicate)theEObject;
				T result = caseBooleanPredicate(booleanPredicate);
				if (result == null) result = casePredicate(booleanPredicate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.EAVALUATEABLE: {
				Eavaluateable eavaluateable = (Eavaluateable)theEObject;
				T result = caseEavaluateable(eavaluateable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CallchainPackage.PROPERTY_MAPPER: {
				PropertyMapper propertyMapper = (PropertyMapper)theEObject;
				T result = casePropertyMapper(propertyMapper);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Model</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Model</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseModel(Model object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Atl Res</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Atl Res</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAtlRes(AtlRes object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Call</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Call</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCall(Call object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MM</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MM</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMM(MM object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Calls</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Calls</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCalls(Calls object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Atl Libary</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Atl Libary</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAtlLibary(AtlLibary object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Model Alias</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Model Alias</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseModelAlias(ModelAlias object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Generator</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Generator</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGenerator(Generator object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Artifact</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Artifact</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseArtifact(Artifact object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MM Alias</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MM Alias</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMMAlias(MMAlias object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Documentable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Documentable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDocumentable(Documentable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Comment</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Comment</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseComment(Comment object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Callable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Callable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCallable(Callable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Generic Generator</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Generic Generator</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGeneric_Generator(Generic_Generator object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseProperty(Property object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Switch</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Switch</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSwitch(de.urszeidler.eclipse.callchain.Switch object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Predicate Switch</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Predicate Switch</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePredicateSwitch(PredicateSwitch object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Named Switch</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Named Switch</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNamedSwitch(NamedSwitch object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Transition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Transition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTransition(Transition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Predicate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePredicate(Predicate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Predicate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyPredicate(PropertyPredicate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Has Value</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Has Value</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyHasValue(PropertyHasValue object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Exist</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Exist</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyExist(PropertyExist object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Resource Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Resource Predicate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseResourcePredicate(ResourcePredicate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Resource Exist Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Resource Exist Predicate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseResourceExistPredicate(ResourceExistPredicate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Composite Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Composite Predicate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCompositePredicate(CompositePredicate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>And Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>And Predicate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAndPredicate(AndPredicate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Or Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Or Predicate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOrPredicate(OrPredicate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Not Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Not Predicate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNotPredicate(NotPredicate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Value Switch</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Value Switch</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyValueSwitch(PropertyValueSwitch object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>External Callable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>External Callable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseExternalCallable(ExternalCallable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Stop Call</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Stop Call</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStopCall(StopCall object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Boolean Predicate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Boolean Predicate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBooleanPredicate(BooleanPredicate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Eavaluateable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Eavaluateable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEavaluateable(Eavaluateable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Mapper</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Mapper</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyMapper(PropertyMapper object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //CallchainSwitch
