/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainValidator.java,v 1.2 2008/04/13 20:29:20 urs Exp $
 */
package de.urszeidler.eclipse.callchain.util;

import de.urszeidler.eclipse.callchain.*;
import java.io.File;
import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.eclipse.emf.ecore.util.EObjectValidator;

import de.urszeidler.eclipse.callchain.AndPredicate;
import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.CompositePredicate;
import de.urszeidler.eclipse.callchain.Documentable;
import de.urszeidler.eclipse.callchain.ExternalCallable;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.MM;
import de.urszeidler.eclipse.callchain.MMAlias;
import de.urszeidler.eclipse.callchain.MMhandler;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.ModelAlias;
import de.urszeidler.eclipse.callchain.NamedSwitch;
import de.urszeidler.eclipse.callchain.NotPredicate;
import de.urszeidler.eclipse.callchain.OrPredicate;
import de.urszeidler.eclipse.callchain.Predicate;
import de.urszeidler.eclipse.callchain.PredicateSwitch;
import de.urszeidler.eclipse.callchain.Property;
import de.urszeidler.eclipse.callchain.PropertyExist;
import de.urszeidler.eclipse.callchain.PropertyHasValue;
import de.urszeidler.eclipse.callchain.PropertyPredicate;
import de.urszeidler.eclipse.callchain.PropertyValueSwitch;
import de.urszeidler.eclipse.callchain.ResourceExistPredicate;
import de.urszeidler.eclipse.callchain.ResourcePredicate;
import de.urszeidler.eclipse.callchain.Switch;
import de.urszeidler.eclipse.callchain.Transition;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorDescriptor;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutableValidator;
import de.urszeidler.eclipse.callchain.generatorservice.Generatorservice;

/**
 * <!-- begin-user-doc --> The <b>Validator</b> for the model. <!-- end-user-doc
 * -->
 * 
 * @see de.urszeidler.eclipse.callchain.CallchainPackage
 * @generated
 */
@SuppressWarnings("unchecked")
public class CallchainValidator extends EObjectValidator {
	public static List EXTENSIONS = new ArrayList();
	static {
		EXTENSIONS.add("atl");
		EXTENSIONS.add("acg");
	}

	/**
	 * The cached model package
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public static final CallchainValidator INSTANCE = new CallchainValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "de.urszeidler.eclipse.callchain";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public CallchainValidator() {
		super();
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
	  return CallchainPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
			case CallchainPackage.MODEL:
				return validateModel((Model)value, diagnostics, context);
			case CallchainPackage.ATL_RES:
				return validateAtlRes((AtlRes)value, diagnostics, context);
			case CallchainPackage.CALL:
				return validateCall((Call)value, diagnostics, context);
			case CallchainPackage.MM:
				return validateMM((MM)value, diagnostics, context);
			case CallchainPackage.CALLS:
				return validateCalls((Calls)value, diagnostics, context);
			case CallchainPackage.ATL_LIBARY:
				return validateAtlLibary((AtlLibary)value, diagnostics, context);
			case CallchainPackage.MODEL_ALIAS:
				return validateModelAlias((ModelAlias)value, diagnostics, context);
			case CallchainPackage.GENERATOR:
				return validateGenerator((Generator)value, diagnostics, context);
			case CallchainPackage.ARTIFACT:
				return validateArtifact((Artifact)value, diagnostics, context);
			case CallchainPackage.MM_ALIAS:
				return validateMMAlias((MMAlias)value, diagnostics, context);
			case CallchainPackage.DOCUMENTABLE:
				return validateDocumentable((Documentable)value, diagnostics, context);
			case CallchainPackage.COMMENT:
				return validateComment((Comment)value, diagnostics, context);
			case CallchainPackage.CALLABLE:
				return validateCallable((Callable)value, diagnostics, context);
			case CallchainPackage.GENERIC_GENERATOR:
				return validateGeneric_Generator((Generic_Generator)value, diagnostics, context);
			case CallchainPackage.PROPERTY:
				return validateProperty((Property)value, diagnostics, context);
			case CallchainPackage.SWITCH:
				return validateSwitch((Switch)value, diagnostics, context);
			case CallchainPackage.PREDICATE_SWITCH:
				return validatePredicateSwitch((PredicateSwitch)value, diagnostics, context);
			case CallchainPackage.NAMED_SWITCH:
				return validateNamedSwitch((NamedSwitch)value, diagnostics, context);
			case CallchainPackage.TRANSITION:
				return validateTransition((Transition)value, diagnostics, context);
			case CallchainPackage.PREDICATE:
				return validatePredicate((Predicate)value, diagnostics, context);
			case CallchainPackage.PROPERTY_PREDICATE:
				return validatePropertyPredicate((PropertyPredicate)value, diagnostics, context);
			case CallchainPackage.PROPERTY_HAS_VALUE:
				return validatePropertyHasValue((PropertyHasValue)value, diagnostics, context);
			case CallchainPackage.PROPERTY_EXIST:
				return validatePropertyExist((PropertyExist)value, diagnostics, context);
			case CallchainPackage.RESOURCE_PREDICATE:
				return validateResourcePredicate((ResourcePredicate)value, diagnostics, context);
			case CallchainPackage.RESOURCE_EXIST_PREDICATE:
				return validateResourceExistPredicate((ResourceExistPredicate)value, diagnostics, context);
			case CallchainPackage.COMPOSITE_PREDICATE:
				return validateCompositePredicate((CompositePredicate)value, diagnostics, context);
			case CallchainPackage.AND_PREDICATE:
				return validateAndPredicate((AndPredicate)value, diagnostics, context);
			case CallchainPackage.OR_PREDICATE:
				return validateOrPredicate((OrPredicate)value, diagnostics, context);
			case CallchainPackage.NOT_PREDICATE:
				return validateNotPredicate((NotPredicate)value, diagnostics, context);
			case CallchainPackage.PROPERTY_VALUE_SWITCH:
				return validatePropertyValueSwitch((PropertyValueSwitch)value, diagnostics, context);
			case CallchainPackage.EXTERNAL_CALLABLE:
				return validateExternalCallable((ExternalCallable)value, diagnostics, context);
			case CallchainPackage.STOP_CALL:
				return validateStopCall((StopCall)value, diagnostics, context);
			case CallchainPackage.BOOLEAN_PREDICATE:
				return validateBooleanPredicate((BooleanPredicate)value, diagnostics, context);
			case CallchainPackage.EAVALUATEABLE:
				return validateEavaluateable((Eavaluateable)value, diagnostics, context);
			case CallchainPackage.PROPERTY_MAPPER:
				return validatePropertyMapper((PropertyMapper)value, diagnostics, context);
			case CallchainPackage.MMHANDLER:
				return validateMMhandler((MMhandler)value, diagnostics, context);
			default:
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateModel(Model model, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(model, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(model, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(model, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(model, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(model, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(model, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(model, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(model, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(model, diagnostics, context);
		if (result || diagnostics != null) result &= validateModel_isUriValid(model, diagnostics, context);
		if (result || diagnostics != null) result &= validateModel_isNameSet(model, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isUriValid constraint of '<em>Model</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModel_isUriValid(Model model,
			DiagnosticChain diagnostics, Map context) {
		if (!fileNameToURLValid(model.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isUriValid",
										getObjectLabel(model, context) }),
						new Object[] { model }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the isNameSet constraint of '<em>Model</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModel_isNameSet(Model model,
			DiagnosticChain diagnostics, Map context) {
		if (model.getName() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isNameSet",
										getObjectLabel(model, context) }),
						new Object[] { model }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAtlRes(AtlRes atlRes, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(atlRes, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(atlRes, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(atlRes, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(atlRes, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(atlRes, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(atlRes, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(atlRes, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(atlRes, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(atlRes, diagnostics, context);
		if (result || diagnostics != null) result &= validateAtlRes_isUriValid(atlRes, diagnostics, context);
		if (result || diagnostics != null) result &= validateAtlRes_isNameSet(atlRes, diagnostics, context);
		if (result || diagnostics != null) result &= validateAtlRes_fileExist(atlRes, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isUriValid constraint of '<em>Atl Res</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlRes_isUriValid(AtlRes atlRes,
			DiagnosticChain diagnostics, Map context) {
		if (!isASMFileValid(atlRes.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isUriValid",
										getObjectLabel(atlRes, context) }),
						new Object[] { atlRes }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the isNameSet constraint of '<em>Atl Res</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlRes_isNameSet(AtlRes atlRes,
			DiagnosticChain diagnostics, Map context) {
		if (atlRes.getName() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isNameSet",
										getObjectLabel(atlRes, context) }),
						new Object[] { atlRes }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the fileExist constraint of '<em>Atl Res</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlRes_fileExist(AtlRes atlRes,
			DiagnosticChain diagnostics, Map context) {
		if (!atlFileExist(atlRes.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "fileExist",
										getObjectLabel(atlRes, context) }),
						new Object[] { atlRes }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCall(Call call, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(call, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(call, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(call, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(call, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(call, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(call, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(call, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(call, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(call, diagnostics, context);
		if (result || diagnostics != null) result &= validateCall_noCircularDefinition(call, diagnostics, context);
		if (result || diagnostics != null) result &= validateCall_usesEnviorementLib(call, diagnostics, context);
		if (result || diagnostics != null) result &= validateCall_usesEviorementSuperimposed(call, diagnostics, context);
		return result;
	}

	/**
	 * Validates the noCircularDefinition constraint of '<em>Call</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateCall_noCircularDefinition(Call call,
			DiagnosticChain diagnostics, Map context) {
		boolean notFound = true;
		HashSet<Object> set = new HashSet<Object>();
		set.add(call);
		Callable newcall = call.getNext();
		while (newcall != null && notFound) {
			notFound = set.add(newcall);
			newcall = newcall.getNext();
		}

		if (!notFound) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "noCircularDefinition",
										getObjectLabel(call, context) }),
						new Object[] { call }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the usesEnviorementLib constraint of '<em>Call</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateCall_usesEnviorementLib(Call call,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		// TODO implement the constraint
		// -> specify the condition that violates the constraint
		// -> verify the diagnostic details, including severity, code, and message
		// Ensure that you remove @generated or mark it @generated NOT
		if (false) {
			if (diagnostics != null) {
				diagnostics.add
					(createDiagnostic
						(Diagnostic.ERROR,
						 DIAGNOSTIC_SOURCE,
						 0,
						 "_UI_GenericConstraint_diagnostic",
						 new Object[] { "usesEnviorementLib", getObjectLabel(call, context) },
						 new Object[] { call },
						 context));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the usesEviorementSuperimposed constraint of '<em>Call</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCall_usesEviorementSuperimposed(Call call,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		// TODO implement the constraint
		// -> specify the condition that violates the constraint
		// -> verify the diagnostic details, including severity, code, and message
		// Ensure that you remove @generated or mark it @generated NOT
		if (false) {
			if (diagnostics != null) {
				diagnostics.add
					(createDiagnostic
						(Diagnostic.ERROR,
						 DIAGNOSTIC_SOURCE,
						 0,
						 "_UI_GenericConstraint_diagnostic",
						 new Object[] { "usesEviorementSuperimposed", getObjectLabel(call, context) },
						 new Object[] { call },
						 context));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateMM(MM mm, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(mm, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(mm, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(mm, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(mm, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(mm, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(mm, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(mm, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(mm, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(mm, diagnostics, context);
		if (result || diagnostics != null) result &= validateMM_isUriValid(mm, diagnostics, context);
		if (result || diagnostics != null) result &= validateMM_isNameSet(mm, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isUriValid constraint of '<em>MM</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateMM_isUriValid(MM mm, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		// TODO implement the constraint
		// -> specify the condition that violates the constraint
		// -> verify the diagnostic details, including severity, code, and message
		// Ensure that you remove @generated or mark it @generated NOT
		if (false) {
			if (diagnostics != null) {
				diagnostics.add
					(createDiagnostic
						(Diagnostic.ERROR,
						 DIAGNOSTIC_SOURCE,
						 0,
						 "_UI_GenericConstraint_diagnostic",
						 new Object[] { "isUriValid", getObjectLabel(mm, context) },
						 new Object[] { mm },
						 context));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the isNameSet constraint of '<em>MM</em>'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateMM_isNameSet(MM mm, DiagnosticChain diagnostics,
			Map context) {
		if (mm.getName() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isNameSet",
										getObjectLabel(mm, context) }),
						new Object[] { mm }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCalls(Calls calls, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(calls, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAtlLibary(AtlLibary atlLibary,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(atlLibary, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validateAtlLibary_isUriValid(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validateAtlLibary_isNameSet(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validateAtlLibary_isASMfile(atlLibary, diagnostics, context);
		if (result || diagnostics != null) result &= validateAtlLibary_fileExist(atlLibary, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isUriValid constraint of '<em>Atl Libary</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlLibary_isUriValid(AtlLibary atlLibary,
			DiagnosticChain diagnostics, Map context) {
		if (!fileNameToURLValid(atlLibary.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isUriValid",
										getObjectLabel(atlLibary, context) }),
						new Object[] { atlLibary }));
			}
			return false;
		}
		return true;// validateAtlRes_isUriValid(atlLibary, diagnostics,
					// context);
	}

	/**
	 * Validates the isNameSet constraint of '<em>Atl Libary</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlLibary_isNameSet(AtlLibary atlLibary,
			DiagnosticChain diagnostics, Map context) {
		if (atlLibary.getName() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isNameSet",
										getObjectLabel(atlLibary, context) }),
						new Object[] { atlLibary }));
			}
			return false;
		}
		return true;// validateAtlRes_isNameSet(atlLibary, diagnostics,
					// context);
	}

	/**
	 * Validates the isASMfile constraint of '<em>Atl Libary</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public boolean validateAtlLibary_isASMfile(AtlLibary atlLibary,
			DiagnosticChain diagnostics, Map context) {
		if (!asmFileExist(atlLibary.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isASMfile",
										getObjectLabel(atlLibary, context) }),
						new Object[] { atlLibary }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the fileExist constraint of '<em>Atl Libary</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlLibary_fileExist(AtlLibary atlLibary,
			DiagnosticChain diagnostics, Map context) {
		if (!fileExist(atlLibary.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "fileExist",
										getObjectLabel(atlLibary, context) }),
						new Object[] { atlLibary }));
			}
			return false;
		}
		return true;// validateAtlRes_fileExist(atlLibary, diagnostics,
					// context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModelAlias(ModelAlias modelAlias,
			DiagnosticChain diagnostics, Map context) {
		boolean result = true;// validate_EveryMultiplicityConforms(modelAlias,
		// diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(modelAlias, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(modelAlias,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(modelAlias, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validateModelAlias_isMMset(modelAlias, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validateModelAlias_isUriset(modelAlias, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validateModelAlias_isAliasset(modelAlias, diagnostics,
					context);
		return result;
	}

	/**
	 * Validates the isMMset constraint of '<em>Model Alias</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModelAlias_isMMset(ModelAlias modelAlias,
			DiagnosticChain diagnostics, Map context) {
		if (modelAlias.getDecoratedmodel().getMm() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isMMset",
										getObjectLabel(modelAlias, context) }),
						new Object[] { modelAlias }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the isUriset constraint of '<em>Model Alias</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModelAlias_isUriset(ModelAlias modelAlias,
			DiagnosticChain diagnostics, Map context) {
		if (modelAlias.getDecoratedmodel().getMm().getUri() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isUriset",
										getObjectLabel(modelAlias, context) }),
						new Object[] { modelAlias }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the isAliasset constraint of '<em>Model Alias</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModelAlias_isAliasset(ModelAlias modelAlias,
			DiagnosticChain diagnostics, Map context) {
		if (modelAlias.getAliasName() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE.getString(
								"_UI_GenericConstraint_diagnostic",
								new Object[] { "isAliasset",
										getObjectLabel(modelAlias, context) }),
						new Object[] { modelAlias }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateGenerator(Generator generator,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(generator, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateArtifact(Artifact artifact,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(artifact, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateMMAlias(MMAlias mmAlias,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(mmAlias, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(mmAlias, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(mmAlias, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(mmAlias, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(mmAlias, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(mmAlias, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(mmAlias, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(mmAlias, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(mmAlias, diagnostics, context);
		if (result || diagnostics != null) result &= validateMM_isUriValid(mmAlias, diagnostics, context);
		if (result || diagnostics != null) result &= validateMM_isNameSet(mmAlias, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDocumentable(Documentable documentable,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(documentable, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateComment(Comment comment,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(comment, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCallable(Callable callable,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(callable, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateGeneric_Generator(
			Generic_Generator generic_Generator, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(generic_Generator, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(generic_Generator, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(generic_Generator, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(generic_Generator, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(generic_Generator, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(generic_Generator, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(generic_Generator, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(generic_Generator, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(generic_Generator, diagnostics, context);
		if (result || diagnostics != null) result &= validateGeneric_Generator_isConfigValid(generic_Generator, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isConfigValid constraint of '<em>Generic Generator</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateGeneric_Generator_isConfigValid(
			Generic_Generator generic_Generator, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		String valid = isGeneratorConfigValid(generic_Generator);

		if (valid.length() != 0) {
			if (diagnostics != null) {
				diagnostics.add(createDiagnostic(
						Diagnostic.ERROR,
						DIAGNOSTIC_SOURCE,
						0,
						"_UI_GenericConstraint_diagnostic",
						new Object[] { valid,
								getObjectLabel(generic_Generator, context) },
						new Object[] { generic_Generator }, context));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateProperty(Property property,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(property, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateSwitch(Switch switch_, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(switch_, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePredicateSwitch(PredicateSwitch predicateSwitch,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(predicateSwitch, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateNamedSwitch(NamedSwitch namedSwitch,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(namedSwitch, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateTransition(Transition transition,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(transition, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePredicate(Predicate predicate,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(predicate, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePropertyPredicate(
			PropertyPredicate propertyPredicate, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(propertyPredicate, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePropertyHasValue(PropertyHasValue propertyHasValue,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(propertyHasValue, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePropertyExist(PropertyExist propertyExist,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(propertyExist, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateResourcePredicate(
			ResourcePredicate resourcePredicate, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(resourcePredicate, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateResourceExistPredicate(
			ResourceExistPredicate resourceExistPredicate,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(resourceExistPredicate, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCompositePredicate(
			CompositePredicate compositePredicate, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(compositePredicate, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAndPredicate(AndPredicate andPredicate,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(andPredicate, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateOrPredicate(OrPredicate orPredicate,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(orPredicate, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateNotPredicate(NotPredicate notPredicate,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(notPredicate, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePropertyValueSwitch(
			PropertyValueSwitch propertyValueSwitch,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(propertyValueSwitch, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCallable(ExternalCallable externalCallable,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(externalCallable, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateStopCall(StopCall stopCall, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(stopCall, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBooleanPredicate(BooleanPredicate booleanPredicate, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(booleanPredicate, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateEavaluateable(Eavaluateable eavaluateable, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(eavaluateable, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validatePropertyMapper(PropertyMapper propertyMapper, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(propertyMapper, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateMMhandler(MMhandler mMhandler,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return true;
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

	private String isGeneratorConfigValid(Generic_Generator generic_Generator) {
		GeneratorDescriptor descriptor = Generatorservice.getDefault()
				.getGenerator(generic_Generator.getId());
		if (descriptor == null)
			return "";
		try {
			GeneratorExecutable executable = descriptor.createExecutable();
			if (executable instanceof GeneratorExecutableValidator) {
				GeneratorExecutableValidator validator = (GeneratorExecutableValidator) executable;
				String validate = validator.validate(generic_Generator);
				return validate;
			}
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return "";
	}

	private static boolean fileNameToURLValid(String filePath) {
		if (filePath == null)
			return false;

		try {
			if (filePath.startsWith("uri:")) {
				return true;
			}

			if (filePath.startsWith("ext:")) {
				File f = new File(filePath.substring(4));
				f.toURL();
				return true;
			}

			if(CallsUtil.containsProperty(filePath))
				return true;

			IWorkspace wks = ResourcesPlugin.getWorkspace();
			IWorkspaceRoot wksroot = wks.getRoot();

			IFile currentLib = wksroot.getFile(new Path(filePath));
			if (currentLib == null)
				return false;
			if (currentLib.getLocation() == null)
				return false;

			currentLib.getLocation().toFile().toURL();
			return true;
		} catch (MalformedURLException e) {
			return false;
		} catch (IllegalArgumentException e) {
			return false;
		}

	}

	/**
	 * From the path of an ATL File, this method returns the ASM File
	 * corresponding to the ATL File
	 * 
	 * @param atlFilePath
	 *            name of the ATL File
	 * @return ASM File corresponding to the ATL File
	 */
	private static boolean isASMFileValid(String atlFilePath) {
		if (atlFilePath == null)
			return false;
		if(CallsUtil.containsProperty(atlFilePath))
			return true;

		IFile currentAtlFile = ResourcesPlugin.getWorkspace().getRoot()
				.getFile(Path.fromOSString(atlFilePath));

		String extension = currentAtlFile.getFileExtension().toLowerCase();
		if (EXTENSIONS.contains(extension)) {
			String currentAsmPath = currentAtlFile
					.getFullPath()
					.toString()
					.substring(
							0,
							currentAtlFile.getFullPath().toString().length()
									- extension.length())
					+ "asm";
			IFile file = ResourcesPlugin.getWorkspace().getRoot()
					.getFile(new Path(currentAsmPath));
			if (file == null)
				return false;
			if (file.getLocation() == null)
				return false;

			// URL asmUrl;
			try {
				// asmUrl =
				file.getLocation().toFile().toURL();
				return true;
			} catch (MalformedURLException e) {
				return false;
			}

		}

		return false;
	}

	/**
	 * 
	 * @param atlFile
	 * @return
	 */
	private String toASMresource(String atlFile) {
		String currentAsmPath = atlFile.substring(0, atlFile.length() - 3)
				+ "asm";
		return currentAsmPath;
	}

	private boolean atlFileExist(String atlFilePath) {
		if (atlFilePath == null)
			return false;
		if (CallsUtil.containsProperty(atlFilePath))
			return true;

		IFile currentAtlFile = ResourcesPlugin.getWorkspace().getRoot()
				.getFile(Path.fromOSString(atlFilePath));

		String extension = currentAtlFile.getFileExtension().toLowerCase();
		if (EXTENSIONS.contains(extension)) {
			String currentAsmPath = currentAtlFile
					.getFullPath()
					.toString()
					.substring(
							0,
							currentAtlFile.getFullPath().toString().length()
									- extension.length())
					+ "asm";
			return asmFileExist(currentAsmPath);
		}

		return false;
	}

	private boolean asmFileExist(String uri) {
		if (uri == null)
			return false;

		uri = toASMresource(uri);
		if (CallsUtil.containsProperty(uri))
			return true;

		try {
			IFile file = ResourcesPlugin.getWorkspace().getRoot()
					.getFile(new Path(uri));
			if (!file.getFileExtension().equals("asm"))
				return false;

			return file.exists();

		} catch (IllegalArgumentException e) {
			return false;
		}
	}

	private boolean fileExist(String filePath) {
		if (filePath == null)
			return false;
		if (CallsUtil.containsProperty(filePath))
			return true;

		try {
			IFile currentAtlFile = ResourcesPlugin.getWorkspace().getRoot()
					.getFile(Path.fromOSString(filePath));
			return currentAtlFile.exists();
		} catch (IllegalArgumentException e) {
			return false;
		}
	}

} // CallchainValidator
