package de.urszeidler.eclipse.callchain.ui.popup.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

import de.urszeidler.eclipse.callchain.ui.wizards.NewCallchainDiagrams_GMFdiagram;
import de.urszeidler.eclipse.callchain.ui.wizards.templates.NewCallchainDiagrams_GMFdiagramFromTemplate;

public class InitaliseGmfTemplateAction implements IObjectActionDelegate {

	private Shell shell;
	private IStructuredSelection selection;

	/**
	 * Constructor for Action1.
	 */
	public InitaliseGmfTemplateAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		shell = targetPart.getSite().getShell();
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		
		NewCallchainDiagrams_GMFdiagram wizard = new NewCallchainDiagrams_GMFdiagramFromTemplate(selection);
		
		WizardDialog dialog = new WizardDialog(shell, wizard);

		dialog.open();
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		if (selection instanceof IStructuredSelection) {
			IStructuredSelection ss = (IStructuredSelection) selection;
			this.selection = ss;
		}
		
	}

}
