/**
 * 
 */
package de.urszeidler.eclipse.callchain.ui.wizards;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.presentation.EcoreActionBarContributor.ExtendedLoadResourceAction.ExtendedLoadResourceDialog;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.viewers.IStructuredSelection;

/**
 * @author urs
 * 
 */
public class Ecore2atlWizardPage extends CallchainSimpleTemplatePage {

	private static final String URI_PREV = "uri:";

	/**
	 * @param pageName
	 * @param selection
	 */
	public Ecore2atlWizardPage(String pageName, IStructuredSelection selection) {
		super(pageName, selection);
	}

	/**
	 * @param pageName
	 * @param selection
	 * @param sourceFileExtension
	 */
	public Ecore2atlWizardPage(String pageName, IStructuredSelection selection,
			String sourceFileExtension) {
		super(pageName, selection, sourceFileExtension);
	}

	@Override
	protected void handleGenmodelChoose() {
		ExtendedLoadResourceDialog extendedLoadResourceDialog = new ExtendedLoadResourceDialog(
				getShell(), (EditingDomain) null);

		int ret = extendedLoadResourceDialog.open();
		if (ret == Dialog.OK)
			setnameFdText(URI_PREV + extendedLoadResourceDialog.getURIText());
	}

	public boolean isPackageUri() {
		if (getNameFd() != null && !getNameFd().isDisposed()) {
			String text = getNameFd().getText();
			if (text.startsWith(URI_PREV))
				return true;
		}
		return false;

	}

	public String getModelUri_Plain() {
		if (getNameFd() != null && !getNameFd().isDisposed()) {
			String text = getNameFd().getText();
			if (text.startsWith(URI_PREV)) {
				return text.substring(URI_PREV.length());

			}

		}

		return getModelName();
	}

	@Override
	public String getModelName() {
		if (getNameFd() != null && !getNameFd().isDisposed()) {
			String text = getNameFd().getText();
			if (text.startsWith(URI_PREV)) {
				URI uri = URI.createURI(text.substring(URI_PREV.length()));
				return uri.lastSegment();

			}

		}

		return super.getModelName();
	}
}
