/**
 * 
 */
package de.urszeidler.eclipse.callchain.ui.wizards.templates;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.gmf.internal.bridge.resolver.StructureResolver;
import org.eclipse.gmf.internal.bridge.wizards.Messages;
import org.eclipse.gmf.internal.bridge.wizards.pages.simple.DefinitionPage;
import org.eclipse.gmf.internal.bridge.wizards.pages.simple.DomainModelSelectionPage;
import org.eclipse.gmf.internal.bridge.wizards.pages.simple.StructureBuilder;
import org.eclipse.gmf.internal.common.ui.ResourceLocationProvider;
import org.eclipse.jface.dialogs.IDialogSettings;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;

import de.urszeidler.eclipse.callchain.ui.wizards.InialiseGMFTemplatePage;
import de.urszeidler.eclipse.callchain.ui.wizards.NewCallchainDiagrams_GMFdiagram;

/**
 * @author urs
 * 
 */
public class NewCallchainDiagrams_GMFdiagramFromTemplate extends
		NewCallchainDiagrams_GMFdiagram {
	private static final String BASE_BUNDEL_ENTRY = "/templates/GMF_from_Ecore_Template";

	private InialiseGMFTemplatePage inialiseGMFTemplatePage;

	private IDialogSettings dialogSettings;


	public NewCallchainDiagrams_GMFdiagramFromTemplate(
			IStructuredSelection selection) {
		super(selection);
	
	}

	@Override
	public void init(IWorkbench workbench, IStructuredSelection sel) {
		super.init(workbench, sel);
		
		//String defaultTemplatePath = dialogSettings.get(DEFAULT_GMF_TEMPLATE_PATH);

	}

	
	@SuppressWarnings("restriction")
	@Override
	public void addPages() {
		inialiseGMFTemplatePage = new InialiseGMFTemplatePage(
				"select basic parameters", this.selection, "ecore");
		addPage(inialiseGMFTemplatePage);
		
		diagPage = inialiseGMFTemplatePage;

		ResourceLocationProvider rloc = new ResourceLocationProvider(selection);
		ResourceSet resourceSet = new ResourceSetImpl();

		domainModelSelectionPage = new DomainModelSelectionPage(
				"DomainModelSelectionPage", rloc, resourceSet); //$NON-NLS-1$
		domainModelSelectionPage
				.setTitle(Messages.SimpleModelWizardDomainModelSelectionPageTitle);
		domainModelSelectionPage
				.setDescription(Messages.SimpleModelWizardDomainModelSelectionPageDesc);
		addPage(domainModelSelectionPage);

		graphicalDefinitionPage = new DefinitionPage("GraphicalDefinitionPage",
				new StructureBuilder(new StructureResolver(), true),
				domainModelSelectionPage);
		graphicalDefinitionPage
				.setTitle(Messages.SimpleModelWizardGraphDefinitionPageTitle);
		graphicalDefinitionPage
				.setDescription(Messages.SimpleModelWizardGraphDefinitionPageDesc);
		addPage(graphicalDefinitionPage);

	}

	/**
	 * @see org.eclipse.jface.wizard.IWizard#canFinish()
	 */
	public boolean canFinish() {
		return inialiseGMFTemplatePage.isPageComplete()
				&& domainModelSelectionPage.isPageComplete();
	}

	@Override
	protected void initVariables(String name, String cname, String pname,
			String modelFile) {
		super.initVariables(name, cname, pname, modelFile);
		
		_variables.put("model_uri", inialiseGMFTemplatePage.getModelUri().getText());
		_variables.put("output_path", inialiseGMFTemplatePage.getOutputPath().getText());
		_variables.put("template_path", inialiseGMFTemplatePage.getTemplatePath().getText());
		
	}
	
	protected IContainer getTargetContainer() {
		return inialiseGMFTemplatePage.getSelectedIContainer();
	}
	
	@Override
	protected String getBaseTemplatePath() {
		return BASE_BUNDEL_ENTRY;
	}
	@Override
	protected String getProjectName() {
		Text outputPath = inialiseGMFTemplatePage.getOutputPath();
		IResource member = ResourcesPlugin.getWorkspace().getRoot().findMember(outputPath.getText());
		IProject project = member.getProject();
		return project.getName();
	}
}
